<?php
/**
 * Created by PhpStorm.
 * User: pavel.rudol
 * Date: 29.3.2016
 * Time: 8:50
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_pokladnikniha',
    'category' => 'nastaveni_sekce_dalsi_agendy',
    'name'  => 'pokladnikniha',
    'index' => 701,
    'storage' => 'nastaveni',
    'strings' => 'pokladnikniha.ini',

    'items' =>
        [
            // typ dokumentu pro vkladane dokumenty
            [
                'name'  => 'poklk_typ_dokumentu', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'PoklK_typ_dokumentu',
                'sql'   => 'SELECT Kod, Popis FROM TypDokumentu WHERE zobrazitNaIntrawebu = 1 ORDER BY popis', 'defaultValue' => 0
            ],

            // kontrolovat casovou posloupnost schvaleni
            [
                'name'  => 'poklk_posloupnost_schvalovani', 'type'  => Preference::CHECKBOX,    'title' => 'PoklK_posloupnost_schvalovani',
                'defaultValue' => 0
            ],
            // pouzivat vraceni
            [
                'name'  => 'poklk_pouzivat_vraceni', 'type'  => Preference::CHECKBOX,    'title' => 'PoklK_pouzivat_vraceni',
                'defaultValue' => 0
            ],

            // vychozi mena
            [
                'name'  => 'poklk_vychozi_mena', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'PoklK_vychozi_mena',
                'sql'   => 'SELECT Mena.KodISO, Mena.KodISO FROM Mena WHERE Mena.Aktivni = 1'
            ],
        ]
];