<?php
/**
 * stanislav.elbl, 27.10.2015
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_zabezpeceni',
    'name'  => 'zabezpeceni',
    'index' => 110,
    'storage' => 'nastaveniSpolecne',
    'strings' => 'users.ini',

    'items' =>
        [
            // pocet minut pro automaticke odhlaseni
            [
                'name'  => 'logouttimer',   'type'  => Preference::TEXT,    'title' => 'Pocet_minut_logout',
                'infoText' => 'Pocet_minut_logout_info',
                'defaultValue' => ''
            ],

            // sekce (menuid) zabezpecene heslem
            [
                'name'  => 'protected_menuid',   'type'  => Preference::TEXT,    'title' => 'Sekce_zabezpecene_heslem',
                'infoText' => 'Sekce_zabezpecene_heslem_info',
                'defaultValue' => ''
            ],
            [
                'name'  => 'protected_timeout',  'type'  => Preference::TEXT,    'title' => 'Sekce_zabezpecene_heslem_platnost',
                'infoText' => 'Sekce_zabezpecene_heslem_platnost_info',
                'defaultValue' => ''
            ],
        ],


];