<?php
/**
 * stanislav.elbl, 19.11.2015
 */

namespace Ron\Personalistika;

use Ron\MessageManager;
use Ron\RonPortal\RonPortalSettings;
use Ron\StringUtils;
use function Ron\ronText;

if (RonPortalSettings::getIntValue(RonPortalSettings::ZAKAZAT_PREVZIT_HODNOCENI)) return;

/** @var $this PrevzetiHodnoceniViewObject */
?>

<?php MessageManager::getInstance() ->showMessages(); ?>

<table class='inputtable'>

    <tr>
        <td colspan='3'>
            <?= ronText('Hodnoceni_rozpracoval') ?> <?= StringUtils::htmlTextConvert($this -> dotaznik ->fHodnoticiJmeno) ?> <?= StringUtils::htmlTextConvert($this->dotaznik ->fHodnoticiPrijmeni) ?>
            <?php if ($this->dotaznik ->fHodnotici) { ?> (<?= StringUtils::htmlTextConvert($this->dotaznik ->fHodnotici) ?>) <?php } ?>
            <br/>
            <br/>

            <b><?= ronText('Chcete_prevzit_hodnoceni') ?></b>
            <br/>
            <br/>

        </td>
    </tr>

    <tr>
        <td width="30%"><a href="?menuid=hodnoceni&hodnoceniaction=editujhodnoceni&prevzit=1&record=<?= $this ->dotaznik ->fId ?>"><?= ronText('Prevzit_hodnoceni') ?></a></td>
        <td width="30%"><a href="?menuid=hodnoceni&record=<?= $this->dotaznik ->fId ?>"><?= ronText('Pouze_zobrazit') ?></a></td>
        <td><a href="?menuid=hodnoceni"><?= ronText('Zpet_na_seznam_hodnoceni') ?></a></td>
    </tr>

</table>
