<?php
/**
 * stanislav.elbl, 28.02.2021
 */

namespace Ron\Controls;

/**
 * Class AppMenuItem
 * @package Ron
 */
class AppMenuItem
{
    var $text;
    var $menuId;
    var $className;
    var $htmlId;
    var $sectionId;

    /** @var string     css pripadneho obrazku */
    var $glyph;

    var $htmlParams;

    /** @var bool Priznak, ze je polozka vychozi pro zadanou sekci */
    var $default;

    // section
    var $active;
    var $defaultQueryString;

    function __construct($text, $menuid, $classname = '', $htmlid = '', $glyph = null)
    {
        $this ->menuId = $menuid;
        $this ->text = $text;
        $this ->className = $classname;
        $this ->htmlId = $htmlid;
        $this ->glyph = $glyph;
    }
}
