<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\MVC;

/**
 * Interface ExceptionHandler
 * @package Ron\MVC
 * Controller muze zajistit zpracovani vyjimky, pokud implementuje ExceptionHandler
 */
interface ExceptionHandler
{
    /**
     * @param \Exception $e
     * @return string|Redirect|InternalRedirect|ViewObject|OutputObject
     */
    public function handleException($e);
}
