<?php
/**
 * stanislav.elbl, 04.07.2018
 * Formular pro editaci terminalu v puvodni dochazce
 */

namespace RonPortal\Dochazka;

use Ron\Controls\ComboBox;
use RonPortal\RonPortalSession;

/** @var ComboBox $comboTerminal */

?>

<div id="vyberTerminaluForm" title="<?= \Ron\ronText('Vyber_terminalu') ?>" class="rondialog ronform" data-ronform-submit-url="?menuid=dochazkazamestnance&action=nastavterminal" data-ronform-after-submit="reload">
    <div id="vyberTerminaluInfoStr"></div>
    <div>
        <?= \Ron\ronText('Terminal') ?>:
    </div>
    <div>
        <input type="hidden" class="ronform-field" name="osoba" value="<?= RonPortalSession::vybranaOsoba() ?>"/>
        <input type="hidden" class="ronform-field" name="obdobi" value="<?= date('j.n.Y', RonPortalSession::obdobi()) ?>"/>
        <input type="hidden" class="ronform-field" name="kodOperace" id="vyberTerminaluKodOperace" value="" />
        <input type="hidden" class="ronform-field" name="datumCasOperace" id="vyberTerminaluCasOperace" value="" />
        <?php $comboTerminal ->render() ?>
    </div>

    <div class="formbuttons">
        <button id="vyberTerminaluOK"     type="button" class="submitbutton ronform-submit"><?= \Ron\ronText('OK') ?></button>
        <button id="vyberTerminaluStorno" type="button" class="button cancel"><?= \Ron\ronText('Cancel') ?></button>
    </div>
</div>
