<?php
/**
 * stanislav.elbl, 22.02.2021
 */

namespace RonPortal\Dokumenty;

use Ron\DB\Database;
use Ron\MVC\ViewObject;


class DokumentUploadForm implements ViewObject
{
    /** @var Database */
    var $database;

    /** @var string */
    var $uploadUrl;

    /** @var string */
    var $redirectUrl;

    var $sqlPripojeniStarsiho = null;

    var $hiddenFields = null;

    /** @var int pokud je nastaven v potomku, ve formulari se nezobrazi vyber typu dokumentu */
    var $typDokumentu = null;

    /** @var int pokud je nastavena v potomku, ve formulari se zobrazi jen vyber typu dokumentu s touto kategorii */
    var $kategorieDokumentu = null;

    var $target = 'upload_target';

    /**
     * DokumentUploadForm constructor.
     * @param Database $database
     * @param string $uploadUrl
     */
    public function __construct(Database $database, $uploadUrl)
    {
        $this->database = $database;
        $this->uploadUrl = $uploadUrl;
    }


    /**
     * Potomek muze doplnit dalsi pole
     */
    public function dalsiRadkyKDokumentu()
    {

    }


    public function render()
    {
        require('view/dokument_novy.php');
    }
}
