<?php
/**
 * pavel.rudol, 7.5.2015
 * formular pro ohodnoceni jidla a zobrazeni alergenu
 */

namespace RonPortal\Jidelna;

use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\RonPortalSettings;

/** @var PolozkaJidelnicku $polozka */

?>

<div id="polozkajidelnicku_dialog" style="display:none" title="">
    <!--<div class="dialogcaption"></div> -->

    <input type="hidden" id="polozkajidelnicku_id" name="id" value="" />

    <div style="position:relative">
        
        <table id="polozkajidelnicku_form" >

            <tr class="jidelnicek_foto_polozky" id="polozkajidelnicku_foto">
                <td colspan="3"></td>
                <td rowspan="4">
                    <img id="polozkajidelnicku_foto_img" data-link="?menuid=jidelnicek&action=zobrazfoto" src="" alt="Fotografie jidla">
                </td>
            </tr>

            <tr class="jidelnicek_hodnoceni_polozky" id="polozkajidelnicku_row_hodnoceni">
            
                <td class='formtablecaption'><?= TextManager::_('Hodnoceni_jidla') ?></td>
                <td id="polozkajidelnicku_hodnoceni">
                    
                    <span id="polozkajidelnicku_hodnoceni_1" class="fa hodnocenijidla_hvezda_off" data-hodnoceni-polozky="1" ></span>
                    <span id="polozkajidelnicku_hodnoceni_2" class="fa hodnocenijidla_hvezda_off" data-hodnoceni-polozky="2" ></span>
                    <span id="polozkajidelnicku_hodnoceni_3" class="fa hodnocenijidla_hvezda_off" data-hodnoceni-polozky="3" ></span>
                    <span id="polozkajidelnicku_hodnoceni_4" class="fa hodnocenijidla_hvezda_off" data-hodnoceni-polozky="4" ></span>
                    <span id="polozkajidelnicku_hodnoceni_5" class="fa hodnocenijidla_hvezda_off" data-hodnoceni-polozky="5" ></span>
                </td>

            </tr>

            

            <tr class="jidelnicek_hodnoceni_polozky" id="polozkajidelnicku_row_poznamka">
                <td class="formtablecaption"><label for="polozkajidelnicku_poznamka"><?= TextManager::_('Poznamka') ?></label></td>
                <td colspan="2">
                    <textarea id="polozkajidelnicku_poznamka" name="poznamka" cols="70" rows="8"></textarea>
                </td>
            </tr>
            
            <tr id="polozkajidelnicku_row_alergeny">
                <td class="formtablecaption"><?= TextManager::_('Alergeny') ?></td>
                <td colspan="2">
                    <ul id="polozkajidelnicku_seznamalergenu"></ul>
                </td>
            </tr>
            
            
        </table>
    </div>

    <div class="buttons align-center">
        <?php if (RonPortalSettings::getIntValue('jidelnicek_povolit_hodnoceni', 1)) { ?>
        <input type="submit" id="btnHodnoceniOK" class="submitbutton" value="<?= TextManager::_('Provest') ?>" />
        <?php } ?>
        <input type="button" id="btnStornoHodnoceni" class="button" value="<?= TextManager::_('Cancel') ?>" />
    </div>
</div>

