<?php
/**
 * stanislav.elbl, 10.01.2019
 */

namespace RonPortal\Kapacity;

use Ron\TextManager;
use RonPortal\RonPortalSettings;

?>

<?php if (RonPortalSettings::getIntValue(KapacitySettings::KAPACITY_TYP_ROZDELENI)  ||  RonPortalSettings::getIntValue(KapacitySettings::KAPACITY_TYP_ROZDELENI2)) { ?>
    <div id="kapacity_zmenarozdeleni" class="rondialog" title="<?= TextManager::_('Prerazeni_zamestnance') ?>">

        <div id="planovani_zmenarozdeleni_osoba"></div>
        <div id="planovani_zmenarozdeleni_datum"></div>


        <div><?= TextManager::_('Vyberte_rozdeleni') ?></div>

        <div id="planovani_zmenarozdeleni1">
            <div>
                <input id="planovani_zmenarozdeleni_kod" />
                <input id="planovani_zmenarozdeleni_popis" />
            </div>
            <?php if (RonPortalSettings::getIntValue('kapacity_smenypodlerozdeleni')) { ?>
                <div>
                    <label><input id="planovani_preplanovat_smeny" type="checkbox"/> <?= TextManager::_('Naplanovat_smeny_podle_noveho_rozdeleni') ?></label>
                </div>
            <?php } ?>
        </div>

        <div id="planovani_zmenarozdeleni2">
            <input id="planovani_zmenarozdeleni2_kod" />
            <input id="planovani_zmenarozdeleni2_popis" />
        </div>

        <div class="buttons">
            <button id="planovani_zmenarozdeleni_ok"     type="button" class="submitbutton"><?= TextManager::_('OK') ?></button>
            <button id="planovani_zmenarozdeleni_storno" type="button" class="button cancel"><?= TextManager::_('Cancel') ?></button>
        </div>
    </div>

<?php } ?>
