


ronPortal.DataZpracovaneDochazky = function() {
    this.idPP = 0;
    this.obdobi = '';
    this.x = 0;
    this.y = 0;
    this.showDokument = 0;
    this.povolitEditaci = 0;
    this.editovatVzdyCelyDen = 0;
    this.showErrorsDialog = 0;
};
ronPortal.zpracovanaDochazka = function(data) {
    if (!data.showDokument) {
        if (data.x  ||  data.y) {
            window.scrollTo(data.x, data.y);
        } else {
            var $editovanyDen = $("a[name='editovanyden']");
            if ($editovanyDen.length) {
                var y = $editovanyDen.offset().top - 100;
                if (y > 0) window.scrollTo(0, y);
            }
        }
    }

    var zpracovanaSubmit = function() {
        ron.showWorkingInfo();
    };


    var buttonClick = function(event) {
        var otazka = $(this).data("ron-question");
        if (otazka) if (!ron.confirm(otazka)) {
            event.stopImmediatePropagation();
            return false;
        }
    };

    var podlePuvodniClick = function() {

        $("[name=prepocitatpodlepuvodni]").val('1');
        zpracovanaSubmit();
        this.form.submit();
        return true;
    };


    var doplnitPuvodniClick = function() {

        $("[name=doplnitpuvodni]").val('1');
        zpracovanaSubmit();
        this.form.submit();
        return true;
    };


    var smazatRadekDochazkyClick = function() {
        var $that = $(this);

        var provedSmazani = function() {
            ron.showWorkingInfo();

            var datumStr = $that.data("ron-datum");
            window.location =
                "?menuid=editacedne&action=zrusitzaznamyproden&idpp=" + data.idPP + "&datum=" + datumStr;
        };


        var otazka = $(this).data("ron-question");
        if ( otazka ) {
            ron.confirm(otazka, provedSmazani);
        } else {
            provedSmazani();
        }

    };


    var zobrazChybuDochazky = function() {
        $("#kontrolyDochazky").dialog( {
            modal : true,
            resizable: true,
            width: "auto",
            height: "auto"
        });

        var index = $(this).data("ron-index");
        $("#kontrolyDochazkyTable").rontable("setActiveRow", $("#kontrolyDochazky_" + index));
    };

    var showDokumentDochazkyDialog = function() {
        var dokumentDochazkyResult = function(result) {
            processDokumentResult(result, 'index.php?menuid=zpracovanadochazka');
        };

        ronPortal.showDokumentDialog(dokumentDochazkyResult);
    };


    var grafickaClick = function() {
        if (!data.povolitEditaci) return;

        window.location = data.editovatVzdyCelyDen
            ? "?menuid=editacedne&idpp=" + data.idPP + '&datum=' + $(this).data("ron-datum")
            : "?menuid=editacedochazky&idpp=" + data.idPP + "&datumcas=" + $(this).data("ron-pocatek");

    };


    var zmenitSmenuPK = function() {
        var dataPK = null;

        var $select = $("#zpracovana_pk_smena");
        var prepocitat = "0"; // nastavi se po stisknuti tlacitka

        var showPodrobnostiSmeny = function() {
            if (!dataPK) return;

            var kod = $("#zpracovana_pk_smena").val();

            var i = 0;
            while (i < dataPK.smeny.length  &&  dataPK.smeny[i].kod != kod) {
                i++;
            }

            var $podrobnosti = $("#zpracovana_pk_podrobnosti");
            $podrobnosti.empty();

            if (i < dataPK.smeny.length  &&  dataPK.smeny[i].kod == kod) {
                $("<div/>")
                    .text(dataPK.smeny[i].pocatekStr + " - " + dataPK.smeny[i].konecStr + " (" + dataPK.smeny[i].delkaStr + ")")
                    .appendTo($podrobnosti);
            }
        };

        var showData = function(resultData) {
            dataPK = resultData;

            $("#zpracovana_pk_kalendar").text(resultData.popisKalendare + " (" + resultData.kalendar + ")");
            $("#zpracovana_pk_datum").text(resultData.datum);

            $select.empty();

            $select.append( $("<option/>").val("").text(""));

            for (var i = 0;  i < resultData.smeny.length;  i++) {
                var $option = $("<option/>")
                    .val(resultData.smeny[i].kod)
                    .text(resultData.smeny[i].popis); // + " (" + resultData.smeny[i].pocatekStr + " - " + resultData.smeny[i].konecStr + ")"

                if (resultData.planovanaSmena  &&  resultData.smeny[i].kod == resultData.planovanaSmena.kod) {
                    $option.attr("selected", "selected");
                }

                $select.append($option);
            }

            showPodrobnostiSmeny();

            ron.dialog.hideWaitMessage("#zpracovana_pk_zmenitsmenu");
        };

        var loadData = function() {
            $.ajax("?menuid=zpracovanadochazka&action=smenypk&idpp=" + data.idPP + "&obdobi=" + data.obdobi + "&dny=" + $("[name=vybranedny]").val())
                .done(function (resultData) {
                    if (resultData.result == 'error') {
                        ron.showError(resultData);
                        return;
                    }

                    showData(resultData)
                })
                .fail(ron.ajaxErrorFunction("Pri nacitani dat doslo k chybe!"));
        };

        $select.on("change", showPodrobnostiSmeny);
        var zapisPlanovanouSmenu = function() {
            ron.showWorkingInfo();

            $.ajax("?menuid=zpracovanadochazka&action=zapissmenupk&idpp=" + data.idPP +
                "&obdobi=" + data.obdobi +
                "&dny=" + $("[name=vybranedny]").val() +
                "&prepocitat=" + prepocitat +
                "&smena=" + $select.val())
                .done(function (resultData) {
                    if (resultData.result == 'error') {
                        ron.hideWorkingInfo();

                        ron.showError(resultData);
                        return;
                    }

                    window.location.replace(window.location);
                })
                .fail(ron.ajaxErrorFunction("Pri nacitani dat doslo k chybe!"));
        };

        $("#btn_pk_OK")
            .on("click", zapisPlanovanouSmenu);

        return function() {
            prepocitat = $(this).data('ron-prepocitat');

            $("#zpracovana_pk_zmenitsmenu")
                .dialog({
                    modal: true,
                    resizable: false,
                    width: "auto",
                    height: "auto"
                });

            ron.dialog.showWaitMessage("#zpracovana_pk_zmenitsmenu");

            loadData();
        };
    }();
    $("#zpracovanadochazkabrowser")
        .on("click", ".submitbutton", buttonClick)
        .on("click", ".button", buttonClick)
        .on("click", "[name=podlepuvodni]", podlePuvodniClick)
        .on("click", "[name=doplnitpuvodnibtn]", doplnitPuvodniClick)
        .on("click", ".smazatradekdochazky", smazatRadekDochazkyClick)
        .on("click", ".kontrola_priznak", zobrazChybuDochazky)
        .on("click", ".mesicnikontrola", zobrazChybuDochazky)
        .on("click", ".grafickadochazka", grafickaClick)
        .on("click", "[name=pk_zmenitsmenu]", zmenitSmenuPK);


    $("#zpracovanadochazkaform")
        .on("submit", zpracovanaSubmit);


    var selectedRows = []; // seznam vybranych radku - pro oznacovani s CTRL,SHIFT
    var lastSelectedRow = null;


    var zapisVybraneDny = function() {
        var value = "";
        var $rows = $("#zpracovanadochazka").find("tr.browserselectedrow");
        $rows.each( function() {
            value += $(this).data("ron-datum") + ";";
        });

        $("[name=vybranedny]").val(value);
    };
    var rowSelect = function(event) {
        if (event.which != 1) return;

        var $target = $(event.target);

        if ( $target.is("input,a,img,.inline-glyph") ) return;
        if ( $target.parents("a").length ) return;

        if ( $target.is(".grafickadochazka")  ||  $target.parents(".grafickadochazka").length ) return;

        var $this = $(this);
        if ($this.is("a")) return;

        var datum = $this.data("ron-datum");
        if (!datum) return; // jiny radek, napr. footer

        if (datum) {
            if (event.ctrlKey) {
                if (ron.inArray(this, selectedRows)) {
                    $this.toggleClass("browserselectedrow", false);
                    ron.removeFromArray(this, selectedRows);
                } else {
                    $this.toggleClass("browserselectedrow", true);
                    selectedRows[selectedRows.length] = this;
                    lastSelectedRow = this;
                }
            } else if (event.shiftKey  &&  lastSelectedRow) {
                var $rows = $("#zpracovanadochazka").find("tr");
                $rows.toggleClass("browserselectedrow", false);
                selectedRows = [];

                var index1 = $rows.index(this);
                var index2 = $rows.index(lastSelectedRow);
                if (index2 < index1) {
                    var pom = index2;
                    index2 = index1;
                    index1 = pom;
                }

                for (var i = index1;  i <= index2;  i++) {
                    $rows.eq(i).toggleClass("browserselectedrow", true);
                    selectedRows[selectedRows.length] = $rows.get(i);
                }
            } else {
                if (selectedRows.length == 1  &&  selectedRows[0] == this) {
                    $this.toggleClass("browserselectedrow", false);
                    lastSelectedRow = null;
                    selectedRows = [];
                } else {
                    $("#zpracovanadochazka").find("tr").toggleClass("browserselectedrow", false);
                    $this.toggleClass("browserselectedrow", true);
                    lastSelectedRow = this;
                    selectedRows = [this];
                }
            }

            $("#zpracovana_tlacitka_float").css("display", selectedRows.length ? "block" : "none");

            zapisVybraneDny();

            return false;
        }
    };


    var vysledekChange = function() {
        $(this).css("fontWeight", "bold");
    };


    $("#zpracovanadochazka")
        .on("mousedown", "tr", rowSelect)
        .on("change", ".vysledekedit", vysledekChange);
    $("#kontrolyDochazkyTable").rontable();

    if (data.showDokument) {
        showDokumentDochazkyDialog();
    }


    (function() {
        var originalX = 0;

        var grafickaDochazkaResize = function (mouseevent) {
            if (!originalX) return; // nemelo by nastat

            var
                $this = $(this),
                dx = $this.position().left - originalX,
                $timeDiv = $(".graficka_timediv"),
                newWidth = $timeDiv.width() + dx,
                minWidth = parseInt($(this).data("min-width")),
                maxWidth = parseInt($(this).data("max-width"));


            if (newWidth < minWidth) newWidth = minWidth;
            else if (newWidth > maxWidth) newWidth = maxWidth;

            $timeDiv.width(newWidth + "px");
            $this.css("left", newWidth + "px");

            $.ajax("?menuid=zpracovanadochazka&action=grafickawidth&newWidth=" + newWidth);
        };


        $(".graficka_splitter")
            .draggable({
                axis: "x",
                start: function() { originalX = $(this).position().left; },
                stop: grafickaDochazkaResize
            })
    })();


    if (data.showErrorsDialog) {
        $(function () {
            ron.errorsDialog(".errormessages");
        });
    }

};


ronPortal.formularAbsence = function() {
    var getCasovaSlozkaPlanovani = function() {
        var nacistData = false;

        var $div = $("#casovaslozka0");
        var i = 0;
        while ($div.length) {
            nacistData = true; // je alespon 1 => budou se nacitat data
            $div.html( " ... " );
            i++;
            $div = $("#casovaslozka" + i);
        }

        if (!nacistData) return;

        $.ajax( "?menuid=absence&action=casoveslozky&idpp=" + $(this).val())
            .done( function(data) {
                if (data.result == "OK") {
                    for (i = 0; i < data.hodnoty.length; i++) {
                        $("#casovaslozka" + i).html( data.hodnoty[i] );
                    }
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri nacitani casovych slozek doslo k chybe!");
            });
    };


    var delkaPlanovaneAbsenceChange = function() {

        var newVal = $(this).val();
        $("#absence_od_do").css("display", (newVal == 3) ? "inline" : "none");
        $("#absence_caption_od").css("display", (newVal == 3) ? "inline" : "none");
        $("#absence_kontinualni_casod").css("display", (newVal == 4) ? "inline" : "none");
        $("#absence_kontinualni_casdo").css("display", (newVal == 4) ? "inline" : "none");
    };

    var operaceAbsenceChange = function () {
        var
            povoleneDelky = $('[name="Delky_operace_' + $(this).val() +'"]').val(),
            $delkaCombo = $('#absence_delka'),
            delky = JSON.parse($("[name='Delky_popis']").val()),
            puvodniHodnota = $delkaCombo.val(); // zapamatuje si puvodni hodnotu

        $delkaCombo.find('option').remove();

        if (povoleneDelky !== undefined) {
            povoleneDelky = povoleneDelky.split(';');
        }


        $.each(delky.delky, function(key, value) {
            if ((povoleneDelky === undefined) || (povoleneDelky.indexOf('' + value.kod + '') >= 0)) {
                $delkaCombo
                   .append($('<option>', {value: value.kod})
                       .text(value.popis));
            }
        });

        $delkaCombo.val(puvodniHodnota); // obnovi puvodni hodnotu
    };


    $("#absence_osoba").on("change", getCasovaSlozkaPlanovani);
    $("#absence_delka").on("change", delkaPlanovaneAbsenceChange);
    $('#absence_operace').on('change', operaceAbsenceChange).trigger('change');
};
ronPortal.DataEditaceDochazky = function() {
    var Smena = function () {
        this.kod = "";
        this.popis = "";
        this.denDochPodleKonceSmeny = 0;
    };
    this.smeny = null;
};


ronPortal.dochazka = {
    editaceDochazky: function (data) {
        $(function () {
            var vyberOperace = function () {
                var name = $(this).attr("name");
                if (typeof VyberOperaceEditace_User == 'function') {
                    VyberOperaceEditace_User(this, 'kod' + name);
                }
            };


            var jeZaznamPresPulnoc = function (rowIndex) {
                var timeFromStr = $("input[name='caspocatku" + rowIndex + "']").val();
                if (!timeFromStr) return false;

                var timeToStr = $("input[name='casukonceni" + rowIndex + "']").val();
                if (!timeToStr) return false;

                var timeFrom = ron.utils.stringToTime(timeFromStr);
                var timeTo = ron.utils.stringToTime(timeToStr);

                return timeFrom && timeTo && timeTo < timeFrom;
            };
            var vyberSmeny = function () {
                if (!data || !data.smeny) return;

                var $this = $(this);

                var indexSmeny = -1;

                for (var i = 0; i < data.smeny.length && indexSmeny < 0; i++) {
                    if (data.smeny[i].kod == $this.val()) {
                        indexSmeny = i;
                    }
                }

                if (indexSmeny < 0) return; // nenasel smenu
                var rowIndex = ron.utils.removePrefix($this.attr("name"), "smena");
                if (rowIndex === false) {
                    console.log("ronPortal.editaceDochazky - vyberSmeny() - name nema prefix 'smena'");
                    return;
                }
                var denStr = $("input[name='datumpocatku" + rowIndex + "']").val();

                if (data.smeny[indexSmeny].denDochPodleKonceSmeny && jeZaznamPresPulnoc(rowIndex)) {
                    var den = ron.utils.stringToDate(denStr);
                    if (den) {
                        den = ron.utils.incDay(den, 1);
                        denStr = ron.utils.dateToString(den);
                    }
                }
                $("input[name='den" + rowIndex + "']").val(denStr);
            };
            var zobrazenaDobaEdit = function () {
                var time1 = ron.utils.stringToTime(document.editacedochazkyform.caspocatku.value);
                if (!time1) return;

                var time2 = ron.utils.stringToTime(document.editacedochazkyform.casukonceni.value);
                if (!time2) return;

                var milis = time2.getTime() - time1.getTime();
                if (milis < 0) milis = milis + 24 * 3600 * 1000;

                var time = new Date();
                time.setTime(milis);

                var span = $("#zobrazena_doba").html(ron.utils.timeToString(time, true, false)); // utc=true, seconds=false
            };
            var zapocitanaDobaEdit = function () {
                var time1 = ron.utils.stringToTime(document.editacedochazkyform.zapoctenycasod.value);
                if (!time1) return;

                var time2 = ron.utils.stringToTime(document.editacedochazkyform.zapoctenycasdo.value);
                if (!time2) return;

                var milis = time2.getTime() - time1.getTime();
                if (milis < 0) milis = milis + 24 * 3600 * 1000;

                var time = new Date();
                time.setTime(milis);

                $("#zapoctena_doba").html(ron.utils.timeToString(time, true, false)); // utc=true, seconds=false
            };


            var smazaniZaznamuClick = function() {
                var $that = $(this);

                var smazZaznam = function() {
                    $("#editaceDneDeleteRow").val($that.data("index"));
                    $("#editaceDneForm").submit();
                };


                ron.confirmQuestion($that, smazZaznam);
            };

            var skutecnaDobaClick = function () {
                $('[name="zapoctenycasod"]').val($('[name="caspocatku"]').val());
                $('[name="zapoctenycasdo"]').val($('[name="casukonceni"]').val());
                zapocitanaDobaEdit();
            };

            $("#editaceDne,#editaceZaznamu")
                .on("change", "select[name^='operace']", vyberOperace)
                .on("change", "select[name^='smena']", vyberSmeny)
                .on("change", "input[name='caspocatku']", zobrazenaDobaEdit)
                .on("change", "input[name='casukonceni']", zobrazenaDobaEdit)
                .on("change", "input[name='zapoctenycasod']", zapocitanaDobaEdit)
                .on("change", "input[name='zapoctenycasdo']", zapocitanaDobaEdit)
                .on("click", "#skutecnadoba", skutecnaDobaClick)
            ;

            $("#editaceDne")
                .on("click", ".deleteRecord", smazaniZaznamuClick);
        });
    },
    editaceZaznamu: function () {
        var zapniViceDnu = function () {
            $("#vicednu_link").css("display", "none");

            $("#datumdocaption, #datumdo").css("display", "inline");
            $("#provicednu").val("1");

            return false;
        };


        $("#vicednu_link")
            .on("click", zapniViceDnu);
    },
    aktualizujSchvaleniOsoby: function () {
        console.log("Chyba: neni co aktualizovat!");
    },
    zobrazSchvaleniDochazky: function (idpp, obdobi, redirectUrl) {
        var showWaitMessage = function() {
            $("#schvaleni_waitmessage").css("display", "block");
            $("#btnSchvaleniOK").prop('disabled', true);
        };

        var hideWaitMessage = function() {
            $("#schvaleni_waitmessage").css("display", "none");
            $("#btnSchvaleniOK").prop('disabled', false);
        };

        showWaitMessage();
        var odesliPozadavekSchvaleni = function (action, callback) {
            $.ajax(
                {
                    url: "?menuid=schvalovani&action=" + action,
                    type: "POST",
                    data: {
                        idpp: $("#schvaleni_idpp").val(),
                        obdobi: $("#schvaleni_obdobi").val(),
                        schvaleni1: $("#schvaleni_zpracovanodo").val(),
                        schvaleni2: $("#schvaleni_zkontrolovanodo").val(),
                        schvaleni3: $("#schvaleni_schvalenodo").val(),
                        poznamka: $("#schvaleni_poznamka").val()
                    }
                }).done(function (responseData) {
                    callback.call(this, responseData);
                }).fail(function (jqXHR) {
                    ron.showAjaxError(jqXHR, "Pri schvalovani doslo k chybe!");
                });
        };
        var zapisSchvaleniOsoby = function () {
            odesliPozadavekSchvaleni("schvalit_no_check",
                function (obj) {
                    if (obj.result == "OK") {
                        var url = redirectUrl ? redirectUrl : window.location;
                        if (debugMode) {
                            alert("DEBUG> Redirect na: " + url);
                        }
                        window.location.replace(url);
                        return true;
                    }

                    ron.showError(obj);
                    return false;
                }
            );

            return true;
        };
        function provedSchvaleniOsoby() {
            showWaitMessage();

            odesliPozadavekSchvaleni("schvalit",
                function (obj) {
                    if (obj.result == "OK") {
                        var url = redirectUrl ? redirectUrl : window.location;
                        if (debugMode) {
                            alert("DEBUG> Redirect na: " + url);
                        }
                        window.location.replace(url);
                        return;
                    }

                    if (obj.result == "warning") {
                        var msg = "";
                        if (obj.errors) {
                            for (var i = 0; i < obj.errors.length; i++) msg = msg + obj.errors[i].errorText + "\n";
                        }
                        if (ron.confirm(msg)) zapisSchvaleniOsoby();
                        return;
                    }

                    hideWaitMessage();

                    ron.showError(obj); // chyba - napr. spatny format
                }
            );
        }
        var predvyplnDatum = function () {
            var inputName = $(this).data("predvyplnit-input");

            var $input = $("#" + inputName);
            $input.val($input.data("datum-predplneni"));

            return false;
        };

        $("#schvaleni_dialog")
            .off("click", "a[data-predvyplnit-input]")
            .on("click", "a[data-predvyplnit-input]", predvyplnDatum)
            .dialog({
                modal: true,
                resizable: false,
                width: "auto",
                height: "auto"
            });

        $("#btnStornoSchvaleni")
            .off("click")
            .on("click", function () {
                $("#schvaleni_dialog").dialog("close");
            });

        $("#btnSchvaleniOK")
            .off("click")
            .on("click", provedSchvaleniOsoby);
        var SchvaleniOsobyData = function() {
            this.idpp = null;
            this.jmeno = null;

            this.zpracovanoDo = null;
            this.zpracoval = '';
            this.pravoZpracovat = 0;

            this.zkontrolovanoDo = null;
            this.zkontroloval = '';
            this.pravoZkontrolovat = 0;

            this.schvalenoDo = null;
            this.schvalil = '';
            this.pravoSchvalit = 0;

            this.zpracovanoVeMzdach = 0;

            this.poznamka = '';

            this.result = null; // OK/error
            this.errors = null;
        };
        var zobrazData = function (data) {
            if (!data || !data.idpp) return;

            $("#schvaleni_dialog")
                .toggleClass("zpracovanovemzdach", !!data.zpracovanoVeMzdach); // funguje jen s booleanem!

            $("#schvaleni_idpp").val(data.idpp);
            $("#schvaleni_jmeno").html(data.jmeno);

            $("#schvaleni_zpracovanodo")
                .val(data.zpracovanoDo)
                .attr("readonly", data.zpracovanoVeMzdach || !data.pravoZpracovat);
            $("#schvaleni_zpracovanobtn")
                .css("display", (data.zpracovanoVeMzdach || !data.pravoZpracovat) ? "none" : "inline");
            $("#schvaleni_zpracoval")
                .text(data.zpracoval);

            $("#schvaleni_zkontrolovanodo")
                .val(data.zkontrolovanoDo)
                .attr("readonly", data.zpracovanoVeMzdach || !data.pravoZkontrolovat);
            $("#schvaleni_zkontrolovanobtn")
                .css("display", (data.zpracovanoVeMzdach || !data.pravoZkontrolovat) ? "none" : "inline");
            $("#schvaleni_zkontroloval")
                .text(data.zkontroloval);

            $("#schvaleni_schvalenodo")
                .val(data.schvalenoDo)
                .attr("readonly", data.zpracovanoVeMzdach || !data.pravoSchvalit);
            $("#schvaleni_schvalenobtn")
                .css("display", (data.zpracovanoVeMzdach || !data.pravoSchvalit) ? "none" : "inline");
            $("#schvaleni_schvalil")
                .text(data.schvalil);


            $("#schvaleni_poznamka")
                .val(data.poznamka ? data.poznamka : '');

            hideWaitMessage();
        };
        var nactiAZobrazData = function (onLoadFunction) {
            var url = "?menuid=schvalovani&action=loaddata&obdobi=" + obdobi + "&idpp=" + idpp;
            $.ajax(url)
                .done(function (data) {
                    if (debugMode) console.log("Nactena data schvaleni: ", data);

                    if (data.result == "error") {
                        ron.showError(data);
                    } else {
                        zobrazData(data);

                        if (typeof onLoadFunction == "function") {
                            onLoadFunction(data);
                        }
                    }

                }).fail(function (jqXHR) {
                    ron.showAjaxError(jqXHR, "Pri nacitani schvaleni doslo k chybe!");
                });
        };


        ronPortal.dochazka.aktualizujSchvaleniOsoby = function () {
            nactiAZobrazData();
        };


        nactiAZobrazData(onLoadSchvaleni);

    },


    hromadneSchvaleniForm: function() {
        var poznamkaKeyUp = function() {
            $("#hromadneschvaleni_poznamkacheck").prop("checked", $(this).val().length > 0);
        };

        var predplnit = function() {
            var $this = $(this);

            $("input[name=" + $this.data("inputname") + "]").val($this.data("value"));
            $("input[name=" + $this.data("inputname") + "_check]").prop("checked", true);
        };

        $("#hromadneschvaleni_poznamkaedit")
            .on("keyup", poznamkaKeyUp);

        $("a.predplnit")
            .on("click", predplnit);
    },
    OsobaProSchvalovani: function() {
        this.idPP = null;
        this.jmeno = '';
        this.osobniCislo = '';
        this.schvaleni1 = null;
        this.prava1 = 0;
        this.schvaleni2 = null;
        this.prava2 = 0;
        this.schvaleni3 = null;
        this.prava3 = 0;
    },

    DataSchvalovani: function() {
        this.obdobi = '';
        this.konecObdobi = '';
        this.pocetOsob = 0;
        this.editace1 = 0; // 0=ne, 1=ano, 2=checkbox
        this.editace2 = 0;
        this.editace3 = 0;
        this.osoby = [];
    },
    hromadneSchvalovani: function (dataSchvalovani) {
        var provestHromadneSchvaleniDochazky = function () {
            var indexOsoby; // musi byt undefined !

            var progressbar = $('#schvaleni_progressbar');
            var nastavPostSchvaleni = function (obj, level, zpusobEditace) {
                switch (zpusobEditace) {
                    case 1 :
                        alert("Neni implementovano!");
                        break;

                    case 2 :
                        var checked = $("#schvaleni_" + dataSchvalovani.osoby[indexOsoby].idPP + "_" + level).prop("checked");
                        obj["schvaleni" + level] = checked ? dataSchvalovani.konecObdobi : '';
                        break;

                    default :
                        break; // uroven neni editovatelna
                }
            };


            var zpracujVysledekSchvaleni = function (data) {
                if (data.result == "OK") {
                    schvalDalsiOsobu();
                    return true;
                }

                if (data.result == "error") {
                    ron.showError(data, '#schvaleni_message');
                    $("#schvaleno_preskocit").show();

                    $('#schvaleni_progress').dialog();
                } else {
                    ron.showError(data, '#schvaleni_message');

                    $("#schvaleno_ok").show();
                    $("#schvaleno_preskocit").show();
                }

                return false;
            };
            var odesliPozadavekSchvaleni = function (action) {
                var postData = {
                    idpp: dataSchvalovani.osoby[indexOsoby].idPP,
                    obdobi: $("#schvaleni_obdobi").val()
                };

                if (dataSchvalovani.osoby[indexOsoby].prava1) {
                    nastavPostSchvaleni(postData, 1, dataSchvalovani.editace1);
                }
                if (dataSchvalovani.osoby[indexOsoby].prava2) {
                    nastavPostSchvaleni(postData, 2, dataSchvalovani.editace2);
                }
                if (dataSchvalovani.osoby[indexOsoby].prava3) {
                    nastavPostSchvaleni(postData, 3, dataSchvalovani.editace3);
                }


                $.ajax(
                    {
                        url: "?menuid=schvalovani&action=" + action,
                        type: "POST",
                        data: postData
                    }).done(function (resultData) {
                        zpracujVysledekSchvaleni(resultData);
                    }).fail(function (jqXHR) {
                        ron.showAjaxError(jqXHR, "Pri schvalovani doslo k chybe!");
                    });
            };


            var provedSchvaleniOsoby = function (action) {
                odesliPozadavekSchvaleni(action);

                return true;
            };


            var schvalDalsiOsobu = function () {
                if (indexOsoby === undefined) {
                    indexOsoby = 0;
                } else {
                    indexOsoby++;
                }

                progressbar.progressbar("value", indexOsoby);

                if (indexOsoby >= dataSchvalovani.pocetOsob) {
                    window.location.replace('?menuid=schvalovani');
                    return true;
                }

                $('#schvaleni_progres_info').text(dataSchvalovani.osoby[indexOsoby].jmeno + ', ' + dataSchvalovani.osoby[indexOsoby].osobniCislo);

                provedSchvaleniOsoby('schvalit');
            };
            var provedSchvaleniNoCheck = function () {
                $("#schvaleno_ok").hide();
                $("#schvaleno_preskocit").hide();

                $("#schvaleni_message").html("");

                provedSchvaleniOsoby('schvalit_no_check');
            };
            var preskocSchvaleni = function () {
                $("#schvaleno_ok").hide();
                $("#schvaleno_preskocit").hide();

                $("#schvaleni_message").html("");

                schvalDalsiOsobu();
            };
            $("#schvaleno_ok")
                .off("click")
                .on("click", provedSchvaleniNoCheck);

            $("#schvaleno_preskocit")
                .off("click")
                .on("click", preskocSchvaleni);

            $("#schvaleno_storno")
                .off("click")
                .on("click", function () {
                    window.location.replace('?menuid=schvalovani');
                });
            progressbar.progressbar({
                max: dataSchvalovani.pocetOsob,
                value: 0
            });
            $('#schvaleni_progress').dialog({
                modal: true,
                resizable: true,
                width: "auto",
                height: "auto"
            });


            schvalDalsiOsobu();
        };
        function stornoHromadneSchvaleniDochazky() {
            window.location.replace('?menuid=schvalovani');
        }
        function hromadneSchvaleniCheck() {
            var $this = $(this);

            var level = $this.data("hromadne-schvalit-uroven");
            if (!level) return;


            for (var i = 0; i < dataSchvalovani.pocetOsob; i++) {
                var jePravo = false;

                switch (level) {
                    case 1 :
                        jePravo = dataSchvalovani.osoby[i].prava1;
                        break;
                    case 2 :
                        jePravo = dataSchvalovani.osoby[i].prava2;
                        break;
                    case 3 :
                        jePravo = dataSchvalovani.osoby[i].prava3;
                        break;
                }

                if (jePravo) {
                    $("#schvaleni_" + dataSchvalovani.osoby[i].idPP + "_" + level).prop("checked", $this.prop("checked"));
                }
            }
        }
        var schvalitDochazkuHromadne = function () {
            $('#schvalovanidochazky').addClass('hromadne');
        };


        var zobrazFormular = function (event) {
            var idPP = $(this).data("schvalovani-idpp");

            event.preventDefault(); // aby se neprovedlo presmerovani na jinou url pri kliknuti na <a>

            if (idPP) {
                ronPortal.dochazka.zobrazSchvaleniDochazky(idPP, dataSchvalovani.obdobi);
            }
        };


        $("#provestHromadneSchvaleniDochazky")
            .on("click", provestHromadneSchvaleniDochazky);

        $("#stornoHromadneSchvaleniDochazky")
            .on("click", stornoHromadneSchvaleniDochazky);

        $("#schvalitDochazkuHromadne")
            .on("click", schvalitDochazkuHromadne);

        $("#seznam_schvalovani_dochazky")
            .on("click", "input.hromadne_edit", function(event) { event.stopPropagation(); } )
            .on("click", "input[data-hromadne-schvalit-uroven]", hromadneSchvaleniCheck)
            .on("click", "tr[data-schvalovani-idpp]", zobrazFormular);


    }

};



ronPortal.VkladaniDochazkyParams = function() {
    this.vkladaniPodleHistorie = 0;
    this.operace = [];
    this.vybranaOperace = null;
    this.muzeMenitCas = 0;
    this.rozdeleni = [];
    this.vybraneRozdeleni = null;
};
ronPortal.vkladaniDochazky = function(params) {
    var lzeEditovatCasOperace = function(kod) {
        for (var i = 0;  i < params.operace.length;  i++) {
            if (params.operace[i].kod == kod) {
                return params.operace[i].lzeNastavitCas;
            }
        }

        return false;
    };


    var vyberOperace_CasDleHistorie = function(kod) {
        var lzeeditovat = lzeEditovatCasOperace(kod);

        if (lzeeditovat) {
            $("#datumOperace").css("display", "inline");
            $("#casOperace").css("display", "inline");
            $("#pruchody").css("display", "none");
        }
        else {
            $("#datumOperace").css("display", "none");
            $("#casOperace").css("display", "none");
            $("#pruchody").css("display", "inline");
        }
    };


    function nactiCasyPodleHistorie()
    {
        var idpp = $("#vyberOsobyProVkladani").val();
        var url = "?menuid=vlozeni&action=pruchodyproden&idpp=" + idpp;
        ron.loadOptionsFromUrl( $("#pruchody"), url);
    }


    var vyberOsobyProVkladaniChange = function()
    {
        nactiCasyPodleHistorie();
        vyberOperace_CasDleHistorie($("#vyberOperaceProVkladani").val());
    };


    function vyberOperaceVkladani(kod)
    {
        if (!params.muzeMenitCas) {
            if (params.vkladaniPodleHistorie) {
                vyberOperace_CasDleHistorie(kod);
            } else {
                var lzeEditovat = lzeEditovatCasOperace(kod);
                $("#datumOperace").prop("disabled", !lzeEditovat);
                $("#casOperace").prop("disabled", !lzeEditovat);
            }
        }
    }

    if (params.vkladaniPodleHistorie  &&  !params.muzeMenitCas) {
        $("#vyberOsobyProVkladani").on("change", vyberOsobyProVkladaniChange);
    }

    if (!params.muzeMenitCas) {
        $("#vyberOperaceProVkladani").on("change", function() { vyberOperaceVkladani(this.value) } );
    }

    var onOperaceChange = function(index, options) {
        if (index === null  ||  index < 0  ||  index >= options.items.length) {
            return;
        }

        $("#operace2").ronselect("value", index === null ? null : options.items[index].popis);
        $("#kodOperace2").ronselect("value", index === null ? null : options.items[index].kod);

        $("#vyberOperaceProVkladani").val(options.items[index].kod);

        vyberOperaceVkladani(options.items[index].kod);
    };
    $("#operace2").ronselect({
        items: params.operace,
        columns: ["popis", "kod"],
        textColumn: "popis",
        onChange: onOperaceChange,
        initialValue: params.vybranaOperace
    } );

    var kodOptions = ron.utils.copyArray(params.operace);
    kodOptions.sort( function(item1, item2) {
        return item1.kod.localeCompare(item2.kod);
    } );

    $("#kodOperace2").ronselect({
        items: kodOptions,
        columns: ["kod", "popis"],
        textColumn: "kod",
        dropDownAlign: "right",
        onChange: onOperaceChange,
        initialValue: params.vybranaOperace
    } );
    if (params.rozdeleni) {
        var onRozdeleniChange = function(index, options) {
            if (index === null  ||  index < 0  ||  index >= options.items.length) {
                return;
            }
            $("#rozdeleni2").ronselect("value", (index === null) ? null : options.items[index].kod);
            $("#kodRozdeleni2").ronselect("value", (index === null) ? null : options.items[index].kod);
            $("#vyberRozdeleniProVkladani").val(options.items[index].kod);
        };

        $("#rozdeleni2").ronselect({
            items: params.rozdeleni,
            columns: ["popis", "kod"],
            initialValue: params.vybraneRozdeleni,
            textColumn: "popis",
            valueColumn: "kod",
            onChange: onRozdeleniChange
        });

        var kodRozdeleniOptions = ron.utils.copyArray(params.rozdeleni);
        kodRozdeleniOptions.sort( function(item1, item2) {
            return item1.kod.localeCompare(item2.kod);
        } );

        $("#kodRozdeleni2").ronselect({
            items: kodRozdeleniOptions,
            columns: ["kod", "popis"],
            initialValue: params.vybraneRozdeleni,
            textColumn: "kod",
            dropDownAlign: "right",
            onChange: onRozdeleniChange
        } );
    }

};


ronPortal.terminalVkladani = function(options) {

    var hodiny = function() {
        var now = new Date();

        $("#time")
            .text( now.getHours() + ":" + (now.getMinutes() < 10 ? "0" : "") + now.getMinutes() + ":" + (now.getSeconds() < 10 ? "0" : "") + now.getSeconds() );
    };
    var probihaVkladani = false;

    var onButtonClick = function() {
        if (probihaVkladani) return false; // nedela nic - uz probiha vkladani

        var $this = $(this);
        $(".terminalVkladani .tlacitko_operace").toggleClass("active", false);
        $this.toggleClass("active", true);

        var kod = $this.data("ron-kodoperace");
        $("#kodOperace").val(kod);

        if (options.potvrdit) return false; // potvrzuje se tlacitkem OK

        probihaVkladani = true;
        return true; // formular rovnou odesle
    };
    var onButtonPPClick = function() {
        var $this = $(this);

        $(".terminalVkladani .tlacitko_pp").toggleClass("active", false);
        $this.toggleClass("active", true);

        $("#idpp").val($this.data("ron-idpp"));

        return false;
    };


    $(function() {
        $(".terminalVkladani")
            .on("click", ".tlacitko_operace", onButtonClick)
            .on("click", ".tlacitko_pp", onButtonPPClick);
        setInterval(hodiny, 200);
    });
};


ronPortal.rozdeleniDVDenni = function() {
    var hodnotaEditChange = function()
    {
        var $zbyva = $("#DenniVysledekR_Zbyva");
        if (!$zbyva.length) return;

        var sum = ron.utils.timeStringToFloat($zbyva.data("ron-sum"));

        var cnt = parseInt($("#DenniVysledekR_COUNT").val());

        $(".rozdeleniDV_hodnota").each(function() {
            var $this = $(this);

            var hodnota = $this.val().trim() == '' ? 0 : ron.utils.timeStringToFloat($this.val().trim());

            $this.toggleClass('error', hodnota == null);
            if (hodnota != null) {
                sum -= hodnota;
            }
        });

        sum = sum.toFixed(2);

        $zbyva.text(ron.utils.floatToTimeString(sum));
    };

    $(function() {
        $(".rozdeleniDV_hodnota")
            .on("change", hodnotaEditChange);

        $("#rozdeleniDV_vyberRozdeleni")
            .on("click", function() {
                ronPortal.rozdeleniOsoby_DVDenni($(this).data("ron-idpp"));
            });
    });

    var deleteRowClick = function() {
        var
            $this = $(this);

        var deleteRow = function() {
            var index = $this.data("index");
            var $input = $("#DenniVysledekR" + index + "_DELETE");

            $input.val("1");
            $input.closest("form").submit();
        };

        ron.confirmQuestion($this, deleteRow);
    };

    $(".rozdeleniDVOsoby")
        .on("click",  ".rozdeleni_dv_delete", deleteRowClick);

};

$(function() {
    var zobrazSchvaleni = function() {
        var
            $this = $(this),
            idPP = $this.data('idpp'),
            obdobi = $this.data('obdobi');

        if (idPP  &&  obdobi) {
            ronPortal.dochazka.zobrazSchvaleniDochazky(idPP, obdobi);
        }
    };

    $("#schvalovani_dochazky_seznam")
        .on("click", ".schvalovani_row", zobrazSchvaleni);
});



$(function() {
    var zobrazVyberTerminalu = function() {
        var
            $dialog = $("#vyberTerminaluForm"),
            $this = $(this);

        if ($dialog.length) {
            $("#vyberTerminaluInfoStr").text($this.data("infostr"));
            $("#vyberTerminaluKodOperace").val($this.data("operace"));
            $("#vyberTerminaluCasOperace").val($this.data("timestamp"));
            $("#vyberTerminaluProVkladani").val($this.data("terminal"));

            $dialog.dialog({
                modal: true,
                resizable: true,
                width: "auto",
                height: "auto"
            });
        }
    };

    $(document.body)
        .on("click", ".zaznamPuvodni", zobrazVyberTerminalu);
});


$( function() {
    var showMapUrl = function(event, latitude, longitude) {
        if ( typeof(latitude) == "undefined"  ||  typeof(longitude) == "undefined" ) {
            var $this = $(this);

            latitude = $this.data("latitude");
            longitude = $this.data("longitude");
        }

        var win = window.open("http://maps.google.com/maps?z=1&t=m&q=" + latitude + "+" + longitude, '_blank');
        if (win) win.focus();
    };


    $(document.body)
        .on( "click", ".mapurl", showMapUrl );

});
var onLoadSchvaleni = null;
var zobrazSchvaleniOsoby = null; // je tu pro kompatibilitu se starymi XML, ve kterych bylo: nactiSchvaleniDochazky(idpp, obdobi, zobrazSchvaleniOsoby);
var nactiSchvaleniDochazky = function() {
    console.log("Aktualizace dat formulare schvaleni ...");
    ronPortal.dochazka.aktualizujSchvaleniOsoby();
};
ronPortal.rozdeleniDV = function(data)
{

    var RozdeleniDVZaznam = function() {
        this.rozdeleni = "";
        this.casovaSlozka = "";
        this.id = "";
    };

    var RozdeleniDVDen = function() {
        this.datum = "1.1.1970";
        this.odpracovano = "0:00";
        this.zaznamy = [];
    };

    var RozdeleniDVData = function() {
        this.datumOd = "1.1.1970";
        this.datumDo = "1.1.1970";

        this.idPP = 0;
        this.dny = [];
    };
    var jeZaznamProDen = function(den, rozdeleni) {
        for (var i = 0; i < data.dny[den].zaznamy.length; i++) {
            if (data.dny[den].zaznamy[i].rozdeleni == rozdeleni) {
                return true;
            }
        }

        return false;
    };
    var nactiDataRozdeleni = function(kod) {
        $.ajax("?menuid=rozdelenidv&action=dataRozdeleni&datumod=" + data.datumOd + "&datumdo=" + data.datumDo + "&rozdeleni=" + kod + "&idpp=" + data.idPP)
            .done( function(resultData) {
                console.log(resultData);

                var $rows = $("table.rozdeleniDV tbody tr");
                $rows.toggleClass("locked", false);
                $("table.rozdeleniDV input").attr("disabled", false);

                $("#rozdeleni_dv_schvalit").attr("disabled", !resultData.lzeSchvalit);

                for (var i = 0;  i < resultData.schvaleni.length; i++) {
                    if (resultData.schvaleni[i].hodnota) {
                        var $row = $("table.rozdeleniDV tr[data-ron-datum='" + resultData.schvaleni[i].datum + "']");
                        $row.toggleClass("locked", true);
                        $("#rozdelenidv_" + $row.data("ron-index")).attr("disabled", true);
                    }
                }

                $("table.rozdeleniDV .rozdelenidv2")
                    .val("");

                if (resultData.rozdeleni2) {
                    for (i = 0;  i < resultData.rozdeleni2.length; i++) {
                        $row = $("table.rozdeleniDV tr[data-ron-datum='" + resultData.rozdeleni2[i].datum + "']");
                        $("#rozdelenidv2_" + $row.data("ron-index")).val(resultData.rozdeleni2[i].hodnota);
                    }
                }
                $rows.each( function() {
                    $row = $(this);
                    console.log(this);
                    var index = parseInt($row.data("ron-index"));
                    console.log(index);
                    var $input = $("#rozdelenidv2_" + index);
                    var hidden = !$input.val(); // pokud ma nejakou hodnotu, tak je zobrazen

                    if (hidden) {
                        if (jeZaznamProDen(index, kod)) {
                            hidden = false;
                        }
                    }

                    $input.toggleClass("d-none", hidden);
                });
            })
            .fail(ron.ajaxErrorFunction("Pri nacitani dat doslo k chybe!"));
    };


    var vyberRozdeleni = function() {
        var $this = $(this);

        $("#vyberRozdeleni, #vyberRozdeleniPopis").val($this.val());
        nactiDataRozdeleni($this.val());
        for (var den = 0; den < data.dny.length; den++) {
            for (var i = 0; i < data.dny[den].zaznamy.length; i++) {
                $("#" + data.dny[den].zaznamy[i].id).toggleClass("selected", data.dny[den].zaznamy[i].rozdeleni == $this.val());
            }
        }
    };


    var setDateRange = function() {
        var $datumOd = $("#rozdeleniDV_DatumOd");
        if (!$datumOd.val()) return false;
        var dateFrom = ron.utils.stringToDate($datumOd.val());
        if (!dateFrom) return false;

        var $datumDo = $("#rozdeleniDV_DatumDo");
        if (!$datumDo.val()) return false;
        var dateTo = ron.utils.stringToDate($datumDo.val());
        if (!dateTo) return false;

        for (var i = 0; i < data.dny.length; i++) {
            var datum = ron.utils.stringToDate(data.dny[i].datum);
            $("#rozdelenidv_" + i).css("display", (datum < dateFrom || datum > dateTo) ? "none" : "inline");
        }
    };


    var schvalitRozdeleni = function() {
        var kod = $("#vyberRozdeleni").val();
        if (kod) {
            window.location = "?menuid=rozdelenidv&prehledrozdeleni=" + kod + "&obdobi=" + data.datumOd;
        }
    };


    var rozdeleniItemClick = function() {
        var kod = $(this).data("ron-rozdeleni");
        if (kod) {
            $("#vyberRozdeleni")
                .val(kod)
                .trigger("change");
        }
    };


    $(function() {
        $("#vyberRozdeleni, #vyberRozdeleniPopis")
            .on("change", vyberRozdeleni);

        $("#rozdeleniDV_DatumOd, #rozdeleniDV_DatumDo")
            .on("change", setDateRange);

        $("#rozdeleni_dv_schvalit")
            .on("click", schvalitRozdeleni);

        $(".zaznamrozdelenidv")
            .on("click", rozdeleniItemClick)
    });
};
$(function() {

    var spocitejSoucetSloupce = function(index, count) {
        var sum = 0;

        for (var row = 0;  row < count;  row++) {
            var $edit = $("#hodnota_" + row + "_" + index);

            var hodnota = $edit.val().trim() == '' ? 0 : ron.utils.timeStringToFloat($edit.val().trim());

            $edit.toggleClass('error', hodnota == null);
            if (hodnota != null) {
                sum += hodnota;
            }
        }

        sum = sum.toFixed(2);

        $("#rozdeleniVysledku_sum_" + index)
            .text(ron.utils.floatToTimeString(sum))
            .toggleClass('minus', sum < 0);

        var $odpracovano = $("#rozdeleniVysledku_rozdelit_" + index);
        if ($odpracovano.length) {
            var odpracovano = ron.utils.timeStringToFloat($odpracovano.text().trim());

            $("#rozdeleniVysledku_zbyva_" + index)
                .text(ron.utils.floatToTimeString(odpracovano - sum))
                .toggleClass('minus', sum > odpracovano);
        }
    };
    var spocitejSoucetRadku = function($tr) {
        var
            rowIndex = parseInt($tr.data("rowindex")),
            sum = 0;

        $tr.find(".rozdelenidv_hodiny").each( function() {
            var hodnotaStr = $(this).val().trim();
            var hodnota = hodnotaStr == '' ? 0 : ron.utils.timeStringToFloat(hodnotaStr);

            if (hodnota != null) {
                sum += hodnota;
            }
        });

        $("#celkem_" + rowIndex)
            .text(ron.utils.floatToTimeString(sum));
    };


    var hodinyEditChange = function() {
        var $this = $(this);
        var
            index = parseInt($this.data("index")),
            count = parseInt($this.closest(".rozdeleniDV").data("count"));

        spocitejSoucetSloupce(index, count);
        spocitejSoucetRadku($this.closest("tr"));
    };

    var deleteRowClick = function() {
        var
            $this = $(this);

        var deleteRow = function() {
            var $input = $("#deleteRowIndex");
            $input.val($this.data("row-index"));

            $input.closest("form").submit();
        };

        ron.confirmQuestion($this, deleteRow);
    };

    var remainRowClick = function() {
        var
            $this = $(this);

        var refillRow = function() {
            var $input = $("#remainRowIndex");
            $input.val($this.data("row-index"));

            $input.closest("form").submit();
        };

        ron.confirmQuestion($this, refillRow);
    };

    var nastavPouzivaneRozdeleni = function() {
        var idpp = $(this).data('idpp');

        ronPortal.rozdeleniOsoby_DVHromadne(idpp);
    };

    var loadPouzivaneRozdeleni = function() {
        var url = '?menuid=editace&action=rozdeleniosoby';
        var idpp = $('#rozdelenidv_vyberrozdeleni').data('idpp');

        if (idpp) {
            ronPortal.aktualizujRozdeleniOsoby(url, idpp, [$("#vyberRozdeleni")], [$("#vyberRozdeleniPopis")]);
        }
    };

    var schvalitRozdeleni = function() {
        var $this = $(this);

        if ($this.data('rozdeleni')) {
            window.location = "?menuid=rozdelenidv&prehledrozdeleni=" + $this.data('rozdeleni') + "&obdobi=" + $('#adsfilterform_obdobi').val();
        }
    };

    $(".rozdeleniDV")
        .on("change", ".rozdelenidv_hodiny", hodinyEditChange)
        .on("click", ".rozdelenidv_delete_row", deleteRowClick)
        .on("click", ".rozdelenidv_remain_row", remainRowClick)
        .on('click', '#rozdelenidv_vyberrozdeleni', nastavPouzivaneRozdeleni)
        .on('click', '.rozdeleni_dv_schvalit', schvalitRozdeleni)
    ;

    loadPouzivaneRozdeleni();
});
ronPortal.schvalovaniAbsenci = function(dataSchvalovani) {
    var $form = $(document.hromadneSchvalovaniForm);

    var schvaleniMenu = function () {
        $("#schvaleniMenu").ronPopupMenu( { attachToElement: $(this) } );
        return false; // stop propagation
    };


    var oznacVsechnyAbsence = function() {
        for (var i = 0;  i < dataSchvalovani.items.length;  i++) {
            $("#absencerow_" + i).addClass("browserselectedrow");
            dataSchvalovani.items[i].selected = true;
        }
        $form.find("[name=schvalitVybrane]").removeAttr("disabled");
        $form.find("[name=zamitnoutVybrane]").removeAttr("disabled");
    };

    var odznacVsechnyAbsence = function() {
        for (var i = 0;  i < dataSchvalovani.items.length;  i++) {
            $("#absencerow_" + i).removeClass("browserselectedrow");
            dataSchvalovani.items[i].selected = false;
        }

        $form.find("[name=schvalitVybrane]").prop("disabled", true);
        $form.find("[name=zamitnoutVybrane]").prop("disabled", true);
    };
    function oznacZaznamAbsence() {
        var $this = $(this);

        var index = $this.data("ron-indexabsence");
        if ( index != undefined ) {
            dataSchvalovani.items[index].selected = !dataSchvalovani.items[index].selected;
            $this.toggleClass("browserselectedrow", dataSchvalovani.items[index].selected);
            var selected = dataSchvalovani.items[index].selected;
            var i = 0;

            while (i < dataSchvalovani.items.length  && !selected) {
                selected = dataSchvalovani.items[i].selected;
                i++;
            }

            document.hromadneSchvalovaniForm.schvalitVybrane.disabled = !selected;
            document.hromadneSchvalovaniForm.zamitnoutVybrane.disabled = !selected;
        }
    }


    function zapisZaznamyAbsence(jenVybrane, akce) {
        ron.showWorkingInfo();

        var vybraneStr = '';

        var result = 0;

        for (var i = 0;  i < dataSchvalovani.items.length;  i++) {
            if ( dataSchvalovani.items[i].selected  ||  !jenVybrane ) {
                vybraneStr += dataSchvalovani.items[i].idpp + ";" + dataSchvalovani.items[i].datum + ";" + dataSchvalovani.items[i].poradi + "\n";
                result ++;
            }
        }

        document.hromadneSchvalovaniForm.vybraneZaznamy.value = vybraneStr;
        document.hromadneSchvalovaniForm.akceHromadneSchvaleni.value = akce;
        document.hromadneSchvalovaniForm.submit();

        return result;
    }


    var schvalitVybraneAbsence = function() {
        zapisZaznamyAbsence(true, 1); // 1=schvalit
    };

    function zamitnoutVybraneAbsence() {
        zapisZaznamyAbsence(true, 2); // 2=zamitnout
    }

    function schvalitVsechnyAbsence() {
        zapisZaznamyAbsence(false, 1); // 1=schvalit
    }



    $("#schvaleniMenuButton")
        .on("click", schvaleniMenu);

    $("#schvaleniMenuVse")
        .on("click", oznacVsechnyAbsence);

    $("#schvaleniMenuNic")
        .on("click", odznacVsechnyAbsence);

    $("#schvalovaniAbsenciTable")
        .on("click", "tr", oznacZaznamAbsence);

    $("#schvalitVybraneAbsence")
        .on("click", schvalitVybraneAbsence);

    $("#zamitnoutVybraneAbsence")
        .on("click", zamitnoutVybraneAbsence);

    $("#schvalitVsechnyAbsence")
        .on("click", schvalitVsechnyAbsence);
};

$(function() {
    var
        $table = $("#smenyKalendareForm"),
        $menu = $("#smenyKalendareMenu"),
        pouzivatSablony = $table.data("pouzivat-sablony") == "1",
        obdobi = $table.data("obdobi"),
        selectionTable = null,
        rozdeleniMenu = null,
        sablonyNacteny = false;  // kod rozdeleni, pro ktere je nacten seznam sablon a zobrazeno schvalovani


    var nactiSeznamSablon = function(kodRozdeleni) {

        if (kodRozdeleni == rozdeleniMenu  &&  sablonyNacteny) {
            return; // uz je nacteno
        }

        var processData = function(resultData) {

            $menu.children(".povolenaSablona").remove();

            if (resultData.sablony  &&  resultData.sablony.length) {
                for (var i = resultData.sablony.length - 1; i >= 0;  i--) {
                    $("<li/>")
                        .addClass("povolenaSablona")
                        .text(resultData.sablony[i].popis + " (" + resultData.sablony[i].zkratka + ")")
                        .data("id", resultData.sablony[i].id)
                        .prependTo($menu);
                }
            }

            if (rozdeleniMenu == kodRozdeleni) {
                sablonyNacteny = true;
            }
        };


        if (kodRozdeleni != rozdeleniMenu) {
            $menu.children(".povolenaSablona").remove();

            $("<li/>")
                .addClass("povolenaSablona loading")
                .append( $("<div><i class='float-right fa fa-spin glyph-spinner loading-indicator'></i></div>"))
                .append("<span>...</span>")
                .prependTo($menu);
            data = { "rozdeleni" : kodRozdeleni };
            $.ajax( {
                url: "?menuid=smenykalendare&action=seznamsablon",
                type: "GET",
                data : data
            })
                .done( processData )
                .fail( ron.ajaxErrorFunction("Pri nacitani seznamu sablon doslo k chybe!") );
        }

        rozdeleniMenu = kodRozdeleni;
    };


    var onMenuClick = function(event, data) {
        var $this = $(this);

        if ($this.is("#smenyKalendare_vypnout")) {
            zrusSmeny();
            return;
        }

        if ($this.is("#smenyKalendare_schvaleni1")) {
            nastavSchvaleni(1);
            return;
        }
        if ($this.is("#smenyKalendare_schvaleni2")) {
            nastavSchvaleni(2);
            return;
        }
        if ($this.is("#smenyKalendare_schvaleni3")) {
            nastavSchvaleni(3);
            return;
        }


        var idSablony = $this.data("id");

        console.log("idSablony: ", idSablony);
        if (idSablony) {
            pridejSmeny(idSablony);
        }
    };


    var zobrazMenu = function() {
        var
            $cell = selectionTable.getSelectedCell(),
            $row = $cell.parent(),
            kodRozdeleni = $row.data("rozdeleni");

        nactiSeznamSablon(kodRozdeleni);
        var den = $cell.data("den");
        $("#smenyKalendare_hodnotaschvaleni1").text(den);
        $("#smenyKalendare_hodnotaschvaleni2").text(den);
        $("#smenyKalendare_hodnotaschvaleni3").text(den);

        $menu.ronPopupMenu({
            attachToElement: $cell,
            onClose: function() {
                $table.parent().focus();
            },
            onClick: onMenuClick
        });
    };


    var nastavSchvaleni = function(uroven) {
        var
            $cell = selectionTable.getSelectedCell(),
            den = $cell.data("den"),
            rozdeleni = rozdeleniMenu;

        var processData = function(data) {
            ron.showError(data);
            console.log(data);
            var
                $row = $("tr.schvaleni[data-rozdeleni='" + rozdeleni + "']"),
                $ths = $row.children(),
                schvaleni1 = data.schvaleni1 ? ron.utils.stringToDate(data.schvaleni1) : null,
                schvaleni2 = data.schvaleni2 ? ron.utils.stringToDate(data.schvaleni2) : null,
                schvaleni3 = data.schvaleni3 ? ron.utils.stringToDate(data.schvaleni3) : null;

            $ths.each( function() {
                console.log("this", this);
                var
                    $th = $(this),
                    datumStr = $th.data("den"),
                    datum = datumStr ? ron.utils.stringToDate(datumStr) : null;

                if (datum) {
                    $th.removeClass("schvaleni1").removeClass("schvaleni2").removeClass("schvaleni3");

                    if (schvaleni3  &&  schvaleni3 >= datum) {
                        $th.addClass("schvaleni3");
                    } else if (schvaleni2  &&  schvaleni2 >= datum) {
                        $th.addClass("schvaleni2");
                    } else if (schvaleni1  &&  schvaleni1 >= datum) {
                        $th.addClass("schvaleni1");
                    }
                }
            });
        };

        data = {
            rozdeleni: rozdeleni,
            obdobi: obdobi,
            uroven: uroven,
            datum: den
        };

        $.ajax( {
            url: "?menuid=smenykalendare&action=nastavschvaleni",
            type: "POST",
            data : data
        })
            .done( processData )
            .fail( ron.ajaxErrorFunction("Pri schvalovani doslo k chybe!") );
    };
    var pridejSmeny = function(idSablony) {
        var $rows = $table.find("tr");

        selectionTable.forEachInterval( function(row, col1, col2) {
            var
                $row = $rows.eq(row),
                $cols = $row.children(),
                $col1 = $cols.eq(col1),
                $col2 = $cols.eq(col2);

            var data = {
                "smena" : $row.data("smena"),
                "rozdeleni" : $row.data("rozdeleni"),
                "kalendar" : $row.data("kalendar"),
                "datumOd" : $col1.data("den"),
                "datumDo" : $col2.data("den")
            };

            if (idSablony) {
                data.sablonaPodminek = idSablony;
            }
            var processData = function(resultData) {
                ron.showError(resultData);
                console.log(resultData);

                if (resultData.result == "OK") {
                    for (var col = col1;  col <= col2;  col++) {
                        $cols.eq(col)
                            .text(resultData.sablona && resultData.sablona.zkratka ? resultData.sablona.zkratka : "x")
                            .attr("title", resultData.sablona && resultData.sablona.popis ? resultData.sablona.popis : "");
                    }
                }

                selectionTable.refreshSelection();
            };

            $.ajax( {
                url: "?menuid=smenykalendare&action=zapnismenu",
                type: "GET",
                data : data
            })
                .done( processData )
                .fail( ron.ajaxErrorFunction("Pri aktivaci smen doslo k chybe!") );
        });
    };



    var zrusSmeny = function() {
        var $rows = $table.find("tr");
        selectionTable.forEachInterval( function(row, col1, col2) {
            var
                $row = $rows.eq(row),
                $cols = $row.children(),
                $col1 = $cols.eq(col1),
                $col2 = $cols.eq(col2);

            var data = {
                "smena" : $row.data("smena"),
                "rozdeleni" : $row.data("rozdeleni"),
                "kalendar" : $row.data("kalendar"),
                "datumOd" : $col1.data("den"),
                "datumDo" : $col2.data("den")
            };

            var processData = function(resultData) {
                ron.showError(resultData);

                if (resultData.result == "OK") {
                    for (var col = col1;  col <= col2;  col++) {
                        $cols.eq(col)
                            .empty()
                            .removeAttr("title");
                    }
                }

                selectionTable.refreshSelection();
            };

            $.ajax( {
                url: "?menuid=smenykalendare&action=vypnismenu",
                type: "GET",
                data : data
            })
                .done( processData )
                .fail( ron.ajaxErrorFunction("Pri ruseni smen doslo k chybe!") );
        });
    };

    var beforeSelectCell = function(data) {
        $(document).ronPopup("closeAll");

        if (data && data.x < 2) {
            return false; // zahlavi tabulky (rozdeleni) nelze oznacit
        }
    };
    var onKeyPress = function(e) {
        switch (e.which) {
            case 32 : // break
                pridejSmeny();
                return false;

            case 13 :
                zobrazMenu();
                return false;
        }
    };

    var onKeyDown = function(e) {
        switch (e.which) {
            case 46 : // delete
                zrusSmeny();
                break;
        }
    };

    var onMouseUp = function($event) {
        if ($event.which == 3) {
            zobrazMenu();
        }
    };

    var clickTimer = null;

    var onSelectionClick = function(data) {
        if (clickTimer) {
            clearTimeout(clickTimer);
            clickTimer = null;
        } else {
            clickTimer = setTimeout(function () {
                clickTimer = null;
            }, 200);
        }
    };


    var onSelectionDblClick = function(data) {
        if (clickTimer) {
            clearTimeout(clickTimer);
            clickTimer = null;
        }

        pridejSmeny();
    };


    $table.selectiontable({
        beforeSelectCell: beforeSelectCell,
        onSelectionClick: onSelectionClick,
        onSelectionDblClick: onSelectionDblClick,
        $focusElement: $table.parent()
    });

    selectionTable = $table.selectiontable("instance");

    $table.parent()
        .on("keypress", onKeyPress)
        .on("keydown", onKeyDown)
        .on("contextmenu", function() { return false; })
        .on("mouseup", onMouseUp);
});
