ronPortal.hodnoceni = function()
{
    // zvyrazneni vybrane odpovedi
    var onRadioChange = function() {
        var $this = $(this);

        var name = $this.attr("name");
        var value = $this.val();

        var $items = $('input[name="' + name + '"]');
        $items.parent().toggleClass("hodnocenichecked", false); // odznaci vsechny
        $this.parent().toggleClass("hodnocenichecked", true);   // oznaci vybrany

        //$items.each( function() {
        //    $(this).parent().toggleClass("hodnocenichecked", $(this).prop("checked"));
        //});
    };


    // zvyrazneni vybranych odpovedi
    var onCheckboxChange = function() {
        var $this = $(this);
        $this.parent().toggleClass("hodnocenichecked", $this.prop('checked'));
    };


    $(".dotaznik")
        .on("change", "input:radio", onRadioChange)
        .on("change", "input:checkbox", onCheckboxChange)
    ;
};


ronPortal.hromadneHodnoceni = function()
{
    if (debugMode) console.log('Inicializace hromadneho schvalovani ...');

    var selectAll = function(value) {
        $("#browserseznamhodnoceni").find("input:checkbox").each(function () {
            var $checkbox = $(this);

            if (!$checkbox.disabled && $checkbox.attr("name").substr(0, 18) == 'hodnocenicheckbox_') {
                $checkbox.prop("checked", value);
            }
        });
    };

    $("#vyberVsechnaHodnoceni")
        .on("click", function() { selectAll(true); } );

    $("#zrusVyberHodnoceni")
        .on("click", function() { selectAll(false); } );

    //ron.ronTable( $("#browserseznamhodnoceni") )
};

ronPortal.hodnoceniDialog = {

    odesliDataDialogu : function (url, data, callback) {
        $.ajax(
            {
                url : url,
                type: "POST",
                data : data
            }).done( function(responseData) {
            if ( responseData.result === "OK" ) {
                //window.location.replace(window.location);
                callback.call();
            } else {
                ron.showError(responseData);
            }
        }).fail( function(jqXHR) {
            ron.showAjaxError(jqXHR, "Pri hodnoceni doslo k chybe!");
        });
    },

    provedGenerovaniHodnoceni : function () {
        var ucel = $('#hodnocenigenerovani_ucel').val();
        var datumOd = $('#hodnocenigenerovani_datumod').val();
        var pocetObdobi = $('#hodnocenigenerovani_pocet_obdobi').val();
        var pocet = $('#hodnocenigenerovani_pocet').val();
        var idPP = $('#idpp').val();

        var url = "?menuid=hodnoceniosob&action=generovani";
        var data = {
            idpp : idPP,
            ucel : ucel,
            datumod: datumOd,
            pocetobdobi: pocetObdobi,
            pocet: pocet
        };

        ronPortal.hodnoceniDialog.odesliDataDialogu(url, data,
            /**
             * Funkce zavre dialog a provede aktualizaci radku browseru
             */
            function () {
                //TODO refresh stranky?
                window.location = "?menuid=hodnoceniosob&datumpocatku=" + datumOd + "&ucel=" + ucel;
                // $("#hodnocenigenerovani_dialog").dialog("close");
            });
    },
    nastavHodnotitele : function () {
        var idhodnoceni = $('#idhodnoceni').val();
        var hodnotitel = $('#hodnocenigenerovani_hodnotitel').val();

        var url = "?menuid=hodnoceniosob&action=nastavhodnotitele";
        var data = {
            idhodnoceni : idhodnoceni,
            hodnotitel : hodnotitel
        };

        ronPortal.hodnoceniDialog.odesliDataDialogu(url, data,
            /**
             * Funkce zavre dialog a provede aktualizaci radku browseru
             */
            function () {
                $('[data-id="' + idhodnoceni + '"]')
                    .html($('#hodnocenigenerovani_hodnotitel_view').val())
                    .removeClass();
                $("#hodnoceninastavenihodnotitele_dialog").dialog("close");
            });
    },

    onComboUcelChange : function(index, options) {
        var $this = $(this);

        var keyField = 'kod';
        var fieldsData = $this.data('ron-combo-fields');

        if (fieldsData !== undefined) {
            keyField = fieldsData.split(';')[0];
        }

        if (options.items[index]['povolit_duplicitu'])
            $('#hodnocenigenerovani_row_pocet').show();
        else
            $('#hodnocenigenerovani_row_pocet').hide();

        var hiddenInputName = $this.data('ron-combo-code');
        $('[name="' + hiddenInputName + '"]').val(options.items[index][keyField]);
    },

    /**
     * Zobrazeni formulare pro vygenerovani hodnoceni osobe
     */
    zobrazData : function(data, typFormulare) {
        if (!data) return;

        var ronSelectID = '';

        var onChangeFn = ronPortal.ronCombo.onComboChange;

        if (typFormulare == 'generovani') {
            ronSelectID = '#hodnocenigenerovani_ucel_view';
            columns = ["kod", "popis"];
            onChangeFn = ronPortal.hodnoceniDialog.onComboUcelChange;
        } else if (typFormulare == 'nastavhodnotitele') {
            ronSelectID = '#hodnocenigenerovani_hodnotitel_view';
            columns = ["osc", "popis"];
        }

        var spinner = $(ronSelectID).data('ron-combo-spinner');

        var $combo = $(ronSelectID);

        $('#'+spinner).hide();

        $combo.ronselect({
            items: data.items,
            columns: columns,
            maxVisibleRows: 30,
            textColumn: ["popis"],
            valueColumn: "kod",
            onChange: onChangeFn
        });
        $combo.ronselect("setItems", data.items);
    },

    initDialog : function (id, typFormulare) {
        var dialogID = '';
        var url = '';
        var fn;
        var ronSelectID = '';

        if (typFormulare == 'generovani') {
            $('#idpp').val(id);
            url = "?menuid=hodnoceniosob&action=nactiucely&idpp=" + id;
            dialogID = '#hodnocenigenerovani_dialog';
            ronSelectID = '#hodnocenigenerovani_ucel_view';
            fn = ronPortal.hodnoceniDialog.provedGenerovaniHodnoceni;
        } else if (typFormulare == 'nastavhodnotitele') {
            $('#idhodnoceni').val(id);
            url = "?menuid=hodnoceniosob&action=nactiosoby&idhodnoceni=" + id;
            dialogID = '#hodnoceninastavenihodnotitele_dialog';
            ronSelectID = '#hodnocenigenerovani_hodnotitel_view';
            fn = ronPortal.hodnoceniDialog.nastavHodnotitele;
        }

        var spinner = $(ronSelectID).data('ron-combo-spinner');
        $('#'+spinner).show();

        $(dialogID).dialog( {
            modal : true,
            resizable: false,
            width: "auto",
            height: "auto"
        });

        $(".btnHodnoceniOK").prop('disabled', '');

        $.ajax(url)
            .done( function(data) {
                if (debugMode) console.log("Natena data pro generovn hodnocen: ", data);

                if (data.result === "OK") {

                    ronPortal.hodnoceniDialog.zobrazData(data, typFormulare);

                    //registrace udalosti pro tlacitka
                    $(".btnStornoHodnoceni")
                        .off("click")
                        .on("click", function() {
                            $(dialogID).dialog("close");
                        });

                    $(".btnHodnoceniOK")
                        .off("click")
                        // .on("click", fn, $sender);
                        .on("click", function () {
                            fn();
                            $(this).prop('disabled', 'disabled');
                        });
                } else {
                    ron.showError(data);
                }

            }).fail( function(jqXHR) {
            ron.showAjaxError(jqXHR, "Pi natn dat pro generovn dolo k chyb!");
        });
    },

     zobrazDialog : function() {
        ronPortal.hodnoceniDialog.initDialog($(this).data('id'), $(this).data("typdialogu"));
    }
};

ronPortal.hodnoceniBrowser = {
    expandVysledky : function () {
        var $this = $(this);
        var selExpand = $this.data('expand-selector');
        var selHide = $this.data('hide-selector');
        var selector = $this.data('selector');
        var expandedSelector = $this.data('expanded-selector');
        var expanded = $this.data('expanded') || $this.hasClass('expanded');

        if (expanded === undefined)
            expanded = false;

        if (selector !== undefined) {
            selHide = selector;
            selExpand = selector;
        }

        if (expanded) {
            $(selHide).removeClass($this.data('toggle-class'));
            $(selHide).addClass($this.data('toggle-class'));
            $(selHide).children('.hodnoceniToggle').removeClass('expanded');

            if (expandedSelector !== undefined) {
                $(expandedSelector).not(this).removeClass('expanded');
                $this.html(ron._('Zobrazit_vse'));
            } else {
                $this.removeClass('expanded');
            }
        }
        else {
            $(selExpand).removeClass($this.data('toggle-class'));
            if (expandedSelector !== undefined) {
                $(expandedSelector).not(this).addClass('expanded');
                $this.html(ron._('Skryt_vse'));
            } else {
                $this.addClass('expanded');
            }
        }

        $this.data('expanded', !expanded);

        return false;
    }
};


function hromadneUzavreniHodnoceni(senderbtn) {
    var hodnoceni_prerusit = false; // priznak, jestli uzivatel stisknul "prerusit"

    var isError = false;

    //var checkboxes = $("input:checkbox");
    var checkboxes = $("#browserseznamhodnoceni").find("input:checkbox");

    var progressScreen = ron.showProgressScreen(ron._('Probiha_hromadne_schvalovani'), checkboxes.length, prerusitOdesilani);


    function prerusitOdesilani() {
        hodnoceni_prerusit = true; // nastavi priznak

        $(this)
            .val("zastavuji ...")
            .attr("disabled", true);
    }



    function zavritHodnoceni() {
        window.location = '?menuid=hodnoceni';
    }


    function konecHodnoceni() {
        if (isError) {
            progressScreen.setButton(ron._("Zavrit"), zavritHodnoceni);
            progressScreen.setInfoMessage('');
            return false;
        }
        else {
            zavritHodnoceni();
            return true;
        }
    }



    function uzavriDalsi(i) {
        var selected = -1;
        var $checkbox = null;

        // najde prvni, ktery se ma uzavrit
        while (i < checkboxes.length  &&  selected < 0) {
            $checkbox = $(checkboxes.get(i));
            if ( $checkbox.attr("name").substr(0, 18) == 'hodnocenicheckbox_') {
                if ( !$checkbox.prop("disabled")  &&  $checkbox.prop("checked") ) {
                    selected = i;
                }
            }

            // nastavi posuvnik
            progressScreen.setProgress(i, null, ron._("Hromadne__hodnoceni_cislo") + ' ' + $checkbox.attr("name").substring(18));

            i++;
        }


        // kontrola preruseni uzivatelem
        if (hodnoceni_prerusit) {
            progressScreen.addMessage(ron._("Hromadne_hodnoceni_preruseno"));
            selected = -1;

            isError = true;
        }


        if (selected < 0) return konecHodnoceni();
        // odesilani preruseno uzivatelem nebo je na konci (nenasel uz zadny vybrany checkbox)


        var id = $(checkboxes.get(selected)).attr("name").substring(18); // vypreparuje cislo dotazniku

        $.ajax( "?menuid=hodnoceni&hodnoceniaction=hromadneuzavrenidotazniku&id=" + id )
            .done( function(data) {
                if (data.result == "OK") {
                    $(checkboxes.get(selected)).prop("disabled", true);
                }
                else {
                    isError = true;

                    if (data.errors) {
                        for (var i = 0; i < data.errors.length; i++) {
                            progressScreen.addMessage(data.errors[i].errorText);
                        }
                    }
                }

                uzavriDalsi(selected + 1);
            })
            .fail( function(jqXHR) {
                progressScreen.addMessage(ron._("Chyba_odesilani_hodnoceni") + " (" + jqXHR.status + " - " + jqXHR.statusText + ")");
                console.log(jqXHR.responseText);

                uzavriDalsi(selected + 1);
            });
    }


    uzavriDalsi(0, false);
}

$(function() {
    $(document.body)
        .on('click', '.generovani, .nastavhodnotitele', ronPortal.hodnoceniDialog.zobrazDialog)
        .on('click', '.hodnoceniToggle', ronPortal.hodnoceniBrowser.expandVysledky);
});