


function showDokumentZmenyUploadDialog(id, backurlzmeny) {
    var dokumentZmenyResult = function (result) {
        var urlAttr = "";
        if(backurlzmeny === 1){
            urlAttr = "&backurlzmeny=osobniudaje";
        }
        processDokumentResult(result, '?menuid=nahlasenezmeny&action=detail&record=' + id + urlAttr)
    };
    ronPortal.showDokumentDialog(dokumentZmenyResult);
}


$(function () {
    var onMestoSelected = function($e) {
        var
            select = $(this).ronselect("instance"),
            selectedItem = select.options.items[select.itemIndex()];

        if (selectedItem) {
            if (selectedItem.psc) {
                $("input[name='PSC']").val(selectedItem.psc);
            }

            if (selectedItem.obec) {
                $("select[name='Obec']").ronselect("instance").value(selectedItem.obec);
            }
        }
    };


    $(".select-mesto")
        .on("itemactivate", onMestoSelected);


    var odkazVyhledejOborVzdelani = function()
    {
        var odkaz = $('#OborVzdelaniISPV-vyhledej');
        var oborDleISPV = $('#OborVzdelaniISPV');

        $(odkaz).bind('click', function (e) {
            var chyba = false;
            var url = 'https://www.obory-vzdelani.cz';
            var mistoStudia = $('input[name=MistoStudia]:checked').val();
            var typVzdelani = $("select[name='TypVzdelani']").val();
            var datumUkonceni = $("[name='DatumUkonceni']");
            var rok = $(datumUkonceni).val().split('.')[2];

            if(mistoStudia == 0){
                url += "/misto-CR";
            } else {
                url += "/misto-Z";
            }

            if(rok){
                url += "/rok-" + rok;
            } else {
                chyba = true;
                ron.showError(ron.translate('zmeny_neni_rok_ukonceni_studia'));
            }

            if(mistoStudia == 0){

                switch (parseInt(typVzdelani)) {
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 7:
                        url += "/typ-SSB";
                        break;

                    case 8:
                    case 9:
                    case 10:
                        url += "/typ-SSS";
                        break;

                    case 11:
                         url += "/typ-VOS";
                        break;

                    case 12:
                         url += "/typ-VSB";
                        break;

                    case 13:
                         url += "/typ-VSM";
                        break;

                    case 14:
                         url += "/typ-VSD";
                        break;

                }

            } else {

                switch (parseInt(typVzdelani)) {
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 7:
                        url += "/typ-SSC";
                        break;

                    case 8:
                    case 9:
                    case 10:
                        url += "/typ-SSC";
                        break;

                    case 11:
                         url += "/typ-VSC";
                        break;

                    case 12:
                         url += "/typ-VSC";
                        break;

                    case 13:
                         url += "/typ-VSC";
                        break;

                    case 14:
                         url += "/typ-VSC";
                        break;

                }
            }

            console.log(url);

            e.preventDefault();
            if(!chyba){
                window.open(url);
                $(oborDleISPV).focus();
            }
        });
    };



    odkazVyhledejOborVzdelani();
});
