


var debugMode = 0;

var ronPortal = {
    zkontrolujPravo : function (idPP, typPrava) {
        var callback = null;
        var typPrava2 = undefined;

        for (var i = 0; i < arguments.length; i++) {
            if (typeof(arguments[i]) == 'function') callback = arguments[i];
            else typPrava2 = arguments[i];
        }

        var url =
            "?menuid=utils&action=prava&idpp=" + idPP + "&typprava=" + typPrava +
            (typPrava2 ? "&typprava2=" + typPrava2 : "");

        var result = false;

        $.ajax(url, {
            async: (callback ? true : false)
        }).done(function (data) {
            if (callback) callback(data.result);
            else result = data.result;
        }).fail(function (jqXHR) {
            ron.showAjaxError(jqXHR, "Pri nacitani prav doslo k chybe!");
        });

        return callback ? true : result;
    }

};
function zkontrolujPravo(idPP, typPrava, callBack) {
    console.log('FUNKCE zkontrolujPravo je deprecated! Pouzijte ronPortal.zkontrolujPravo');
    return ronPortal.zkontrolujPravo(idPP, typPrava, callBack);
}
function VyberRozdeleni(sender)
{
    var value = sender.value;

    sender.form.rozdeleni.value = value;
    sender.form.rozdeleni_kod.value = value;

    sender.form.submit();
}
ronPortal.dateStringFromRC = function () {
    var elementRC = $(this);
    var rodneCislo = $(this).val().toString();
    var rodneCisloToDatumNarozeni = function (rodneCislo) {
        var year = Number();
        var month = Number();
        var day = Number();
        var rc = '';
        var index = Number();
        var currentYear = new Date().getFullYear();

        var result = 0;
        rc = rodneCislo.replace(/[/\\\-\s]/g, ''); //odstraneni mezer, lomitek, pomlcek

        if (rc.length < 9) throw rodneCislo + ' nesplnuje minimalni delku';

        if (isNaN(rc)) throw rodneCislo + ' nelze prevest na cislo';

        if (rc.length > 6) {
            year = parseInt('19' + rc.substr(0, 2));

            if ((year < 1954) && (rc.length > 9))
                year = year + 100;
        }
        else {
            year = parseInt('20' + rc.substr(0, 2));
            if (year > currentYear)
                year = year - 100;
        }

        try {
            month = parseInt(rc.substr(2, 2));
            if (month > 50)
                month = month - 50;
            day = parseInt(rc.substr(4, 2));

            if (isValidDate(year, month, day)) {
                if (debugMode) console.log('rok: ' + year, 'mesic: ' + month, 'den: ' + day);
                result = new Date(year, month-1, day);
            }
        }
        catch (err) {
            throw rodneCislo + ' nelze prevest na datum narozeni.' + '\n' + err.toString();
        }

        $(elementRC).val(rc);
        return result;
    };
    var isValidDate = function (year, month, day) {
        if (!((month >= 1) && (month <= 12))) {
            throw month + " neni platny mesic";
        }
        if (!((day >= 1) && (day <= 31))) {
            throw day + " neni platny den";
        }

        var datum = new Date();
        try {
            datum.setFullYear(year);
            datum.setMonth(month);
            datum.setDate(day);
        }
        catch (err) {
            throw "Chybny format data." + err.toString();
        }

        return true;
    };


    $(elementRC).removeClass('app_input_error').prop('title','');

    try {
        $('input[name=' + $(elementRC).data('ronrc-inputdatename') + ']').val(ron.utils.dateToString(rodneCisloToDatumNarozeni(rodneCislo)));
    }
    catch (err) {
        ron.showError(err);
        $(elementRC).addClass('app_input_error').prop('title',err);
    }
};

ronPortal.disableInputs = function (cssClass) {
    var stopPropagation = function (e) {
        e.stopImmediatePropagation();
        return false;
    };

    $('.' + cssClass + ' input:text')
        .prop('readonly', true)
        .addClass('form_readonly');

    $('.' + cssClass + ' input:checkbox')
        .prop('disabled', true);

    $('.' + cssClass + ' .app_combo')
        .prop('disabled', true)
        .addClass('form_readonly');

    $('.' + cssClass + ' .showcalendar')
        .on('click', stopPropagation);

    $('.' + cssClass + ' .js')
        .on('click', stopPropagation);

};
ronPortal.ronFoto =  {
    nastavZobrazeni : function (elemImg) {
        var elemBox;
        var newElem;
        var doba = 500;
        var efekt = "scale";
        newElem = $('<div class="ronFoto_full"><img src="'+$(elemImg).prop("src")+'" alt="'+$(elemImg).prop("alt")+'" ></div>');
        $(elemImg).parent().before($(newElem));
        elemBox = $(newElem);
        $(elemImg)
            .on('click',function () {
                $(elemBox)
                    .css('left',$(this).position().left - (($(elemBox).width() - $(this).width())/2))
                    .css('top',$(this).position().top - (( $(elemBox).height() - $(this).height())/2))
                    .show(efekt,doba)
                    .on('click', function () {
                        $(this).hide(efekt,doba);
                        return false;
                    });
                return false;
            });
    },

    nastavInfoZobrazeni : function (elem) {
        var newElem;

        var alt = '';

        if ($(elem).data("foto-alt") !== undefined) {
            alt = 'alt="'+$(elem).data("foto-alt")+'"';
        }
        newElem = $('<div class="ronInfoFoto_full" id="'+$(elem).prop('id') + '_full' + '"><img src="'+$(elem).data("foto-url")+'"' + alt + '></div>');
        $(elem).after($(newElem));
    },

    zobrazNahled : function () {
        var $fotoSpan = $(this); //"info" obrazek, po najeti mysi se zobrazuje obrazek z fotodiv
        var $fotoDiv = $('#'+$fotoSpan.prop('id')+'_full');

        $fotoDiv.show();
        var windowWidth = $(window).scrollLeft() + $(window).width();
        var boxRight = $fotoSpan.position().left + $fotoDiv.find('img').width();
        if (boxRight > windowWidth) {
            $fotoDiv.css('left', $fotoSpan.position().left - $fotoDiv.find('img').width());
        }
        else {
            $fotoDiv.css('left', 'auto');
        }

        var bottomView = $(window).scrollTop() + $(window).height();
        var bottomBox = $fotoSpan.position().top + $fotoDiv.find('img').height();
        if (bottomBox > bottomView) {
            var topPosImg = $fotoSpan.position().top;
            if ($fotoSpan.parents('tr').length > 0) {
                topPosImg = $fotoSpan.parents('tr').position().top;
            }

            $fotoDiv.css('top', topPosImg - $fotoDiv.find('img').height());
        }
        else {
            $fotoDiv.css('top', 'auto');
        }
    },

    skryjNahled : function () {
        $('#'+$(this).prop('id') + '_full').hide();
    },

    init : function () {
        $('.ronFoto').each(function (index, element) {
            ronPortal.ronFoto.nastavZobrazeni($(element).find('img'));
        });
        $('.ronInfoFoto').each(function (index, element) {
            ronPortal.ronFoto.nastavInfoZobrazeni($(element));
        });

    }

};


$(function() {
    var
        nastavPriznaky = function($priznaky, data) {
            $priznaky
                .removeClass('pritomen')
                .removeClass('nepritomen');

            $priznaky.each(function() {
                var
                    $this = $(this),
                    idpp = $this.data("idpp"),
                    cssClass = "";

                    if (data[idpp]) {
                        cssClass = data[idpp].pritomnost ? 'pritomen' : 'nepritomen';
                    }

                    if (cssClass) {
                        $this
                            .addClass(cssClass)
                            .prop('title', data[idpp].popisoperace + ': ' +  data[idpp].datumcasoperace);
                    }
            });
        },

        nactiPritomnost = function($container, callBack) {
            var
                $priznaky = $container.find(".pritomnost_info"),
                url = $container.data('ron-pritomnost-url');

            if (!$priznaky.length) {
                if (callBack) {
                    setTimeout(callBack, 1);
                }
                return;
            }

            if (url) {
                $.ajax(url)
                    .done(function (data) {
                        nastavPriznaky($priznaky, data.data);
                    })
                    .fail(function (jqXHR) {
                        console.log(jqXHR.responseText);
                    })
                    .always(function () {
                        if (callBack) {
                            callBack();
                        }
                    });

            }
        },

        $containers = $(".pritomnost-container"),
        index = null,

        nactiDalsiPritomnost = function() {
            index = (index == null) ? 0 : index + 1;

            if (index < $containers.length) {
                nactiPritomnost($containers.eq(index), nactiDalsiPritomnost);
            } else {
                index = null;
                setTimeout(nactiDalsiPritomnost, 120000);
            }
        };


    if ($containers.length) {
        setTimeout(nactiDalsiPritomnost, 2000);
    }

});

ronPortal.ronCombo = {
    onComboChange : function(index, options) {
        var $this = $(this);

        var keyField = 'kod';
        var fieldsData = $this.data('ron-combo-fields');

        if (fieldsData !== undefined) {
            keyField = fieldsData.split(';')[0];
        }

        var hiddenInputName = $this.data('ron-combo-code');

        var newValue = null;
        if (index !== null) {
            newValue = options.items[index][keyField];
        }

        $('[name="' + hiddenInputName + '"]').val(newValue);
    },
    nactiData : function ($elems, callback, comboBoxChange) {
        var $firstElem = $elems.first();
        var url = $firstElem.data('ron-combo-url');

        var fields = ['kod', 'popis'];
        var fieldsData = $firstElem.data('ron-combo-fields');

        if (fieldsData !== undefined) {
            fields = fieldsData.split(';');
        }

        var textField = 'popis';
        var textFieldData = $firstElem.data('ron-combo-text-field');

        if (textFieldData !== undefined) {
            textField = textFieldData;
        }

        var onChangeEvent = ronPortal.ronCombo.onComboChange;
        if (comboBoxChange)
            onChangeEvent = comboBoxChange;

        if (url) {
            $.ajax(url)
                .done(function (data) {
                    $elems.each(function () {
                        var $this = $(this);

                        var hiddenInputName = $this.data('ron-combo-code');
                        var $hiddenInput    = $('[name="' + hiddenInputName + '"]');
                        var puvodniHodnota = $hiddenInput.val();
                        var spinner = $this.data('ron-combo-spinner');
                        $('#' + spinner).hide();

                        if (data.result === "OK") {
                            if ($this.data('ron-combo-selectfirst') && (puvodniHodnota === '') && (data.items.length === 1)) {
                                puvodniHodnota = data.items[0].kod;
                                $hiddenInput.val(puvodniHodnota)
                            }

                            $this.ronselect({
                                items: data.items,
                                columns: fields,
                                maxVisibleRows: 30,
                                textColumn: textField,
                                valueColumn: "kod",
                                onChange: onChangeEvent,
                                initialValue: puvodniHodnota
                            });
                        } else {
                            ron.showError(data);
                        }
                    });
                    if (callback)
                        callback.call();
                })
                .fail(function () {

                });

        }
    },
    nastavCombo : function () {
        var $selectCombo = $(".ron_select_combo");

        var comboGroup = '';
        var groups = [];

        if ($selectCombo.length > 0) {
            $selectCombo.each(function () {
                comboGroup = $(this).data('ron-combo-group');

                if ($.inArray(comboGroup, groups) === -1) {
                    groups.push(comboGroup);
                }
            });
            $(groups).each(function () {
                ronPortal.ronCombo.nactiData($selectCombo.filter("input[data-ron-combo-group='" + this + "']"));
            });
        }
    }

};

$( function() {

    var showFoto = function() {
        var url = $(this).attr("href");

        ron.showImage(url);
        return false;
    };


    $("body")
        .on("change", 'input.ronRC', ronPortal.dateStringFromRC) //pro vsechny inputy s tridou ronRC aktivuje prevod RC na datum do inputu definovaneho v data-ronrc-inputdatename
        .on("click", ".link_foto", showFoto)  // zobrazeni obrazku po kliknuti
        .on('mouseover', '.ronInfoFoto', ronPortal.ronFoto.zobrazNahled)
        .on('mouseout', '.ronInfoFoto', ronPortal.ronFoto.skryjNahled);
    ronPortal.ronFoto.init();

    ronPortal.ronCombo.nastavCombo();
    (function() {
        var logoutTime = null;
        var $logout_info_message = null;
        var $logout_info_time = null;
        var timeVisible = false;
        var showTimeFunc = function() {
            if (!timeVisible) return;

            var remaining = logoutTime - Date.now();
            if (remaining > 0) {
                $logout_info_time.text(ron.utils.secondsToString(Math.floor((logoutTime - Date.now()) / 1000)));
                setTimeout(showTimeFunc, 1000);
            } else {
                $logout_info_time.text(ron.utils.secondsToString(0));
                window.location.replace(window.location);
            }
            timeVisible = true;
        };


        var resetTimer = function() {
            $.ajax('?menuid=utils&action=resetTimer')
                .done(handleLastAccessResult);
        };

        var timer = null;

        var setRemainingTimer = function() {
            var showTime = false;

            if (timer) {
                clearTimeout(timer);
                timer = null;
            }

            if (logoutTime - Date.now() > 600000) {
                timer = setTimeout(logoutTimerFunc, 300000);
            } else if (logoutTime - Date.now() > 360000) {
                timer = setTimeout(logoutTimerFunc, logoutTime - Date.now() - 300000);
            } else if (logoutTime - Date.now() > 120000) {
                timer = setTimeout(logoutTimerFunc, logoutTime - Date.now() - 120000);
            } else if (logoutTime - Date.now() > 20000) {
                showTime = true;
                timer = setTimeout(logoutTimerFunc, 10000);
            } else {
                showTime = true;
                timer = setTimeout(logoutTimerFunc, logoutTime - Date.now());
            }

            if (showTime) {
                if (!$logout_info_message) {
                    $logout_info_message = $("<div/>")
                        .attr("class", "app_info_bubble")
                        .attr("id", "logout_info_message")
                        .html(ron.translate("Automaticke_odhlaseni_info"))
                        .on("click", resetTimer)
                        .appendTo($(document.body));

                    $logout_info_time = $("#logout_info_time");
                }

                if (!timeVisible) {
                    timeVisible = true;
                    showTimeFunc();
                }
                $logout_info_message.show();
            } else {
                if ($logout_info_message) $logout_info_message.hide();
                timeVisible = false;
            }
        };
        var handleLastAccessResult = function(data) {
            if (!data.logoutTimer) return;

            logoutTime = Date.now() + 1000 * data.remaining;
            if (data.valid) {
                setRemainingTimer();
            }
        };
        var logoutTimerFunc = function()
        {
            $.ajax('?menuid=utils&action=lastAccess')
                .done(handleLastAccessResult);
        };

        setTimeout(logoutTimerFunc, 5000);
    })();
});


$(function() {

    var onDatumChechboxClick = function() {
        var $this = $(this);
        var $form = $this.closest("form");

        if ($this.prop("checked")) {
            $form.find("input[name=jenobdobi]").prop("checked", false);
        }

        if ($form.data("ron-autosubmit") == "1") {
            $form.submit();
        }
    };


    var onObdobiChechboxClick = function() {
        var $this = $(this);
        var $form = $(this).closest("form");

        if ($this.prop("checked")) {
            $form.find("input[name=jendatumoddo]").prop("checked", false);
        }

        if ($form.data("ron-autosubmit") == "1") {
            $form.submit();
        }
    };

    $(".ronportalfilterform")
        .on("click", "[name=jendatumoddo]", onDatumChechboxClick)
        .on("click", "[name=jenobdobi]", onObdobiChechboxClick);
});

$(function() {

    var
        pscInputChange = function() {
            let
                $this = $(this),
                mestoSelector = $this.data("mesto-input-selector");

            if (mestoSelector) {
                let
                    $mesto = $(mestoSelector),
                    ronSelect = $mesto.ronselect("instance");

                ronSelect.setDropDownFilter($this.val());
            }
        },

        mestoInputActivate = function(event, data) {
            console.log(data.item);
            if (!data  || !data.item) {
                return;
            }

            let
                $this = $(this),
                pscSelector = $this.data("psc-input-selector"),
                obecSelector = $this.data("obec-input-selector");

            if (pscSelector  &&  data.item.psc) {
                $(pscSelector).val(data.item.psc);
            }

            if (obecSelector  &&  data.item.obec) {
                console.log("nastavuji obec", data.item.obec);
                $(obecSelector).ronselect("instance").value(data.item.obec);
            }

            $this.ronselect("instance").setDropDownFilter();
        };

    $("body")
        .on("input", ".psc-input", ron.delayedLaunch(1000, pscInputChange, true))
        .on("itemactivate", ".mesto-input", mestoInputActivate);
});


$(function() {

    ronPortal.dokumentDialog = function(options) {

    };
});

var vlozitDokumentResult = null; // volano z vnoreneho iframe


(function() {
    var
        vyberStarsihoDokumentu = function () {
            if (this.value) {
                this.form.soubor.value = null;
            }
        },

        uploadingFinished = function() {
            console.log("uploadingFinished");

            var url = $("#novydokument").data("redirect-url");
            if (!url) {
                url = window.location;
            }

            console.log("redirect to:", url);

            window.location = url;
        },

        handleUploadFiles = function(files, url) {
            var i = 0;

            var uploadNextFile = function () {
                if (i >= files.length) {
                    uploadingFinished();
                    return;
                }

                var
                    fileReader = new FileReader(),
                    file = files[i];

                fileReader.onload = ( function (e) {
                    var form = new FormData();

                    $("#novydokument").find(".documentUploadInput").each(function() {
                        var $input = $(this);
                        form.append($input.attr("name"), $input.val());
                    });

                    form.append("soubor", file);

                    $.ajax(
                        {
                            url: url,
                            type: "POST",
                            data: form,
                            cache: false,
                            dataType: 'json',
                            processData: false,
                            contentType: false
                        })
                        .done(function (data) {
                            if (data.result == "OK") {
                                uploadNextFile();
                            } else {
                                ron.showError(data);
                            }
                        }).fail(function (jqXHR) {
                            ron.logAjaxError(jqXHR, "Pri nahravani souboru doslo k chybe!");
                        });
                });

                fileReader.readAsBinaryString(files[i]);
                i++;
            };

            uploadNextFile();
        },

        vlozitNovyDokument = function () {
            var $form = $(this.form);

            $("#novydokument_buttonsrow").hide();
            $("#novydokument_progressrow").show();
            $("#novydokument_error").html("");

            if ($form.attr("target")) {
                $form.submit();
            } else {
                handleUploadFiles($(this.form.soubor).prop("files"), $form.attr("action"));
                return false;
            }


            return true;
        };

    $(function() {
        $("#novydokument")
            .on("change", "#vyberStarsihoDokumentu", vyberStarsihoDokumentu)
            .on("click", "#vlozitNovyDokumentBtn", vlozitNovyDokument);
    });
    ronPortal.showDokumentDialog = function (afterUploadCallback) {
        var redirectUrl = null;

        vlozitDokumentResult = null;

        if (typeof afterUploadCallback == 'function') {
            vlozitDokumentResult = afterUploadCallback;
        } else if (afterUploadCallback) {
            redirectUrl = afterUploadCallback;
        }

        var $dialog = $("#novydokument");

        if (!vlozitDokumentResult  &&  !redirectUrl  &&  $dialog.data('redirect-url')) {
            redirectUrl = $dialog.data('redirect-url');
        }

        if (redirectUrl) {
            vlozitDokumentResult = function(result) {
                processDokumentResult(result, redirectUrl);
            };
        }

        $dialog
            .dialog({
                modal: true,
                resizable: false,
                width: "auto",
                height: "auto"
            });
    };
})();
function processDokumentResult(result, urlOK) {
    if (result  &&  result.result == 'OK') {
        if (urlOK) window.location.replace(urlOK);
        return true;
    }
    else {
        if (!result) {
            console.log('Nebyla prijata zadna data po spusteni Agenta!'); // nastane v pripade, ze se pousti primo exe
            if (urlOK) window.location.replace(urlOK);
        } else {
            ron.showError(result, '#novydokument_error');
        }

        $("#novydokument_buttonsrow").show();
        $("#novydokument_progressrow").hide();
        return false;
    }
}

$(function() {
    var
        deleteDocument = function() {
            var idField = $("#deleteDocumentId");
            if (idField.length) {
                idField.val(this.data("document-id"));
                idField.closest("form").submit();
            } else {
                alert('Chyba ve funkci deleteDocument - neexistuje pole deleteDocumentId!');
            }
        },

        onDeleteDocumentClick = function() {
            console.log(this);
            ron.confirmQuestion( $(this), deleteDocument );
        },

        onShowDokumentDialogClick = function() {
            var
                $this = $(this),
                $dialog = $("#novydokument"),
                fields = $this.data("fields");

            if (fields) {
                fields = fields.split(";");

                for (var i = 0;  i < fields.length;  i++) {
                    var $field = $dialog.find(".documentUploadInput[name=" + fields[i] + "]");
                    $field.val($this.data("field-" + fields[i].toLowerCase())); // nazvy atributu maji byt lowercase (HTML5 spec.)
                }
            }

            ronPortal.showDokumentDialog();
            return false;
        };

    $("body")
        .on("click", ".delete-document-post", onDeleteDocumentClick)
        .on("click", ".show-dokument-dialog", onShowDokumentDialogClick);
});
ronPortal.editaceMesicnich = function()
{
    var forEachRow = function($form, prefix, sloupec, callback) {
        var cnt = $form.find("input[name=" + prefix + "POCET_RADKU]").val();

        for ( var i = 0;  i < cnt;  i ++ ) {
            var
                idpp = $form.find("input[name=" + prefix + "IdPP_" + i + "]").val(),
                $input = $('input[name="' + prefix + idpp + '_' + sloupec + '"]');
                callback($input);
        }
    };
    var prepocitejSoucet = function($form, prefix, sloupec, timeFormat)
    {
        var limit = $form.find("input[name=" + prefix + "limit_" + sloupec + "]").val();

        var soucet = 0;
        forEachRow($form, prefix, sloupec, function($input) {
            var
                hodnotaStr = $input.val(),
                hodnota = timeFormat
                    ? ron.utils.timeStringToFloat( hodnotaStr )
                    : ron.utils.stringToFloat( hodnotaStr );

            console.log(hodnotaStr, hodnota, soucet);
            if ( hodnota ) soucet = soucet + hodnota;
        });

        var
            $div = $("#" + prefix + 'soucet_' + sloupec),
            digitsStr = $div.data('digits'),
            digits = digitsStr ? parseInt(digitsStr) : 2;

        $div.html(
            "<b>" +
            (timeFormat
                ? ron.utils.floatToTimeString(soucet)
                : ron.utils.formatFloat(soucet, digits)) +
            "</b>");

        if ( limit != -1 ) {
            var zbyva = limit - soucet;
            if ( zbyva < 0 ) zbyva = 0;

            $("#" + prefix + "zbyvadolimitu_" + sloupec).text(ron.utils.formatFloat(zbyva, digits));

            $("#" + prefix + "limit_" + sloupec).toggleClass("errorcolor", soucet > limit);
        }
    };
    var zapisPuvodniHodnotu = function($element) {
        if ($element.data('puvodni-hodnota') === null  ||  $element.data('puvodni-hodnota') === undefined) {
            var val = $element.val();
            if (val === undefined ||  val === null) val = "";
            $element.data('puvodni-hodnota', val );
        }
    };
    var editace = function($e) {
        var $this = $(this); // edit

        $this.addClass("mesicniEditovana");

        var
            timeFormat = $this.is(".inputTime"),
            $table = $this.closest("table"),
            prefix = $table.data("ron-prefix"),
            $form = $this.closest("form"),
            sloupec = $this.data('ron-index');

        prepocitejSoucet($form, prefix, sloupec, timeFormat);
    };


    var editacePoznamky = function($e) {
        var $this = $(this);
        $this.addClass("mesicniEditovana");
    };


    var headerMenu = function() {
        var
            $menu = $("#editaceHromadnaMenu"),
            $that = $(this); // bunka zahlavi, na kterou se kliklo


        var onMenuItemClick = function() {
            var index = $that.data("index");
            var $form = $that.closest("form");

            var $table = $that.closest("table");
            var prefix = $table.data("ron-prefix");

            var $this = $(this); // polozka menu

            var timeFormat = false;


            var nastavZadanouHodnotu = function() {
                var
                    jenPrazdne = $("#editaceHromadnaDialogJenPrazdne").prop("checked"),
                    hodnota = $("#editaceHromadnaDialogHodnota").val();

                forEachRow($form, $table.data("ron-prefix"), index, function($element) {
                    zapisPuvodniHodnotu($element);
                    if (!jenPrazdne  ||  $element.val() == "") {
                        $element
                            .val(hodnota)
                            .addClass("mesicniEditovana");
                    }
                });
            };


            var provedAkci = function() {
                switch ($this.data("ron-action")) {
                    case "original" :
                        forEachRow($form, $table.data("ron-prefix"), index, function ($element) {
                            if ($element.is(".inputTime")) {
                                timeFormat = true;
                            }

                            if ($element.data("puvodni-hodnota") !== null && $element.data("puvodni-hodnota") !== undefined) {
                                $element
                                    .val($element.data("puvodni-hodnota"))
                                    .removeClass("mesicniEditovana");
                            }
                        });
                        break;

                    case "smazat" :
                        forEachRow($form, $table.data("ron-prefix"), index, function($element) {
                            if ($element.is(".inputTime")) {
                                timeFormat = true;
                            }

                            zapisPuvodniHodnotu($element);
                            $element
                                .val("")
                                .addClass("mesicniEditovana");
                        });
                        break;

                    case 'nastavit' :
                        nastavZadanouHodnotu();
                        break;
                }

                prepocitejSoucet($form, prefix, index, timeFormat);
            };



            if ($this.data("ron-question")) {
                ron.confirm($this.data("ron-question"), provedAkci);
            } else if ($this.data("ron-action") == "nastavit") {
                var $menuItem = $this;
                $("#editaceHromadnaDialogNazevSloupce").text($that.text());
                $("#editaceHromadnaDialogHodnota").val("");

                $("#editaceHromadnaDialogOK")
                    .off("click")
                    .on("click", function() {
                        $("#editaceHromadnaDialogSloupec").dialog("close");
                        provedAkci.call($menuItem);
                    });

                $("#editaceHromadnaDialogSloupec").dialog({
                    modal: true,
                    width: "auto",
                    height: "auto"
                });
            } else {
                provedAkci($this.data("ron-action"));
            }
        };

        $menu.ronPopupMenu({
            attachToElement: $that,
            onClick: onMenuItemClick
        });
    };

    var initForm = function() {
        var $this = $(this);

        $this
            .on("click", ".menuHromadne", headerMenu)
            .on("focus", ".editaceMP, .editaceMV, .editacePoznamky", function() { zapisPuvodniHodnotu($(this)); })
            .on("change", ".editaceMP", editace)
            .on("change", ".editaceMV", editace)
            .on("change", ".editacePoznamky", editacePoznamky);

    };


    $(function() {
        $(".editaceMesicnichHromadna").each(initForm);
    });
};

$(function() {

    var
        vyhledatOborVzdelaniClick = function() {
            console.log("JSME TU");
            let
                url = "https://www.obory-vzdelani.cz",
                $this = $(this),
                $mistoStudia = $($this.data("misto-studia-selector")),
                $kodVzdelani = $($this.data("kod-vzdelani-selector")),
                $datumUkonceni = $($this.data("datum-ukonceni-selector")),
                zahranici = $mistoStudia.val() == "1";


            url += zahranici
                ? "/misto-Z"
                : "/misto-CR";

            let
                rok = $datumUkonceni.val().split('.')[2];

            if (rok) {
                url += "/rok-" + rok;

                let
                    kod = $kodVzdelani.val(),
                    typVzdelani = kod
                        ? parseInt(kod)
                        : null;

                if (typVzdelani) {
                    switch (parseInt(typVzdelani)) {
                        case 3:
                        case 4:
                        case 5:
                        case 6:
                        case 7:
                            url += zahranici ? "/typ-SSC" : "/typ-SSB";
                            break;

                        case 8:
                        case 9:
                        case 10:
                            url += zahranici ? "/typ-SSC" : "/typ-SSS";
                            break;

                        case 11:
                            url += zahranici ? "/typ-VSC" : "/typ-VOS";
                            break;

                        case 12:
                            url += zahranici ? "/typ-VSC" : "/typ-VSB";
                            break;

                        case 13:
                            url += zahranici ? "/typ-VSC" : "/typ-VSM";
                            break;

                        case 14:
                            url += zahranici ? "/typ-VSC" : "/typ-VSD";
                            break;
                    }
                }
            }

            window.open(url, "_blank");
            $($this.data("data-obor-vzdelani-ispv-selector")).focus();
        };

    $("body")
        .on("click", ".vyhledat-obor-vzdelani", vyhledatOborVzdelaniClick);
});

$(function() {
    var
        $cardInputs = $(".rd-reader"),
        kodIdMedia = "",
        kodMediaTimer = null,
        kodMediaTimeout = 200,
        minimalCodeLength = 5,
        readMediumTimeout = function() {
            kodIdMedia = "";
        },


        setReaderTimeout = function(calculateTimeout) {
            if (calculateTimeout) {
                var $timeOutStr = $cardInputs.data('timeout');
                if ($timeOutStr) {
                    kodMediaTimeout = parseInt($timeOutStr);
                }
            }

            kodMediaTimer = setTimeout(readMediumTimeout, kodMediaTimeout);
        },

        clearReaderTimeout = function() {
            if (kodMediaTimer) {
                clearTimeout(kodMediaTimer);
                kodMediaTimer = null;
            }
        },


        readerAutoSubmit = function() {
            var $minimalLengthStr = $cardInputs.data('minimal-code-length');

            minimalCodeLength = $minimalLengthStr
                ? parseInt($minimalLengthStr)
                : 0;
            if (kodIdMedia.length >= minimalCodeLength) {
                $cardInputs.val(kodIdMedia);
                var $autoSubmitInput = $cardInputs.filter("[data-ron-autosubmit]").first();
                if ($autoSubmitInput.length) {
                    $autoSubmitInput.closest("form").submit();
                }
            }
        },


        readerInputKeyPress = function(e) {
            clearReaderTimeout();

            if (e.which == 13) {
                readerAutoSubmit();
                kodIdMedia = "";
            } else {
                setReaderTimeout(kodIdMedia == ""); // pokud se jedna o prvni znak, tak zjisti minimalni timeout
                kodIdMedia = kodIdMedia + e.key;
            }
        };
    if ($cardInputs.length) {
        $("body")
            .on("keypress", readerInputKeyPress);
    }
});


(function() {
    var tasks = [];

    var TaskInfo = function(taskId) {
        this.taskId = taskId;
        this.timeoutPeriod = 3000;
        this.widgets = [];

        this.lastStatus = null;
        var timer = null;
        var $updateRequest = null;

        tasks[taskId] = this;


        this.addWidget = function($widget) {
            this.widgets.push($widget);
        };


        this.updateStatus = function(callback) {
            if ($updateRequest) {
                return false;
            }

            var that = this;

            $updateRequest = $.ajax("?menuid=task&taskId=" + this.taskId)
                .always( function() {
                    $updateRequest = null;
                })
                .done( function(resultData) {
                    that.lastStatus = resultData.tasks[that.taskId];

                    if (callback) {
                        if (callback.call(that, resultData) === false) return;
                    }

                    for (var i = 0;  i < that.widgets.length;  i++) {
                        that.widgets[i]._updateStatus();
                    }
                });

            return true;
        };


        this.cancelUpdate = function() {
            if ($updateRequest) {
                $updateRequest.abort();
                $updateRequest = null;
            }

            if (timer) {
                clearTimeout(timer);
                timer = null;
            }

            return this;
        };


        this.start = function(updateImmediatelly) {
            if (updateImmediatelly) {
                var that = this;

                this.updateStatus( function() {
                    that.setTimeout()
                });
            } else {
                this.setTimeout();
            }
        };


        this.setTimeout = function() {
            if (timer) {
                return this;
            }

            if (this.lastStatus  &&  !this.lastStatus.isRunning) {
                return this;
            }

            var that = this;

            var doUpdate = function() {
                timer = null;
                that.start(true);
            };

            timer = setTimeout( doUpdate, this.timeoutPeriod );

            return this;
        };


        this.stopTimeout = function() {
            if (timer) {
                clearTimeout(timer);
                timer = null;
            }

            return this;
        };
    };


    $.widget("ron.taskstatus", {
        options: {
            taskId: null,
            period: null,
            $progressInfo: null,
            showProgressLabel: true,
            $progressLabel: null,
            complete: null,
            error: null
        },

        _create: function () {
            var that = this;

            if (!this.options.taskId) {
                this.options.taskId = this.element.data("task-id");
            }

            if (!this.options.period) {
                if (this.element.data("period")) {
                    this.options.period = parseInt(this.element.data("period"));
                } else {
                    this.options.period = 3000;
                }
            }

            if (!this.options.complete) {
                this.options.complete = this.element.data("complete");
            }

            if (!this.options.error) {
                this.options.error = this.element.data("error");
            }

            var showLabel = this.element.data("show-label");
            if (showLabel === false ||  showLabel === 0) {
                this.options.showProgressLabel = false;
            } else if (showLabel === 1  ||  showLabel === true) {
                this.options.showProgressLabel = true;
            } else if (showLabel) {
                this.options.showProgressLabel = showLabel;
            }
            if (this.options.taskId) {
                var taskInfo = tasks[this.options.taskId];

                if (!taskInfo) {
                    taskInfo = new TaskInfo(this.options.taskId);
                    taskInfo.timeoutPeriod = this.options.period;
                } else {
                    if (this.options.period < taskInfo.timeoutPeriod) {
                        taskInfo.timeoutPeriod = this.options.period;
                    }
                }

                taskInfo.addWidget(this);
                taskInfo.start(true);
            }
        },

        setTimeout: function() {
            var taskInfo = tasks[this.options.taskId];
            if (!taskInfo) return this;         // nemelo by nastat

            taskInfo.setTimeout();

            return this;
        },

        stopTimeout: function() {
            var taskInfo = tasks[this.options.taskId];
            if (!taskInfo) return this;         // nemelo by nastat

            taskInfo.stopTimeout();

            return this;
        },
        showStatus: function() {
            if (this.options.$progressInfo === null) {
                this.options.$progressInfo = this.element.find(".task-status-progress");

                if (!this.options.$progressInfo.length) {
                    this.options.$progressInfo = $("<div/>")
                        .addClass("task-status-progress")
                        .appendTo(this.element)
                        .progressbar();

                    if (this.options.showProgressLabel === true) {
                        this.options.$progressLabel = $("<div/>")
                            .addClass("progress-label")
                            .appendTo(this.options.$progressInfo);
                    } else if (this.options.showProgressLabel) {
                        this.options.$progressLabel = $(this.options.showProgressLabel);
                    }
                }
            }

            if (!this.options.$progressInfo) {
                return this;
            }

            var taskInfo = tasks[this.options.taskId];

            if (taskInfo.lastStatus) {
                if (this.options.$progressLabel) {
                    this.options.$progressLabel.text(taskInfo.lastStatus.progressMessage);
                }

                if (taskInfo.lastStatus.progressMax) {
                    this.options.$progressInfo
                        .progressbar("option", "max", taskInfo.lastStatus.progressMax)
                        .progressbar("value", taskInfo.lastStatus.progressCurrent);
                } else if (taskInfo.lastStatus.isRunning) {
                    this.options.$progressInfo
                        .progressbar("option", "value", false);
                } else {
                    this.options.$progressInfo
                        .progressbar("option", "value", 0);
                }
            }

            return this;
        },

        _updateStatus: function() {
            var taskInfo = tasks[this.options.taskId];
            if (!taskInfo) return this;         // nemelo by nastat

            this.showStatus();

            if (taskInfo.lastStatus  &&  !taskInfo.lastStatus.isRunning) {
                if (this.options.complete  &&  !taskInfo.lastStatus.errorMessage) {
                    switch (typeof this.options.complete) {
                        case "string":
                            window.location = this.options.complete;
                            break;

                        case "function":
                            this.options.complete.call(this);
                            break;
                    }
                }

                if (this.options.error  &&  taskInfo.lastStatus.errorMessage) {
                    switch (typeof this.options.error) {
                        case "string":
                            window.location = this.options.error;
                            break;

                        case "function":
                            this.options.error.call(this);
                            break;
                    }
                }
            }
        }
    });


})();


$(function() {
    $(".task-status").taskstatus();
});