<?php
/**
 * UTF8
 * stanislav.elbl, 15.10.2014
 */

namespace Ron\RonPortal;

/** @var $radky KompaktniRadekSluzebniCesty[] */
/** @var $sluzebniCesta SluzebniCesta */
?>

<?php if ( $radky && sizeof($radky) ) { ?>
    <table class="browser">
        <thead>
            <tr>
                <th class="align-left"><?= \Ron\ronText('Date') ?></th>
                <th class="align-left"><?= \Ron\ronText('Podrobnosti_radku_sc') ?></th>
                <th><?= \Ron\ronText('Pocet_snidani') ?></th>
                <th><?= \Ron\ronText('Pocet_obedu') ?></th>
                <th><?= \Ron\ronText('Pocet_veceri') ?></th>
            </tr>
        </thead>

        <tbody>

        <?php foreach ($radky as $i => $radek) {
            $rowclassname = ($i % 2) ? 'browsercolor1' : 'browsercolor2';
        ?>
            <tr class="<?= $rowclassname ?>">
                <td><?= $radek ->getDatumStr() ?></td>
                <td><?= $radek ->f_popis ?></td>
                <td class="align-center"><?php if ($radek ->f_snidane) echo $radek ->f_snidane; ?></td>
                <td class="align-center"><?php if ($radek ->f_obedy) echo $radek ->f_obedy; ?></td>
                <td class="align-center"><?php if ($radek ->f_vecere) echo $radek ->f_vecere; ?></td>
            </tr>

        <?php } ?>

        </tbody>
    </table>
<?php } ?>

<br/>
<div class="linkslist">
    <a href='?menuid=sluzebnicesty&action=editovatradkysluzebky&record=<?= $sluzebniCesta ->id ?>'>
        <?= \Ron\ronText($sluzebniCesta ->lzeEditovat ? 'Editovat_radky_sc' : 'Zobrazit_radky_sc') ?>
    </a>
</div>
