<?php
/**
 * UTF8
 * stanislav.elbl, 14.07.2015
 */

namespace RonPortal;

use Ron\Http\App;
use Ron\Http\HtmlHeaders;

global $appVersion;

?>
<meta name="apple-mobile-web-app-capable" content="yes">
<!-- test adblocku -->
<script src="script/ads.js?ver=<?= $appVersion ?>" type="text/javascript"></script>
<script>
    $(function () {
        if (!window.neniAdblock) {
            $('#nojs').show();
            console.log($('#nojs').html());
        }
    });
</script>
<noscript>
    <style>
        #nojs {
            display: inline;
        }
    </style>
</noscript>

<link rel="stylesheet" type="text/css" href="css/s_app.css?ver=<?= $appVersion ?>">

<!-- scripty ronportal -->
<script src="./script/ronportal.js?ver=<?= $appVersion ?>" type="text/javascript"></script>
<script src="./script/xmlform.js?ver=<?= $appVersion ?>" type="text/javascript"></script>

<script type="text/javascript">
    var debugMode = <?=  (App::getDebugMode() ? '1' : '0') ?>;
</script>

<?php HtmlHeaders::getInstance() ->render(); ?>

<?php if (file_exists('s_user.css')) { ?>
<!-- uzivatelske predefinovani stylu -->
    <link rel="stylesheet" type="text/css" href="s_user.css?ver=<?= $appVersion ?>">
<?php } ?>
<link rel="stylesheet" type="text/css" href="?menuid=download&css&timestamp=<?= RonPortalSession::sessionTimestamp() ?>">
<?php if (User::getUserCss()) { ?>
    <!-- css podle profilu uzivatele -->
    <link rel="stylesheet" type="text/css" href="<?= User::getUserCss() ?>?timestamp=<?= RonPortalSession::sessionTimestamp() ?>">
<?php } ?>

<?php if (file_exists('user_scripts.js')) { ?>
<!-- uzivatelske skripty -->
<script src="user_scripts.js?ver=<?= $appVersion ?>" type="text/javascript"></script>
<?php } ?>

<!--<script src="https://code.jquery.com/jquery-migrate-3.0.0.js"></script>-->