<?php
/**
 * stanislav.elbl, 03.07.2020
 * Tag <predat smer="..."> preda formular o zadany pocet kroku (smer) dale nebo zpet
 */

namespace Ron\RonPortal\XML;

/** @var RonPortalXMLForm $this  */
/** @var XMLFormElement $parentElement */

if (!class_exists('\Ron\RonPortal\XML\XMLFormElementPredat', false)) {
    class XMLFormElementPredat extends XMLFormElement
    {
        function predejFormular()
        {
            // Teoreticky by se dalo pridelat jeste toto:
            // string $kodUrovne     kod urovne, na kterou se ma predat - musi v procesu existovat!
            // int $poradi           poradi urovne v pradavacim procesu

            $smer = $this ->getAttributeValue('smer', 1);
            $smer = (int)$this->nahradPromenne($smer);
            $this ->xmlForm ->predej($smer);
        }


        function getHTMLOutput()
        {
            return '';
        }

        function event()
        {
            // nedela nic - v udalosti nema smysl
        }

        function process()
        {
            $this ->predejFormular();
        }

        function writeXMLOutput($xmlWriter)
        {
            $this ->predejFormular();
        }
    }
}

return new XMLFormElementPredat($this, $parentElement);