<?php
/**
 * stanislav.elbl, 13.03.2021
 */

spl_autoload_register(function ($className) {
    if (strpos($className, '..') !== false) {
        throw new \Exception('RON autoload: invalid class name!');
    }

    $fileName = __DIR__ . '/' . strtolower(str_replace('\\', '/', $className) . '.php');

    if (file_exists($fileName)) {
        require_once __DIR__ . '/' . strtolower(str_replace('\\', '/', $className) . '.php');
    } else {
        return false;
    }
});
