<HTML>
<BODY>

<?php
    error_reporting(E_ALL);

    require_once("_appdbset.php");

    if ($db_utils) {
        require_once('ron/database.php');
        require_once($db_utils);
        require_once('db/compatibility.php');
    }
    else {
        echo "Chyba: V _appdbset.php neni nastaveno db_utils!<BR>";
    }

  
    $connection = NULL;

    if ($db_connectionstring) {
        echo "Pipojuji se k databzi pod uivatelskm jmnem $db_user<BR>\n";
        //$connection = db_connect($db_user, $db_password);
        /** @var \Ron\DB\Database $database */
        $database = \Ron\DB\createDefaultDatabase();
        try {
            $database->connect($db_user, $db_password);
        } catch (Exception $e) {
            echo "Chyba: Nepodarilo se pripojit k databazi<BR>\n";
            echo $e->getMessage() . "<BR><BR>\n";
            var_dump($e);
            exit;
        }

        echo "Pripojeni k databazi OK<BR><BR>";
    }
    else {
        echo "Chyba: V _appdbset.php neni nastaven db_connectionstring!<BR>\n";
    }


    if ( isset($_GET["zapis"]) ) {
        // ------------------------------------------------------------------------
        // TEST ZAPISU - Zobrazi formular
        echo "Test zapisu do databaze<BR>\n";
        echo "POZOR! Test provede zmenu prijmeni zamestnance - po provedeni testu nastavte puvodni prijmeni!<BR>\n";
        echo "Zadejte rodne cislo zamestnance a nove prijmeni<BR>";
        echo '<FORM action="?provedzapis=1" method="POST">';
        echo 'RC: <INPUT type=text name=rc> &nbsp;&nbsp;';
        echo 'Zmenit prijmeni na: <INPUT type=text name=prijmeni> &nbsp;&nbsp;';
        echo '<INPUT type=submit value="Provest">';
        echo "</FORM>\n";
    }
    else if ( isset($_GET["provedzapis"]) ) {
        // ------------------------------------------------------------------------
        // TEST ZAPISU - provede test
        $sql = "UPDATE Osoba SET Prijmeni = '" . $_POST["prijmeni"] . "' WHERE RC = '" . $_POST["rc"] . "'";
        echo "Zkousim SQL dotaz $sql<BR>\n";

        $vysledek = $database ->sql($sql);

        if ($vysledek) {
            echo "Spusteni SQL dotazu OK<BR>\n";
        } else {
            echo "Chyba pri spusteni dotazu<BR>\n";
            echo $database ->lastErrorText() . "<BR><BR>\n";
        }
    }
    else {
        // ------------------------------------------------------------------------
        // DEFAULTNI TEST - Nacteni Osob
        $sql = "SELECT RC, Jmeno, Prijmeni FROM Osoba";
        echo "Zkousim SQL dotaz $sql<BR>\n";

        $cursor = $database ->select($sql);

        if ($cursor) {
            echo "Spusteni SQL dotazu OK, nacitam data<BR><BR>";

            $row = $cursor ->fetch();

            if ($row) {
                echo "Nacteno: {$row[2]} {$row[1]}, RC {$row[0]}<BR>\n";
                echo "<BR><BR>TEST UKONCEN V PORADKU<BR><BR>\n";

                echo "<a href=?zapis=1>Otestovat zapis do databaze</a><BR>\n";
            } else {
                echo "Nepovedlo se nacist radek - tabulka je pravdepodobne prazdna<BR>\n";
                echo $database ->lastErrorText() . "<BR><BR>\n";
            }

        } else {
            echo "Chyba pri spusteni dotazu<BR>\n";
            echo $database ->lastErrorText() . "<BR><BR>\n";
        }
    }

?>

</BODY>
</HTML>