<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 15.08.2019
 */

use Ron\DateUtils;
use Ron\MVC\Model;
use Ron\RonPortal\Notifikace\NotifikaceObjekt;
use function Ron\ronText;


$model = Model::getInstance();

/** @var NotifikaceObjekt $hodnotaNotifikace */
$hodnotaNotifikace = $model->getData('hodnotaNotifikace');

//$d = DateUtils::datesFromDateRange('10.2.2019', '8.3.2019');
//        var_dump($d);

//TODO doplnit
?>


<h1><?= ronText('notifikace')?></h1>


<div class="form large-form">
    <div class="form-content">
        <div class="row">
            <?php if ($hodnotaNotifikace->jeTextNotifikace) { ?>
                <?php foreach ($hodnotaNotifikace->textNotifikace as $value => $item) { ?>

                    <div class="col col-12 col-md-3">
                        <?= $item['nadpis'] ?>
                    </div>

                    <div class="col col-12 col-md-3">
                        <?= $item['hodnota'] ?>
                    </div>

                    <?php if ($item['url']) { ?>
                        <div class="col col-12 col-md-6">
                            <a href="<?= $item['url'] ?>"><?= ronText('detail') ?></a>
                        </div>
                    <?php } else { ?>
                        <div class="col col-12 col-md-6">
                        </div>
                    <?php }?>
                <?php }?>
            <?php }?>
        </div>
    </div>
</div>
