<?php
/**
 * UTF8
 */

// 07-2018 - odstraneny requiry!
//require_once('ron/dateutils.php');
//require_once('ron/guiutils.php');
//require_once('ron/text.php');
//require_once('ron/stringutils.php');


/**
 * @param string $text
 * @return string mixed  Transformuje text pro pouziti v XML (napr. planovani kapacit, xml formulare)
 * @deprecated
 */
function xmlTextConvert($text)
{
    require_once('ron/stringutils.php');
    return \Ron\StringUtils::xmlTextConvert($text);
}


/**
 * @param string $text
 * @return string
 * @deprecated
 */
function htmlTextConvert($text)
{
    require_once('ron/stringutils.php');
    return \Ron\StringUtils::htmlTextConvert($text);
}


/**
 * @param string $text
 * @return string  Prevede dlouhy text na text s html znackama
 * @deprecated
 */
function longTextToHtml($text)
{
    return 'funkce longTextToHtml je DEPRECATED';
}


/**
 * @param string $text
 * @param bool $htmlConvert
 * @return string
 * @deprecated
 */
function jsonText($text, $htmlConvert = false) {
    require_once('ron/stringutils.php');
    return \Ron\StringUtils::jsonText($text, $htmlConvert);
}

/**
 * @param $value
 * @return string
 * @deprecated
 */
function encodeToJSON($value) {
    return json_encode($value);
}



/**
 * @param string $msg
 * @param string $description
 * @param string $errorField
 * @param bool   $htmlConvert   Urcuje, jestli se maji v textu zkonvertovat specialni znaky
 * @return bool  Zobrazi zadane chybove hlaseni
 * @deprecated
 */
function errormsg($msg, $description = '', $errorField = null, $htmlConvert = true)
{
    require_once('ron/stringutils.php');
    echo "<div class='errortext'>" . ($htmlConvert ? \Ron\StringUtils::htmlTextConvert($msg) : $msg) . "</div>\n";
    if ($description) echo '<div class="errorinfo">' . str_replace("\n", '<br/>', ($htmlConvert ? \Ron\StringUtils::htmlTextConvert($description) : $description)) . "</div>\n";

    return false;
}


/**
 * Prevede pocet minut (cislo) na retezec. Napr. 30 => "0:30"
 * @param int $data
 * @return string
 * @deprecated
 */
function minutesToString($data)
{
    return '';
}


/**
 * Vraci lepe citelny formatovany datum. Pokud je $showtime true, tak vraci i cas
 * @param int $date
 * @param bool $showtime
 * @return string
 * @deprecated
 */
function getFineDateString($date, $showtime)
{
    return '';
}

/**
 * Vraci true, pokud je retezec spravne zadane cislo integer
 * @param $valuestr
 * @return bool
 * @deprecated
 */
function isInteger($valuestr)
{
    require_once('ron/stringutils.php');
    return \Ron\StringUtils::isInteger($valuestr);
}


/**
 * Vraci true, pokud je retezec spravne zadane float integer
 * @param $valuestr
 * @return bool
 * @deprecated
 */
function isFloat($valuestr)
{
    require_once('ron/stringutils.php');
    return \Ron\StringUtils::isFloat($valuestr);
}

/**
 * @param string $value
 * @return int float
 * @deprecated
 */
function stringToFloat($value)
{
    require_once('ron/stringutils.php');
    return \Ron\StringUtils::stringToFloat($value);
}
