<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\MVC;

/**
 * Zobrazi zadane view (php soubor)
 * Class BaseViewObject
 * @package Ron\MVC
 */
class BaseViewObject implements  ViewObject
{

    /** @var string */
    public $view;


    /**
     * @param string $view
     */
    public function __construct($view)
    {
        $this ->view = $view;
    }

    /**
     * @return string
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * @param string $view
     */
    public function setView($view)
    {
        $this->view = $view;
    }


    public function render()
    {
        if ($this ->view) {
            /** @noinspection PhpIncludeInspection */
            require($this ->view);
        }
    }
}
