<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\MVC;

/**
 * Zakladni Controller, ktery pouze zobrazi view
 * Class ViewController
 * @package Ron\MVC
 */
class ViewController implements  Controller
{
    protected $view;

    public function __construct($view)
    {
        $this ->view = $view;
    }

    /**
     * @param string $action
     * @return string|Redirect|InternalRedirect
     */
    public function handleAction($action)
    {
        return $this ->view;
    }
}
