

(function () {

    var akceTlacitkaZpet = function () {
        var tlacitkoZpet = $('#back_url');
        var tlacitkoZpetSablona = $('#back_url_sablona');

        tlacitkoZpet.on('click', function () {
            window.location.href = '?menuid=benefity'
        });

        tlacitkoZpetSablona.on('click', function () {
            window.location.href = '?menuid=benefity&action=browsersablonybenefitu'
        })
    };


    var jumpMenu = function () {
        var url = $(".jumpMenu");

        $(url).each(function () {
            $(this).on('click', function () {
                window.location = $(this).attr('data-ron-url');
            });
        });
    };

    var otestujPole = function () {
        var navrat = 1;
        var zprava = "";
        $(".nonempty").each(function ()
        {
            if ($(this).val().trim() === "") {
                $(this).addClass("app_input_error");
                zprava += " - " + $(this).attr('title') + "\n";
                navrat = 0;
            } else {
                $(this).removeClass("app_input_error");
            }
        });
        if(navrat === 0){
            alert(ron.translate('doplnte_chybejici_pole') + "\n" + zprava);
        }

        return navrat;
    };

    var kontrolaVyplneniPoli = function () {

        $("form").submit(function(e){
            if(!otestujPole()){
                e.preventDefault();
            }
        });
    };


    var prepocetPoctuBenefituNaBody = function () {
        var pocetBenefitu = $("[name='pocetBenefitu']");
        var pocetBoduInfo = $("[name='pocetBoduInfo']");
        var doplatekCastka = $("[name='doplatekCastka']");
        var pocetBodu = $("[name='pocetBodu']");

        var hodnotaVBodechProVypocet = $("[name='hodnotaVBodechProVypocet']").val();
        var doplatekCastkaProVypocet = $("[name='doplatekCastkaProVypocet']").val();
        var maxPocetNaOsobuProVypocet = $("[name='maxPocetNaOsobuProVypocet']").val();

        if(maxPocetNaOsobuProVypocet !== ""){
            $(pocetBenefitu).attr({"max" : maxPocetNaOsobuProVypocet});

            $(pocetBenefitu).on("change scroll keyup", function (event) {
                if(parseInt(pocetBenefitu.val())<= parseInt(maxPocetNaOsobuProVypocet)){
                    $(pocetBoduInfo).val(pocetBenefitu.val() * hodnotaVBodechProVypocet);
                    $(pocetBodu).val(pocetBenefitu.val() * hodnotaVBodechProVypocet);
                    $(doplatekCastka).val(pocetBenefitu.val() * doplatekCastkaProVypocet);
                } else {
                    event.preventDefault();
                }
            })
        } else {
            $(pocetBenefitu).on("change scroll keyup", function () {
                if(parseInt(pocetBenefitu.val()) >= 0 ){
                    $(pocetBoduInfo).val(pocetBenefitu.val() * hodnotaVBodechProVypocet);
                    $(pocetBodu).val(pocetBenefitu.val() * hodnotaVBodechProVypocet);
                    $(doplatekCastka).val(pocetBenefitu.val() * doplatekCastkaProVypocet);
                }
            })
        }
    };

    var pripojeniDataSchvaleniBenefitu = function (){

        var checkSchvaleni = $("#checkDatumSchvaleni");
        var datumSchvaleniInfo = $("#datumSchvaleniInfo");

        var datum = new Date();

        $(checkSchvaleni).on('click', function () {
            if($(checkSchvaleni).is(":checked")){
                $(checkSchvaleni).prop('checked', true);
                $(datumSchvaleniInfo).text(datum.getDate() + "." + (datum.getMonth() + 1) + "." + datum.getFullYear());
            } else {
                $(checkSchvaleni).prop('checked', false);
                $(datumSchvaleniInfo).text("");
            }
        });
    };

    var pripojeniDataCerpaniBenefitu = function (){

        var checkCerpani = $("#checkDatumCerpani");
        var checkSchvaleni = $("#checkDatumSchvaleni");
        var datumCerpani = $("#datumCerpaniInfo");

        var datum = new Date();

        $(checkCerpani).on('click', function () {
            if($(checkCerpani).is(":checked")){
                $(checkSchvaleni).prop('checked', true);
                $(checkSchvaleni).prop('disabled', true);
                $(datumCerpani).text(datum.getDate() + "." + (datum.getMonth() + 1) + "." + datum.getFullYear());
            } else {
                $(checkSchvaleni).prop('checked', false);
                $(checkSchvaleni).prop('disabled', false);
                $(datumCerpani).text("");
            }
        });
    };


    var svazaniEdituSCheckboxem = function ()
    {
        $("input[data-ron-provazani]").each(function ()
        {
            var provazani = $(this).attr('data-ron-provazani');
            var input = $('[name="'+ provazani + '"]');
            var inputBox_nazev = this.id;
            var editBox = $('[name="' + inputBox_nazev + '"]');

            input.on('click', function () {

                if(!this.checked){
                    $(editBox).prop('disabled', true)
                } else {
                    $(editBox).prop('disabled', false)
                }
            });
        });
    };


    var zdrojPoctuBodu = function()
    {
        var zdrojPoctuBenefitu = $('input:radio[name=zdrojPoctuBenefitu]');
        var casovaJednotka = $('input:radio[name=casovaJednotka]');
        var typCasoveSlozky = $('#typcasoveslozky');
        var divCasoveSlozky = $('.div-typ-casove-slozky');
        var divPocetBenefitu = $('.div-pocet-benefitu');
        var doplatekCastkaProVypocet = $("[name='doplatekCastkaProVypocet']").val();
        var hodnotaVBodechProVypocet = $("[name='hodnotaVBodechProVypocet']").val();
        var doplatekCastka = $("[name='doplatekCastka']");
        var pocetBenefitu = $("[name='pocetBenefitu']");
        var pocetBodu = $("[name='pocetBodu']");
        var pocetBoduInfo = $("[name='pocetBoduInfo']");
        var idBenefitu = $("[name='idBenefitu']").val();
        var zdrojPoctuBenefituHodnota = $('input:radio[name=zdrojPoctuBenefitu]:checked').val();

        if(parseInt(idBenefitu) !== undefined ) {
            if (parseInt(zdrojPoctuBenefituHodnota) === 0) {
                $(divCasoveSlozky).hide();

                $(divPocetBenefitu).show();
                $(typCasoveSlozky).removeClass('nonempty');
            } else {
                $(divPocetBenefitu).hide();
                $(divCasoveSlozky).show();
            }


            $(zdrojPoctuBenefitu).change(function () {
                if (parseInt(this.value) === 0) {
                    console.log('Zmena na Zadany');
                    $(typCasoveSlozky).removeClass('nonempty');

                    $(pocetBenefitu).addClass('nonempty');

                    $(divCasoveSlozky).hide();
                    $(divPocetBenefitu).show();
                } else {
                    console.log('Zmena na Mesicni');
                    $(typCasoveSlozky).addClass('nonempty');

                    $(divPocetBenefitu).hide();
                    $(divCasoveSlozky).show();

                    $(doplatekCastka).val(doplatekCastkaProVypocet * 1);

                    $(pocetBenefitu).removeClass('nonempty');
                    $(pocetBenefitu).val(1);

                    $(pocetBodu).val(hodnotaVBodechProVypocet * 1);
                    $(pocetBoduInfo).val(hodnotaVBodechProVypocet * 1);
                }
            });
        }
        $(typCasoveSlozky).on('change', function () {
            $(casovaJednotka).filter('[value=3]').prop('checked', true);
        })
    };


    $(function () {
        akceTlacitkaZpet();
        jumpMenu();
        kontrolaVyplneniPoli();
        prepocetPoctuBenefituNaBody();
        pripojeniDataSchvaleniBenefitu();
        pripojeniDataCerpaniBenefitu();
        svazaniEdituSCheckboxem();
        zdrojPoctuBodu();
    })
})();