


var jidelna = { };
jidelna.Alergen = function() {
    this.kod = 0;
    this.popis = '';
};

jidelna.PolozkaJidelnicku = function() {
    this.idpolozky = 0;
    this.den = '';
    this.popis = '';
    this.hodnoceni = 0;
    this.hodnocenipoznamka = '';
    this.alergeny = [];
    this.idfotografie = 0;
};
jidelna.zapisHodnoceniJidla = function(data, zapsatPoznamku, callback) {
    var odesliPozadavekHodnoceni = function(action) {
        var submitData = {
            idpolozky: data.idpolozky,
            hodnoceni: data.hodnoceni
        };

        if (zapsatPoznamku) submitData.hodnocenipoznamka = data.hodnocenipoznamka;

        $.ajax(
            {
                url : "?menuid=jidelnajs&action=" + action,
                type: "POST",
                data : submitData
            }).done( function(responseData) {
                if ( responseData.result === "OK" ) {
                    callback.call();
                } else {
                    ron.showError(responseData);
                }
            }).fail( function(jqXHR) {
                ron.showAjaxError(jqXHR, "Pri hodnoceni jidla doslo k chybe!");
            });
    };
    var zapisHodnoceniJidla = function() {
        odesliPozadavekHodnoceni("hodnotit");

        return true;
    }; 
    
    zapisHodnoceniJidla();
};
jidelna.zobrazHodnoceniJidla = function(id, callback) {  
    function provedHodnoceniJidla() {
        var hodnoceni = 0;
        var $vybranohodnoceni = $('.vybranohodnoceni');
        if ($vybranohodnoceni.length !== 0) {
            hodnoceni = $vybranohodnoceni.data('hodnoceni-polozky');
        }
        var poznamka = $('#polozkajidelnicku_poznamka').val();        
        
        jidelna.zapisHodnoceniJidla({
                idpolozky : id,
                hodnoceni: hodnoceni,
                hodnocenipoznamka: poznamka
            },
            true, // zapsat poznamku = true
            function () {
                $('.vybranohodnoceni').removeClass('vybranohodnoceni');
                $("#polozkajidelnicku_dialog").dialog('close');
                if (hodnoceni !== 0) {
                    var hodnoceno = $('#jidelnicek_hodnoceni_'+hodnoceni+'_'+id);
                    $(hodnoceno).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
                    $(hodnoceno).nextAll('span').removeClass('hodnocenijidla_hvezda_on_16');
                    $(hodnoceno).parent('td').data('aktualni-hodnoceni', hodnoceni);
                }
                else {
                    $('tr[data-jidelnicek-id="' + id + '"]').children('td.jidelnicek_hodnoceni')
                        .data('aktualni-hodnoceni',hodnoceni)
                        .children('span').removeClass('hodnocenijidla_hvezda_on_16 hodnocenijidla_hvezda_off_16');
                }
            }
        );
    }

    $('#polozkajidelnicku_foto').hide();

    $("#polozkajidelnicku_dialog")        
        .dialog( {
            modal : true,
            resizable: false,
            width: "auto",
            height: "auto"
        });
    $('#polozkajidelnicku_row_alergeny').hide();
    $('#polozkajidelnicku_seznamalergenu').html('');  

    var $polozkaJidelnickuHodnoceni = $('#polozkajidelnicku_hodnoceni');
    $polozkaJidelnickuHodnoceni.find('span').removeClass('vybranohodnoceni hodnocenijidla_hvezda_on');
    $("#btnStornoHodnoceni")
        .off("click")
        .on("click", function() {
            $('.vybranohodnoceni').removeClass('vybranohodnoceni');
            $("#polozkajidelnicku_dialog").dialog("close");    
        });

    $("#btnHodnoceniOK")
        .off("click")
        .on("click", provedHodnoceniJidla);
    $polozkaJidelnickuHodnoceni
        .off('mouseover mousemove mouseout click')
        .on('mouseover mousemove', 'span[data-hodnoceni-polozky]', function() {                        
            $(this).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on');

            var $vybraneneHodnoceni = $('.vybranohodnoceni');
            if ($vybraneneHodnoceni.length !== 0) {
                $vybraneneHodnoceni.prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on');
            }
        })
        .on('mouseout', 'span[data-hodnoceni-polozky]', function() {                        
            $(this).siblings('span').addBack().removeClass('hodnocenijidla_hvezda_on');

            var $vybraneneHodnoceni = $('.vybranohodnoceni');
            if ($vybraneneHodnoceni.length !== 0) {
                $vybraneneHodnoceni.prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on');
            }
        })
        .on('click', 'span[data-hodnoceni-polozky]', function() {                                                
            $(this).prevAll('span').removeClass('vybranohodnoceni');
            $(this).nextAll('span').removeClass('vybranohodnoceni hodnocenijidla_hvezda_on');
            if ($(this).hasClass('vybranohodnoceni')) {                
                $(this).prevAll('span').addBack().removeClass('hodnocenijidla_hvezda_on');
                $(this).removeClass('vybranohodnoceni');
            }
            else {
                $(this).addClass('vybranohodnoceni')            
                .prevAll('span').addBack()
                .addClass("hodnocenijidla_hvezda_on");            
            }
            
            if (debugMode) console.log('Vybrano hodnoceni: '+$('.vybranohodnoceni').data('hodnoceni-polozky'));
        });
    var zobrazData = function(data) {
        if (!data  ||  !data.idpolozky) return;
        
        $('#polozkajidelnicku_dialog').dialog('option','title',data.popis);
        
        if (debugMode) console.log('Dialog pro den:' + data.den);
        
        var dnes = new Date();
        if (ron.utils.stringToDate(data.den) > dnes) {
            $('#polozkajidelnicku_row_hodnoceni').hide();
            $('#polozkajidelnicku_row_poznamka').hide();
            $("#btnHodnoceniOK").hide();
        }
        else {
            $('#polozkajidelnicku_hodnoceni_'+data.hodnoceni).addClass('vybranohodnoceni').prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on');

            $('#polozkajidelnicku_poznamka').val(data.hodnocenipoznamka);
            if ($('.jidelnicek_hodnoceni_polozky :visible').length > 0) {
                $('#polozkajidelnicku_row_hodnoceni').show();
                $('#polozkajidelnicku_row_poznamka').show();
            }
        }
        if ((data.alergeny.length > 0) && ($('.alergeny :visible').length > 0)) {
            $.each(data.alergeny, function (k, v) {
                $('#polozkajidelnicku_seznamalergenu').append('<li>'+v.kod + ' - ' + v.popis +'</li>');
            }); 
            $('#polozkajidelnicku_row_alergeny').show();
        }
        else {
            $('#polozkajidelnicku_row_alergeny').hide();
        }

        if (data.idfotografie > 0) {
            var img = $('#polozkajidelnicku_foto_img');
            $(img).prop('src',$(img).data('link') + '&idpolozky=' + data.idpolozky);
            $('#polozkajidelnicku_foto').show();
        }
        else {
            $('#polozkajidelnicku_foto').hide();
        }
    };


    var url = "?menuid=jidelnajs&action=loaddata&id=" + id;

    $.ajax(url)
        .done( function(data) {
            if (debugMode) console.log("Nactena data polozky jidelnicku: ", data);

            if (data.result === "error") {
                ron.showError(data);
            } else {
                zobrazData(data);                

                if (typeof callback === "function") {
                    callback(data);
                }
            }

        }).fail( function(jqXHR) {
            ron.showAjaxError(jqXHR, "Pri nacitani polozky jidelnicku doslo k chybe!");
        });

};
jidelna.nastavPolozky = function() {
    var nastavZobrazPolozku = function(event) {
        var id = $(this).data("jidelnicek-id");
        var existujeFoto = $(this).data('jidelnicek-mafotografii');
        var jsouAlergeny = $(this).data('jidelnicek-maalergeny');
        
        if ((povolitHodnoceni && (ron.utils.stringToDate($(this).data('jidelnicek-den')) < hodnotitPred)) || jsouAlergeny || existujeFoto)
        {
            if ((id) && (event.target.tagName === 'SPAN') && (event.target.id !== '')) {
                var hodnoceni = $(event.target).data('hodnoceni-polozky');
                var puvodniHodnoceni = $(event.target).parent('td').data('aktualni-hodnoceni');
                if (hodnoceni === puvodniHodnoceni) {
                    hodnoceni = 0;
                }
                jidelna.zapisHodnoceniJidla({
                        idpolozky : id,
                        hodnoceni: hodnoceni
                    },
                    false, // zapsat poznamku = false
                    function () {
                        if (hodnoceni !== 0) {
                            var hodnoceno = $('#jidelnicek_hodnoceni_'+hodnoceni+'_'+id);                        
                            $(hodnoceno).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
                            $(hodnoceno).nextAll('span').removeClass('hodnocenijidla_hvezda_on_16');
                            $(hodnoceno).parent('td').data('aktualni-hodnoceni', hodnoceni);                        
                        }
                        else {
                            $('tr[data-jidelnicek-id="' + id + '"]').children('td.jidelnicek_hodnoceni')
                                .data('aktualni-hodnoceni',hodnoceni)
                                .children('span').removeClass('hodnocenijidla_hvezda_on_16 hodnocenijidla_hvezda_off_16');
                        }
                    }); 
            }
            else if ((id) && (event.target.tagName !== 'INPUT')) {
                if (povolitHodnoceni || existujeFoto === true || jsouAlergeny === true) {
                    jidelna.zobrazHodnoceniJidla(id);
                }
            }
        }
    };
        
    var hodnotitPred = new Date();

    var jidelnicek = $('.jidelnicek');

    var povolitHodnoceni = $(jidelnicek).data('jidelnicek-povolit-hodnoceni');

    $(jidelnicek)
        .on('click', 'tr[data-jidelnicek-id]' , nastavZobrazPolozku)
        .on('mouseover', 'tr[data-jidelnicek-id]', function() {            
            if ((povolitHodnoceni && (ron.utils.stringToDate($(this).data('jidelnicek-den')) < hodnotitPred)) || (($(this).data('jidelnicek-maalergeny') === true) /*&& ($('.alergeny :visible').length > 0)*/) || ($(this).data('jidelnicek-mafotografii') == true))
            {
                $(this).addClass("browserhighlightrow");
                $(this).css('cursor', 'pointer');
            }
            if (ron.utils.stringToDate($(this).data('jidelnicek-den')) < hodnotitPred) {
                $(this).children(".jidelnicek_hodnoceni").find('span').addClass('hodnocenijidla_hvezda_off_16');
            }
        })
        .on('mouseout', 'tr[data-jidelnicek-id]', function() {
            $(this)
                .removeClass("browserhighlightrow");
            if (($(this).children('td.jidelnicek_hodnoceni').data('aktualni-hodnoceni') === undefined) || 
                    (($(this).children('td.jidelnicek_hodnoceni').data('aktualni-hodnoceni') === 0))) {   
                $(this).children(".jidelnicek_hodnoceni").find('span').removeClass('hodnocenijidla_hvezda_off_16');
            }
        })
        .on('mouseover mousemove', 'span[data-hodnoceni-polozky]', function() {                        
            $(this).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
            
            var aktualniHodnoceni = $(this).parent('td').data('aktualni-hodnoceni');            
            var id = $(this).parents('tr[data-jidelnicek-id]').data('jidelnicek-id');
            
            if (aktualniHodnoceni !== 0) {
                $('#jidelnicek_hodnoceni_'+aktualniHodnoceni+'_'+id).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
            }
        })
        .on('mouseout', 'span[data-hodnoceni-polozky]', function() {                        
            $(this).siblings('span').addBack().removeClass('hodnocenijidla_hvezda_on_16');
            
            var aktualniHodnoceni = $(this).parent('td').data('aktualni-hodnoceni');            
            var id = $(this).parents('tr[data-jidelnicek-id]').data('jidelnicek-id');
            
            if (aktualniHodnoceni !== 0) {
                $('#jidelnicek_hodnoceni_'+aktualniHodnoceni+'_'+id).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
            }
        })
    ;
    var hodnocenePolozky = $('.jidelnicek td[data-aktualni-hodnoceni]');
            var aktualniHodnoceni = 0;
            $.each(hodnocenePolozky, function (index, item) {
                aktualniHodnoceni = $(item).data('aktualni-hodnoceni');
                $(item)            
                    .children('span').addClass('hodnocenijidla_hvezda_off_16');
                $(item)
                    .children('span[data-hodnoceni-polozky="'+aktualniHodnoceni+'"]').prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
            });
    
};
$(function() {

    var
        nactenaJidelna = null,

        jidelna = null,
        idpp = null,
        cisloObjednavky = null,
        idPolozkyJidelnicku = null,
        $element = null,
        zDetailu = false,
        zobrazPrevodObjednavky = function() {

            idPolozkyJidelnicku = $element.data("ron-id-polozky-jidelnicku");
            idpp = $element.data("ron-idpp");
            jidelna = $element.data("ron-jidelna");
            cisloObjednavky = $element.data("ron-cislo-objednavky");
            var
                $osoba = $('#osoba_objednavky').text($element.data("ron-jmeno")),
                $id_objednavky = $('#id_objednavky').text(cisloObjednavky),
                $id_polozky = $('#id_polozky_jidelnicku').text(idPolozkyJidelnicku),
                $popis_objednavky = $('#popis_objednavky').text($element.data("ron-popis-objednavky"));

            $("#vlastnik").val(idpp);

            if (!nactenaJidelna  ||  nactenaJidelna != jidelna) {
                $("#prevodObjednavkySelectOsoba").ronselect("instance").loadData("?menuid=jidelnaobjednavky&action=seznamosob&nactiosoby=1&jidelna=" + jidelna, false);
                nactenaJidelna = jidelna;
            }

            $("#jidelna_prevod_objednavky").dialog({
                modal: true,
                width: "auto",
                height: "auto"
            });

        },
        prevodObjednavky = function() {
            $element = $(this);
            zDetailu = false;
            zobrazPrevodObjednavky();
        },
        prevodObjednavkyDetail = function() {
            $element = $(this);
            zDetailu = true;
            zobrazPrevodObjednavky();
        },


        provedPrevodObjednavky = function() {
                var
                    novaOsobaIDPP = $('#prevodObjednavkySelectOsoba').val();

                if (novaOsobaIDPP === undefined || novaOsobaIDPP === '') {
                    ron.showError(ron.translate('Jidelna_nezvolen_prijemce_objednavky'));
                    return false;
                }

                if (idpp == novaOsobaIDPP) {
                    ron.showError(ron.translate('Jidelna_opravdu_na_stejnou_osobu'));
                    return false;
                }
                $("#loadingSpinnerPrevodObjednavky").addClass("loading");

                $.ajax(
                    {
                        url: "?menuid=jidelnaobjednavky&action=prevodobjednavkynaosobu",
                        type: "POST",
                        data: {
                            osoba: idpp,
                            cisloObjednavky: cisloObjednavky,
                            id: idPolozkyJidelnicku,
                            novaOsobaIDPP: novaOsobaIDPP
                        }
                    }).done(function (data) {
                        $("#loadingSpinnerPrevodObjednavky").removeClass("loading");

                        if (data.result === "OK") {
                            if (zDetailu) {
                                window.location = "?menuid=jidelnaobjednavky";
                            } else {
                                var $tr = $element.closest('tr');
                                $tr.find(".jmeno-stravnika").addClass("text-decoration-line-through");
                                $tr.find("span.confirmQuestion").hide();
                                $element
                                    .text(ron.translate("Jidelna_objednavka_prevedena"))
                                    .removeClass("objednavku-prevest")
                                    .removeClass("js");
                            }
                        } else {
                            ron.showError(data);
                        }

                        $("#jidelna_prevod_objednavky").dialog("close");
                    }).fail(function (jqXHR) {
                        $('#loadingSpinnerPrevodObjednavky').hide();
                        ron.showError(ron.translate("Jidelna_chyba_pri_prevodu"));
                    });
        };

    $("body")
        .on("click", ".objednavku-prevest", prevodObjednavky)
        .on("click", "#btn_prevest_objednavku", provedPrevodObjednavky)
        .on("click", "#jidelnaprevestobjednavkupresdetail", prevodObjednavkyDetail);
});

jidelna.objednejPolozku = function () {
    $(this).parent().submit();
    return false;
};

$(function(){
    $('.jidelnicek').on('click', 'div.jidelnicek_objednat', jidelna.objednejPolozku);
});
