

ron.sc = { };

$(function() {
    var
        $sluzebniCestaFormular = $("#sluzebni_cesta_formular"),
        idPP = $sluzebniCestaFormular.data("id-pp"),
        idSC = $sluzebniCestaFormular.data("id-sc"),
        $cilovyStat = $("#CilovyStat"),
        nacitatStat = !$cilovyStat.val();
    var
        nactiMaximalniStravne = function() {
            var cilovyStat = $cilovyStat.val();
            if (!cilovyStat) return; // neni zadan stat - nic nenacita

            var datum = $("#DatumSCOd").val();
            if (!datum) return; // neni zadan datum - nic nenacita

            if ($("#maximalniDenniStravne").is(":hidden")) return;

            var
                vychoziStatSelect = $("#vychoziStatSC"),
                vychoziStat = vychoziStatSelect.length ? vychoziStatSelect.val() : '';

            $.ajax("?menuid=sluzebnicestyjs&action=maxstravneprostat&cilovystat=" + cilovyStat + "&vychozistat=" + vychoziStat + "&datum=" + datum).done(
                function (data) {
                    if (data.result == "OK") {
                        $("#maximalniDenniStravne").html(data.text);
                    } else {
                        ron.showError(data);
                        $("#maximalniDenniStravne").html("");
                        focusJsonErrorField(data, true);
                    }
                }
            );
        },
        nactiKapesneStatu = function () {
            var
                $scForm = $("#sluzebni_cesta_formular"),
                sazbaKapesnehoPodleStatu = $scForm.data("sazba-kapesneho-podle-statu"),
                menitSazbuKapesneho = $scForm.data("menit-sazbu-kapesneho");

            if (!sazbaKapesnehoPodleStatu || !menitSazbuKapesneho) {
                return;
            }

            var cilovyStat = $cilovyStat.val();
            if (!cilovyStat) return; // neni zadan stat - nic nenacita

            $.ajax("?menuid=sluzebnicestyjs&action=kapesneprostat&stat=" + cilovyStat).done(
                function (data) {
                    if (data.result == "OK") {
                        if (data.text) {
                            $("#SazbaKapesneho").val(data.text);
                        }
                    } else {
                        ron.showError(data);
                    }
                }
            );
        },


        nactiStatPodleRozdeleni = function(kodRozdeleni) {
            if (!kodRozdeleni) return;

            var nacitatAdresu = $("#sluzebni_cesta_formular").data("nacitat-adresu-rozdeleni");
            if (!nacitatAdresu && $cilovyStat.val() && !nacitatStat) return;  // cilovy stat byl uz pri zobrazeni formulare nastaven - nedela nic

            $.ajax("?menuid=sluzebnicestyjs&action=adresarozdeleni&kod=" + encodeURIComponent(kodRozdeleni))
                .done(function (data) {
                    if (data.result == "OK") {
                        if (data.stat) {
                            var puvodniStat = $cilovyStat.val();
                            $cilovyStat.val(data.stat);
                            if (puvodniStat != data.stat) {
                                nactiKapesneStatu();
                            }
                        }
                        if (nacitatAdresu) {
                            var novaAdresa =
                                (data.ulice ? data.ulice : "") +
                                (data.ulice && data.mesto ? ", " : "") +
                                (data.mesto ? data.mesto : "");

                            if (novaAdresa) {
                                $("#hlavickasc_popiscile").find("input").val(novaAdresa);
                            }
                        }
                    } else {
                        ron.showError(data);
                    }
                })
                .fail(function (jqXHR) {
                    ron.showAjaxError(jqXHR);
                });
        },


        zmenaRozdeleniSC = function() {
            var kod = $(this).val();

            if (kod && $("#scZahranicni").prop("checked")) {
                nactiStatPodleRozdeleni(kod);
            }
        },


        zahranicniClick = function() {
            var checked = $(this).prop("checked");
            $("#sluzebnicestatable").toggleClass("zahranicniSC", checked);

            if (checked) {
                nactiStatPodleRozdeleni($("#rozdelenisc_kod").val());
            }
        },


        cilovyStatChange = function() {
            nactiMaximalniStravne();
            nactiKapesneStatu();
        },
        rozdeleniOsoby_SC = function() {
            var
                url = "?menuid=sluzebnicestyjs&action=rozdeleniosoby";


            var aktualizujSelect = function (newValue) {
                ronPortal.aktualizujRozdeleniOsoby(url, idPP, [$("#rozdelenisc_kod")], [$("#rozdelenisc_popis")], newValue);
            };

            ronPortal.rozdeleniOsoby(url, idPP, aktualizujSelect);
        },


        osobaChange = function() {
            ron.loadOptionsFromUrl(
                $("#RegistracniZnacka"),
                "?menuid=sluzebnicestyjs&action=dataproosobu&idpp=" + $(this).val());
        };


    $sluzebniCestaFormular
        .on("click", "#vybratRozdeleniSC", rozdeleniOsoby_SC)
        .on("change", "#rozdelenisc_kod,#rozdelenisc_popis", zmenaRozdeleniSC)
        .on("click", "#scZahranicni", zahranicniClick)
        .on("change", "#CilovyStat", cilovyStatChange)
        .on("blur", "#DatumSCOd", nactiMaximalniStravne)
        .on("change", "#Osoba", osobaChange)
    ;
});


$(function() {

    var
        seznamOsob = null,
        seznamOsobnichCisel = null;

    var cancel = function() {
        $("#hlavickasc_pridatspolucestujiciho").css("display", "block");
        $("#vyber_spolucestujiciho").css("display", "none");
    };

    var ok = function() {
        var index = $("#jmenoSpolucestujiho").ronselect("itemIndex");
        if (index === null) return;

        var idPP = seznamOsob[index].idPP;
        var idSC = $("#idScSpolucestujiciho").val();

        $.ajax("?menuid=sluzebnicestyjs&action=pridejspolucestujiciho&idpp=" + idPP + "&idsc=" + idSC )
            .done( function(data) {
                if (data.result == "OK") {
                    window.location.replace("?menuid=sluzebnicesty&action=zobrazslcestu&record=" + idSC); // redirect
                } else {
                    ron.showError(data);
                }
            })
            .fail( function(jqXHR) {
                ron.showAjaxError(jqXHR);
            });

    };


    var onOsobaChange = function(index, options) {
        if (index === null) return;

        $("#jmenoSpolucestujiho").ronselect("value", options.items[index].idPP);
        $("#osobniCisloSpolucestujiciho").ronselect("value", options.items[index].idPP);
    };


    var naplnSeznamOsob = function(data) {
        $("#nacitani_spolucestujicich").css("display", "none");

        if (data.result == "OK") {
            seznamOsob = data.pp;
            seznamOsobnichCisel = ron.utils.copyArray(data.pp);
            seznamOsobnichCisel.sort( function(item1, item2) {
                return item1.osobniCislo.localeCompare(item2.osobniCislo);
            });

            $("#jmenoSpolucestujiho").ronselect({
                items: seznamOsob,
                onChange: onOsobaChange,
                columns: ["jmenoPrijmeni", "osobniCislo"],
                textColumn: "jmenoPrijmeni",
                valueColumn: "idPP"
            });

            $("#osobniCisloSpolucestujiciho").ronselect({
                items: seznamOsobnichCisel,
                onChange: onOsobaChange,
                columns: ["jmenoPrijmeni", "osobniCislo"],
                textColumn: "osobniCislo",
                valueColumn: "idPP",
                dropDownAlign: "right"
            });
        } else {
            ron.showError(data);
            $("#maximalniDenniStravne").html( "" );
            focusJsonErrorField(data, true);
        }
    };

    var nactiSeznamOsob = function() {
        $("#spolucestujiciCancel").on("click", cancel);
        $("#spolucestujiciOK").on("click", ok);

        $.ajax('?menuid=sluzebnicestyjs&action=vyberspolucestujicich')
            .done(naplnSeznamOsob);
    };

    var vyberSpolucestujiciho = function() {
        $("#hlavickasc_pridatspolucestujiciho").css("display", "none");
        $("#vyber_spolucestujiciho").css("display", "block");

        if (!seznamOsob) {
            nactiSeznamOsob();
        }

        return false;
    };

    $("#hlavickasc_pridatspolucestujiciho")
        .on("click", vyberSpolucestujiciho);

});


$(function() {

    var provestSchvaleni = function() {
        var
            $rows = $(".sc_row"),
            index = null,
            cancel = false,
            isError = false,
            $progresDialog = $("#progress_dialog");


        var
            onCancel = function() {
                cancel = true;
            },


            onClose = function() {
                window.location = "?menuid=sluzebnicesty";
            },


            zpracujVysledek = function(data) {
                if (data &&  data.errors) {
                    isError = true;

                    for (var i = 0;  i < data.errors.length;  i++) {
                        $progresDialog.progressDialog("addmessage", data.errors[i].errorText, "errortext");
                    }
                }
            },
            zpracujRadek = function($row) {
                var
                    data = {
                        id: $row.data("id-sc")
                    },
                    jeZmena = false,
                    $checkboxes = $row.find(".schvaleni-check");

                $checkboxes.each(function() {
                    var $checkbox = $(this);

                    if (!$checkbox.prop("checked") != !$checkbox.data("original-value")) {
                        jeZmena = true;
                        data["Schvaleni_" + $checkbox.data("level")] = $checkbox.prop("checked") ? 1 : 0;
                    }
                });

                if (jeZmena) {
                    $.ajax( {
                        url: "?menuid=sluzebnicestyjs&action=schvalenisc",
                        type: "POST",
                        data : data
                    })
                        .done( zpracujVysledek )
                        .fail( ron.ajaxErrorFunction("Pri schvaleni doslo chybe!") )
                        .always(zpracujDalsiRadek);

                } else {
                    setTimeout(zpracujDalsiRadek, 0); // aby se aktualizoval progress
                }
            },

            zpracujDalsiRadek = function() {
                index = (index === null) ? 0 : index + 1;

                if (cancel  ||  index >= $rows.length) {
                    if (isError) {
                        $progresDialog
                            .progressDialog("setvalue", index, '')
                            .progressDialog("setbuttons", ["close"]);
                    } else {
                        window.location = "?menuid=sluzebnicesty";
                    }
                    return;
                }

                var $radek = $($rows.get(index));
                $progresDialog.progressDialog("setvalue", index, $radek.data('info-sc'));
                zpracujRadek($radek);
            };

        $progresDialog.progressDialog({
            min: 0,
            max: $rows.length,
            onCancel: onCancel,
            onClose: onClose
        });

        zpracujDalsiRadek();

        return false;
    };
    var oznacRadekSC = function($row) {
        var
            selected = false,
            $checkboxes = $row.find(".schvaleni-check");

        $checkboxes.each(function() {
            var $checkbox = $(this);

            if (!$checkbox.prop("checked") != !$checkbox.data("original-value")) {
                selected = true;
            }
        });

        $row.toggleClass("browserselectedrow", selected);
    };


    var schvaleniCheckboxClick = function() {
        oznacRadekSC($(this).closest("tr"));
    };


    var oznacVsechnyRadky = function() {
        $(".sc_row").each(function() {
            oznacRadekSC($(this));
        });
    };
    var oznacVsechny = function(index, value) {
        var $checkboxes = $("#seznamsluzebnichcest").find(".Schvaleni_" + index);

        switch (value) {
            case -1 :
                $checkboxes.each(function() {
                    var $this = $(this);

                    $this.prop("checked", !!$this.data("original-value"));
                });
                break;

            default :
                $checkboxes.prop("checked", !!value);
                break;

        }

        oznacVsechnyRadky();
    };



    var schvaleniSCMenu = function($sender, uroven) {
        var $menu = $("#schvaleniSCMenu");

        $menu
            .off("click", "li")
            .on("click", "li", function() {
                oznacVsechny( uroven, $(this).data("ron-hodnotaschvaleni") );
            });

        $menu.ronPopupMenu( { attachToElement: $sender } );

        return false; // stop event propagation
    };


    var showSchvaleniMenu = function() {
        var $this = $(this);
        schvaleniSCMenu($this, $this.data("index"));
        return false;
    };


    var allCheckClick = function() {
        var
            $this = $(this),
            checked = $this.prop("checked"),
            index = $this.data("index");

        oznacVsechny(index, checked);
    };

    var schvalSluzebniCesty = function() {
        var
            index = null,
            $rows = $(".sc_row");

        var
            provedSchvaleniRadku = function($row) {

                schvalDalsiSC();
            },

            schvalDalsiSC = function() {
                if (index === null) {
                    index = 0;
                } else {
                    index++;
                }

                if (index >= $rows.size()) {
                    return;
                }

                provedSchvaleniRadku($($rows.get(i)));
            };

        schvalDalsiSC();
    };


    $("#seznamsluzebnichcest.hromadne-schvalovani")
        .on("click", ".schvaleni_ALL", allCheckClick)
        .on("click", ".schvaleniSCShowMenu", showSchvaleniMenu)
        .on("click", "input", schvaleniCheckboxClick);

    $("#provestHromadneSchvaleniSC")
        .on("click", provestSchvaleni);

});

ron.sc.DataEditaceRadkuSC = function() {
    this.idSluzebniCesty = 0;
    this.readOnly = 0;
    this.zahranicni = 0;
    this.operaceSluzebniCesty = "";
    this.statSluzebniCesty = "";
    this.cilovyStatSluzebniCesty = "";
    this.strDeleteRow = "";
    this.strStorno = "";
    this.casPocatku = "";
};
ron.sc.editaceRadkuSC = function(data) {
    var predvyplnStatSlCesty = function(index) {
        var $select = $("[name=stat_" + index + "]").eq(0);
        if (!$select.length) return false;
        if ($select.val()) return false;

        var $options = $select.children("option");
        if ($options.length == 1) {
            $select.val($options.eq(0).val());
            return true;
        }

        if ($options.length == 2 && $options.eq(0).val() == "") {
            $select.val($options.eq(1).value);
            return true;
        }
        if (index <= 1) {
            $select.val(data.statSluzebniCesty);
            return true;
        }
        if (index == 2) {
            $select.val(data.cilovyStatSluzebniCesty);
            return true;
        }
        var predchoziradek = index - 1;

        while (predchoziradek > 0) {
            var $pom_casinput = $("[name=casod_" + predchoziradek + "]").eq(0);
            var $pom_statinput = $("[name=stat_" + predchoziradek + "]").eq(0);

            if ( $pom_casinput.length  &&  $pom_statinput.length  &&  $pom_casinput.val()  && $pom_statinput.val() ) {
                $select.val($pom_statinput.val());
                return true;
            }
            else {
                predchoziradek--;
            }
        }
        $select.val(data.cilovyStatSluzebniCesty);
    };
    var vyberNasledujiciOperaci = function(seznam, indexradku) {
        var predchozioperace = null;
        var predchoziradek = indexradku - 1;
        while (predchoziradek > 0  &&  !predchozioperace) {
            var pom_casinput = document.getElementsByName('casod_' + predchoziradek)[0];
            var pom_operaceinput = document.getElementsByName('operace_' + predchoziradek)[0];

            if (pom_casinput  &&  pom_operaceinput  &&  pom_casinput.value  &&  pom_operaceinput.value) {
                predchozioperace = pom_operaceinput.value;
            }
            else {
                predchoziradek--;
            }
        }

        if (!predchozioperace) return null;

        predchozioperace = predchozioperace.toLocaleLowerCase();

        var result = null;
        var star = false;
        var found = false;
        for (var i = 0;  i < seznam.length;  i++) {
            if (found) {
                if ( seznam[i] != "*" ) return seznam[i];
            }
            else if (star) {
                if ( seznam[i] != "*" ) result = seznam[i];
            }

            if (seznam[i].toLocaleLowerCase() == predchozioperace) {
                found = true;
            }

            star = seznam[i] == "*";
        }

        return result;
    };


    var predvyplnOperaciSlCesty = function(index) {
        var operace = data.operaceSluzebniCesty.split(";");
        if (!operace.length) return;

        var predchozioperace = null;
        var predchozicas = null;
        var predchoziradek = index - 1;
        while (predchoziradek > 0  &&  !predchozioperace) {
            var pom_casinput = document.getElementsByName('casod_' + predchoziradek)[0];
            var pom_operaceinput = document.getElementsByName('operace_' + predchoziradek)[0];

            if (pom_casinput  &&  pom_operaceinput  &&  pom_casinput.value) {
                predchozioperace = pom_operaceinput;
                predchozicas = pom_casinput;
            }
            else {
                predchoziradek--;
            }
        }

        var operaceinput = document.getElementsByName('operace_' + index)[0];
        if (operaceinput  &&  !operaceinput.value) {
            if (predchoziradek > 0) {
                var novaoperace = vyberNasledujiciOperaci(operace, index);
                if (novaoperace) operaceinput.value = novaoperace;
            }
            else {
                if (operace[0]) {
                    operaceinput.value = operace[0];
                }
            }
        }
    };
    var predvyplnNovyRadekSlCesty = function(index) {
        if (data.operaceSluzebniCesty) {
            predvyplnOperaciSlCesty(index);
        }

        predvyplnStatSlCesty(index);
    };
    var novyRadekChange = function() {
        var index = $(this).data("ron-index");
        if (!index) return;

        var $row = $("#radekSC_" + index);
        if (!$row.length) return; // nedela nic

        var zobrazit = false;

        var $cas_input = $("[name=casod_" + index + "]");
        if ($cas_input.length  &&  $cas_input.eq(0).val() != "") zobrazit = true;

        if (!zobrazit) {
            var snidane_checkbox = $("[name=pocetPJidel_S_" + index + "]").eq(0);
            if (snidane_checkbox.length  &&  snidane_checkbox.prop("checked")) zobrazit = true;
        }
        if (!zobrazit) {
            var obed_checkbox = $("[name=pocetPJidel_O_" + index + "]").eq(0);
            if (obed_checkbox.length  &&  obed_checkbox.prop("checked")) zobrazit = true;
        }
        if (!zobrazit) {
            var vecere_checkbox = $("[name=pocetPJidel_V_" + index + "]").eq(0);
            if (vecere_checkbox  &&  vecere_checkbox.prop("checked")) zobrazit = true;
        }

        if (zobrazit) {
            if ($row.hasClass("novyradekSC") ) {
                $row.removeClass("novyradekSC");
                predvyplnNovyRadekSlCesty(index);
            }
        }
        else {
            $row.addClass("novyradekSC");
        }
    };


    var predvyplnCas = function($input) {
        var index = $input.data("ron-index");

        if (!$input.val()) {
            var casStr = "";

            if (index == 1) {
                casStr = (!data.casPocatku || data.casPocatku == "0:00") ? "8:00" : data.casPocatku;
            } else if ($input.closest("tr").is(".prvniradekprodenSC")) {
                casStr = "8:00";
            } else {
                var $predchoziInput = $("input[name='casod_" + (index - 1) + "']");

                if ($predchoziInput.val()) {
                    var cas = ron.utils.timeStringToFloat($predchoziInput.val());
                    if (cas) {
                        casStr = ron.utils.floatToTimeString(cas + 1);
                    }
                }
            }

            if (casStr) {
                $input.val(casStr);
            }
        }
    };


    var casInputDblClick = function() {
        predvyplnCas($(this));
        novyRadekChange.call(this);
    };


    var jidloCheckboxClick = function() {
        novyRadekChange.call(this);

        predvyplnCas($("input[name='casod_" + $(this).data("ron-index") + "']"));
    };


    var nastavStatProMistoSC = function() {
        var $this = $(this);
        if ( !$this.val() ) return;

        var index = $this.data('ron-index');

        $.ajax( "?menuid=sluzebnicestyjs&action=statpromistosc&kod=" + encodeURIComponent($this.val()) )
            .done( function(data) {
                if (data.result == "OK") {
                    $("[name='stat_" + index + "']").val(data.text);
                } else {
                    ron.showError(data);
                }
            })
            .fail( function(jqXHR) {
                ron.showAjaxError(jqXHR);
            });
    };


    var deleteRow = function() {
        var index = $(this).data('ron-deleterow');
        if (!index) return;

        ron.confirm(data.strDeleteRow,
            function() {
                document.radky_sc_form.smazat_radek_sluzebky.value = index;
                document.radky_sc_form.submit();
            }
        );
    };


    var vydajeProDenClick = function() {
        var datum = $(this).data('ron-vydaje');
        if (!datum) return;

        this.form.zobrazitVydajeProDen.value = datum;

        ron.showWorkingInfo();
        this.form.submit();
    };


    var btnPoznamkaClick = function() {
        var $this = $(this);
        var index = $this.data('ron-index');

        $("#radekSC_" + index).toggleClass("jePoznamkaSC", true);
        $("#radekSC_poznamka_" + index).toggleClass("jePoznamkaSC", true);
    };


    $("#radky_sc_editace")
        .on("keyup", 'input[name^="casod_"]', novyRadekChange)
        .on("change", 'input[name^="casod_"]', novyRadekChange)
        .on("dblclick", 'input[name^="casod_"]', casInputDblClick)
        .on("change", 'input[name^="pocetPJidel_"]', jidloCheckboxClick)
        .on("change", '[name^="misto_"]', nastavStatProMistoSC)
        .on("click", ".glyph-delete", deleteRow)
        .on("click", '[name^="vydaje_"]', vydajeProDenClick)
    ;


    var stornoClick = function() {
        ron.confirm(data.strStorno,
            function() {
                window.location = "?menuid=sluzebnicesty&action=zobrazslcestu&record=" + data.idSluzebniCesty;
            }
        );

        return false;
    };


    $("#stornoRadkuSC")
        .on("click", stornoClick);

    $(".radekSC_btn_poznamka")
        .on("click", btnPoznamkaClick)
};


$(function() {
    var
        nastavProkazaniCenyPHM = function() {
            if ($(this).val() == "1") {
                $("#NVV_DruhPHM").removeClass("d-none");
                $("#NVV_CenaPHM").addClass("d-none");
            }
            else {
                $("#NVV_DruhPHM").addClass("d-none");
                $("#NVV_CenaPHM").removeClass("d-none");
            }
        },
        radekSlCesty_Je_NVV = function(kod)
        {
            var
                kodyStr = "" + $("#UctovaniSluzebniCestyForm").data("typy-uctovani-nvv"),
                kody = kodyStr ? kodyStr.split(";") : [];
            console.log(kody);

            for (var i = 0;  i < kody.length;  i ++) {
                if ( kody[i] == kod ) {
                    return true;
                }
            }

            return false;
        },
        nastavTypRadkuUctovaniSlCesty = function() {
            var jeNahrada = radekSlCesty_Je_NVV($(this).val());

            $("#nahradyzavozidlo")
                .css("display", jeNahrada ? "inline" : "none");

            this.form.Castka.disabled = jeNahrada;
        },
        nastavZkontrolovaniRadkuUctovani = function() {
            let
                $this = $(this),
                checked = $this.prop("checked"),

                zpracujVysledek = function(data) {
                    if (data.result == "OK") {

                    } else {
                        ron.showError(data);
                    }
                };

            $.ajax( {
                url: "?menuid=sluzebnicestyjs&action=radekuctovanikontrola",
                type: "POST",
                data : {
                    idslcesty : $this.data("id-sc"),
                    cisloRadku :  $this.data("cislo-radku"),
                    zkontrolovano : checked ? 1 : 0
                }
            })
                .done( zpracujVysledek )
                .fail( ron.ajaxErrorFunction("Pri zapisu dat doslo chybe!") );
        };


    $("#UctovaniSluzebniCestyForm")
        .on("change", "input[name='NVV_NeprokazanaCenaPHM']", nastavProkazaniCenyPHM)
        .on("change", "#typRadkuUctovaniSC", nastavTypRadkuUctovaniSlCesty);

    $("#UctovaniSluzebniCestyView")
        .on("click", ".radek-uctovani-sc-kontrola", nastavZkontrolovaniRadkuUctovani);
});


ron.sc.Vozidlo = function() {
    this.registracniZnacka = null;
    this.popis = '';
    this.druhPHM = '';
    this.spotreba = 0;
};
var vozidla = [];
function najdiVozidlo(registracniZnacka) {
    for (var i = 0;  i < vozidla.length;  i++) {
        if (vozidla[i].registracniZnacka == registracniZnacka) {
            return vozidla[i];
        }
    }

    return null;
}

function vozidloSluzebniCesty(sender, index) {
    var $edit_spotreba = $("#NVV_SpotrebaVozidla_" + index);

    var vozidlo = najdiVozidlo(sender.value);
    if (vozidlo) {
        $("#NVV_PopisVozidla_" + index)
            .html("(" + vozidlo.popis + ")");
    } else {
        $("#NVV_PopisVozidla_" + index)
            .html("");
    }
    if (vozidlo  &&  vozidlo.spotreba) {
        $edit_spotreba
            .val('' + vozidlo.spotreba)
            .prop("readonly", true);

    } else {
        $edit_spotreba
            .prop("readonly", false);
    }
    if (vozidlo  &&  vozidlo.druhPHM) {
        $("[name=NVV_DruhPHM_" + index + "]")
            .val(vozidlo.druhPHM)
            .prop("disabled", true);
    } else {
        $("[name=NVV_DruhPHM_" + index + "]")
            .prop("disabled", false);
    }
}


$(function() {

    var nastavProkazaniCenyPHM =  function() {
        var
            $this = $(this),
            index = $this.data("index"),
            prokaze = $this.attr("value") == "1";

        $("select[name=NVV_DruhPHM_" + index + "]").css("display", prokaze ? "inline" : "none");
        $("input[name=NVV_CenaPHM_" + index + "]").css("display", prokaze ? "none" : "inline");
    };


    $("#radky_uctovanisc_editace").on("change", ".NVV_ProkazaniCenyPHM", nastavProkazaniCenyPHM);
});
var indexRadkuNVV = null; // aby to fungovalo i v hromadne editaci radku uctovani

function GetDistance(sender, origin, destination, waypoints, indexradku) {
    indexRadkuNVV = indexradku;

    function getDistanceCallback(response, status) {
        if (status != google.maps.DistanceMatrixStatus.OK) {
            alert('Nelze zjistit vzd�lenost! Chyba: ' + status);
            return false;
        }

        if (!response.rows.length) {
            alert('Nelze zjistit vzd�lenost! Slu�ba nevr�tila ��dn� data!');
            return false;
        }

        var vzdalenost = 0;

        var all_found = true;

        for (i = 0; i < response.rows.length; i++) {
            var results = response.rows[i].elements;
            if (results && results.length > i) {
                if (results[i].status == google.maps.DistanceMatrixStatus.OK) {
                    vzdalenost = vzdalenost + Math.round(results[i].distance.value / 1000);
                }
                else {
                    all_found = false;
                }
            }
        }

        if (indexRadkuNVV) {
            var checkbox = document.getElementsByName('NVV_DvojnasobekVzdalenosti_' + indexRadkuNVV)[0];
            if (checkbox) {
                if (checkbox.checked) vzdalenost = 2 * vzdalenost;
            }
        }
        else if (document.radky_uctovanisc_form.NVV_DvojnasobekVzdalenosti.checked) vzdalenost = 2 * vzdalenost;

        var trasa_msg = 'Start: ' + response.originAddresses[0] + "\n";
        var map_url = "http://www.google.cz/maps/?f=d&source=s_d&saddr=" + encodeURIComponent(response.originAddresses[0]);

        for (var i = 0; i < response.destinationAddresses.length - 1; i++) {
            trasa_msg += 'P�es: ' + response.destinationAddresses[i] + "\n";
        }
        trasa_msg += 'C�l: ' + response.destinationAddresses[response.destinationAddresses.length - 1] + "\n";

        map_url += "&daddr=" + encodeURIComponent(response.destinationAddresses[0]);
        for (i = 1; i < response.destinationAddresses.length; i++) {
            map_url += "+to:" + encodeURIComponent(response.destinationAddresses[i]);
        }

        if (!all_found) trasa_msg = "POZOR! N�kter� z m�st nebylo nalezeno, trasa nen� kompletn�!\n\n" + trasa_msg;

        if (confirm(trasa_msg +
                'Vypo�ten� vzd�lenost je ' + vzdalenost + ' km. Pou��t tuto vzd�lenost?')) {
            if (indexRadkuNVV) {
                var edit = document.getElementsByName('NVV_PocetUjetychKM_' + indexRadkuNVV)[0];
                if (edit) edit.value = vzdalenost;
            }
            else document.radky_uctovanisc_form.NVV_PocetUjetychKM.value = vzdalenost;
        }

        window.open(map_url, 'ron_iw_mapa');
    }


    var service = new google.maps.DistanceMatrixService();

    if (waypoints && document.radky_uctovanisc_form.NVV_PocitatPres.checked) {
        if (debugMode) console.log("GetDistance:", 'z ' + origin + ' p�es ' + waypoints + ' do ' + destination);

        poma = waypoints.split(',');

        var myorigins = [];
        var mydests = [];

        myorigins[0] = origin;
        for (var i = 0; i < poma.length; i++) {
            if (poma[i]) {
                myorigins[i + 1] = poma[i];
                mydests[i] = poma[i];
            }
        }
        mydests[mydests.length] = destination;

        service.getDistanceMatrix(
            {
                origins: myorigins,
                destinations: mydests,
                travelMode: google.maps.TravelMode.DRIVING,
                unitSystem: google.maps.UnitSystem.METRIC,
                avoidHighways: false,
                avoidTolls: false
            }, getDistanceCallback);
    }
    else {
        if (debugMode) console.log("GetDistance:", 'z ' + origin + ' do ' + destination);

        service.getDistanceMatrix(
            {
                origins: [origin],
                destinations: [destination],
                travelMode: google.maps.TravelMode.DRIVING,
                unitSystem: google.maps.UnitSystem.METRIC,
                avoidHighways: false,
                avoidTolls: false
            }, getDistanceCallback);
    }
}


$(function() {
    var deleteRadekUctovani = function() {
        var $that = $(this);

        ron.confirmQuestion($that, function() {
            document.radky_uctovanisc_form.smazat_radek_uctovani_sluzebky.value = $that.data("cislo-radku");
            document.radky_uctovanisc_form.submit();
        });
    };

    $("#radky_uctovanisc_editace")
        .on("click", ".glyph-delete", deleteRadekUctovani);
});


$(function() {
    var vlastniKurzMenyClick = function() {
        if ($(this).prop("checked")) {
            $("#editace_uctovani_kurz").show();
        } else {
            $("#editace_uctovani_kurz").hide();
        }
    };
    var menaUctovaniChange = function() {
        $("#editace_uctovani_mena").text($(this).val());
    };


    function showDokumentSCDialog() {

        ronPortal.showDokumentDialog();
        return false;
    }
    function vraceniSCClick(sender) {
        $("#vracenisluzebnicesty").show();
        $(this).hide();

        return false; // puvodni odkaz se nepouzije
    }
    var kopieProSpolucestujiciho = function() {
        var $this = $(this);

        var provedRedirect = function() {
            window.location.replace( $this.attr("href") ); // redirect
        };

        var vytvorKopii = function() {
            var
                idPP = $this.data("ron-idpp"),
                idSC = $this.data("ron-idsc");

            $.ajax("?menuid=sluzebnicestyjs&action=overspolucestujiciho&idpp=" + idPP + "&idsc=" + idSC )
                .done( function(data) {
                    if (data.result == "warning") {
                        ron.confirm(data.infoText, provedRedirect);
                        return;
                    } else if (data.result != "OK") {
                        ron.showError(data);
                        return;
                    }

                    provedRedirect();
                });
        };

        ron.confirmQuestion( $this, vytvorKopii );
        return false;
    };



    $(document.body)
        .on("click", "#DM_VlastniKurz", vlastniKurzMenyClick)
        .on("change", "#KodMeny", menaUctovaniChange)
        .on("click", "#vlozit_dokument_sc", showDokumentSCDialog)
        .on("click", ".vraceni_sluzebni_cesty_link", vraceniSCClick)
        .on("click", ".kopieProSpolucestujiciho", kopieProSpolucestujiciho);

});