/**
 * UTF8
 * Roman.Szablatura RON Software 5.9.2017 */

var skoleni = { };

(function () {

    /**
     * Pokud dojde k editaci nejakeho prvku pak nastavit priznak zmeny u formulare
     */
    var kontrolaFormulareNaZmenu = function ()
    {
        var form = $('#hodnoceniSkoleni');
        var formular =$(form);


        //Kdykoliv dojde k nejake zmene pak proveď nasledujici prikazy
        formular.on("change", 'select', function() {
            formular.data('changed', true);
        });

        //Pri resetu, vse nastavuji do puvodniho stavu - submit se znepristupňuje
        formular.on('reset', function() {
            formular.data('changed', false);
            $('input[name="filtr_pritomnych"][value="0"]').click();
        });


        //Zmena vsech na combo
        formular.find($('#hodnoceniComboAll')).on('change', function () {
            formular.data('changed', true);

            $("[id*='_hodnoceniCombo']:visible").each(function () {

                if(this.value === "0"){
                    if(debugMode){console.log(this.value);}
                    if(debugMode){console.log(this.id);}

                    $(this).val($('#hodnoceniComboAll').val());
                }
            });
        });


        /**
         * Radio zobrazit Vsechny / Pritomne / nepritomne
         */
        formular.find($('[id="filtr_pritomnych"]')).change(function ()
        {
            var filtrZobrazeni = $('[id="filtr_pritomnych"]:checked').val();
            var radkySUcastniky = '';
            var licheRadkySUcastniky = '';
            var sudeRadkySUcastniky = '';

            if(filtrZobrazeni === "0"){
                $(".uspesny ").show();
                $(".neuspesne").show();
                $(".bez_hodnoceni").show();

                //Obarveni sudych / lichych dle aktualniho zobrazeni
                radkySUcastniky = formular.find($(".radekTabulky:visible"));
                licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                radkySUcastniky.removeClass("licheRadky");
                radkySUcastniky.removeClass("sudeRadky");
                licheRadkySUcastniky.addClass("licheRadky");
                sudeRadkySUcastniky.addClass("sudeRadky");
            }

            if(filtrZobrazeni === "1"){
                $(".uspesny ").show();
                $(".neuspesne").hide();
                $(".bez_hodnoceni").hide();

                //Obarveni sudych / lichych dle aktualniho zobrazeni
                radkySUcastniky = formular.find($(".radekTabulky:visible"));
                licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                radkySUcastniky.removeClass("licheRadky");
                radkySUcastniky.removeClass("sudeRadky");
                licheRadkySUcastniky.addClass("licheRadky");
                sudeRadkySUcastniky.addClass("sudeRadky");
            }

            if(filtrZobrazeni === "2"){
                $(".uspesny ").hide();
                $(".neuspesne").show();
                $(".bez_hodnoceni").hide();

                //Obarveni sudych / lichych dle aktualniho zobrazeni
                radkySUcastniky = formular.find($(".radekTabulky:visible"));
                licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                radkySUcastniky.removeClass("licheRadky");
                radkySUcastniky.removeClass("sudeRadky");
                licheRadkySUcastniky.addClass("licheRadky");
                sudeRadkySUcastniky.addClass("sudeRadky");
            }

            if(filtrZobrazeni === "3"){
                $(".uspesny ").hide();
                $(".neuspesne").hide();
                $(".bez_hodnoceni").show();

                //Obarveni sudych / lichych dle aktualniho zobrazeni
                radkySUcastniky = formular.find($(".radekTabulky:visible"));
                licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                radkySUcastniky.removeClass("licheRadky");
                radkySUcastniky.removeClass("sudeRadky");
                licheRadkySUcastniky.addClass("licheRadky");
                sudeRadkySUcastniky.addClass("sudeRadky");
            }
        });
    };


    /**
     * Obsluha storno tlacitka, pokud dojde k stisku ESC pak pred opustenim zjistit zda nedoslo na formulari ke zmene
     */
    var stornoTlacitko = function ()
    {
        //Pokud dojde k editaci nejakeho prvku pak pri pokusu opustit formular zobrazit dotaz
        $("[id='tlacitkoStorno']").on('click', function () {
            //Pokud doslo ke zmene a uzivatel se rozhodl odejit pak se dotazat
            if($(this).closest('form').data('changed')){
                console.log("Zmena");
                var question = ron.translate('zaznam_upraveny');
                if(!ron.confirm(question)){
                    // $(this).stopPropagation();
                    return false;
                } else {
                    //Odstraneni znacky zmeny a nasledny reset formulare
                    $(this).closest('form').data('changed', false);
                    //Reset formulare
                    $(this).closest('form')[0].reset();

                    setTimeout(function () {
                        $('input[name="filtr_pritomnych"][value="0"]').click();
                    }, 500);
                    window.location.href = "?menuid=skoleni&action=skolenikurzy";
                }
            } else {
                $('input[name="filtr_pritomnych"][value="0"]').click();
                window.location.href = "?menuid=skoleni&action=skolenikurzy";
            }
        });


        //Na Esc opustit dialog
        $(document).keyup(function(e) {
            if (e.keyCode === 27) {
                if(debugMode){console.log("ESC, fn() stornoTlacitko");}

                var filtrZobrazeni = $('[id="filtr_pritomnych"]:checked').val();
                if(filtrZobrazeni !== "0"){
                    $('input[name="filtr_pritomnych"][value="0"]').click();
                } else {
                    $("[id='tlacitkoStorno']").trigger('click');
                }
            }
        })
    };



    var otestujPole = function () {
        var navrat = 1;
        var zprava = "";
        if($("form").hasClass("nonempty"))
        {
            $(".nonempty").each(function () {
                // osetreni formulare na prazdne hodnoty povinnych poli
                if ($(this).val().trim() === "") {
                    $(this).addClass("app_input_error");
                    zprava += " - " + $(this).attr('title') + "\n";
                    navrat = 0;
                } else {
                    navrat = 1;
                    $(this).removeClass("app_input_error");
                }
            });
            if (navrat === 0) {

                alert(ron.translate('doplnte_chybejici_pole') + "\n" + zprava);
            }
        }
        return navrat;
    };

    var kontrolaVyplneniPoli = function () {

        $("form").submit(function(e){
            if(!otestujPole()){
                e.preventDefault();
            }
        });
    };



    var comboFirmy = function () {
        var $selectFirmy = $(".selectFirmy");
        $selectFirmy.each( nastavSelectFirmy );
    };

    var nastavSelectFirmy = function() {
        var $this = $(this);

        var onFirmaChange = function(index, options) {
            var $firma = $('[name="firma"]');
            $firma.val(options.items[index]['kod']);
        };

        var nactiData = function () {
            $.ajax("?menuid=skoleni&action=seznamfirem")
            .done( function(data) {

                //Zobrazi informaci o nacitani firem, po nacteni info skryje
                var $firma2 = $('[name="firma2"]');
                var $firma = $('[name="firma"]');

                $firma2.val($firma.val());

                $("#loadingSpinnerFirma").hide();

                if (data.result === "OK") {
                    ron.ronSelect($this, {
                        items: data.items,
                        maxVisibleRows: 30,
                        columns: ["popis", "kod"],
                        valueColumn: "kod",
                        initialValue: $firma.val(),
                        onChange: onFirmaChange,
                        textColumn: "popis"
                    } );
                } else {
                    ron.showError(data);
                }
            })
            .fail( function() {

            }) ;
        };

        nactiData();
    };


    var dialogSchvaleniPlanuKurzu = function showDialog(text)
    {
        var odkaz = $(".pripojit-poznamku-schvaleni");

        odkaz.each(function () {
            $(this).on('click', function () {

                var dialogSchvaleni = $("#dialog-pripojeni-poznamky-schvaleni");
                var poznamkaSchvalovaniOld = $(this).attr("data-ron-poznamkaschvaleni");
                $(dialogSchvaleni).find('#poznamka_schvaleni').val(poznamkaSchvalovaniOld);

                var osoba = $(this).attr("data-ron-osoba");
                $(dialogSchvaleni).find('#osoba').val(osoba);

                var cislokurzu = $(this).attr("data-ron-cislokurzu");
                $(dialogSchvaleni).find('#cisloskoleni').val(cislokurzu);

                var akce = $(this).attr("data-ron-akce");

                var button_name = ron.translate('form.Store');
                var dialog_buttons = {};
                dialog_buttons['Storno'] = function(){ $(this).dialog('close'); };
                dialog_buttons[button_name] = function(){
                    var poznamkaSchvalovani = $("#poznamka_schvaleni").val();
                    $.ajax(
                    {
                        url : "?menuid=skoleni&action=prihlaseninaplanovaneskoleni",
                        type: "POST",
                        data : {poznamkaSchvalovani:poznamkaSchvalovani,osoba:osoba,cisloskoleni:cislokurzu,plankurzuzamestnance:akce,ajaxpoznamkakurzu:true}
                    }).done( function(responseData) {
                        if ( responseData.result === "OK" ) {
                            window.location.replace(window.location);
                        } else {
                            ron.showError("Pri odesilani poznamky schvaleni planu kurzu doslo k chybe!");
                        }
                    }).fail( function(jqXHR) {
                        ron.showAjaxError(jqXHR, "Pri odesilani poznamky schvaleni planu kurzu doslo k chybe!");
                    });
                };


                $(dialogSchvaleni).dialog({
                    resizable: false,
                    modal: true,
                    width: 450,
                    height: 230,

                    buttons: dialog_buttons
                });
            });
        });
    };


    var vycistiDialog = function (dialogDetailuSkoleniKurzu) {
        dialogDetailuSkoleniKurzu.find('.loading').remove();
        dialogDetailuSkoleniKurzu.find('.row').remove();
        dialogDetailuSkoleniKurzu.find('.buttons').remove();
    };


    var pripojeniRadku = function (index, hodnota, dialogDetailuSkoleniKurzu){

        var $divRow = $('<div class="row" />').appendTo(dialogDetailuSkoleniKurzu);
        $divRow.attr('id', index);
        var $divCaption = $('<div class="col col-12 col-sm-3 caption required" />').appendTo($divRow);
        $divCaption.text(ron.translate(index));


        if(hodnota.length > 100){
            var $textareaObsah = $('<textarea class="col col-12 col-sm-9 infomsg" rows="3" cols="70" />').appendTo($divRow);
            $textareaObsah.text(hodnota).attr('disabled', true);
        } else {
            if(index === 'Skoleni_ICAL'){
                var odkaz = $('<a href="'+hodnota+'">'+ron.translate('Skoleni_odkaz_na_download')+'</a>');

                var $divObsah = $('<div class="col col-12 col-sm-9" />').appendTo($divRow);
                $divObsah.wrapInner(odkaz);
            } else {
                var $divObsah = $('<div class="col col-12 col-sm-9" />').appendTo($divRow);
                $divObsah.text(hodnota)
            }
        }
    };


    var pripojeniTlacitek = function (dialogDetailuSkoleniKurzu) {
        var $divButtons = $('<div class="buttons" />').appendTo(dialogDetailuSkoleniKurzu);
        var $divStornoButton = $('<button class="button" id="storno_button" />').appendTo($divButtons);
        $divStornoButton.text('Storno');
        $("#storno_button").on('click', function () {
            $(dialogDetailuSkoleniKurzu).dialog('close');
        });
    };

    var pripojeniSekceKurzu = function () {
        var sekceKurzu = $('.informace-kurzu');
        //Zobrazeni/skryti informaci o kurzu, implicitne rozbaleno
        // $(sekceKurzu).nextAll().css({display: "none"});
        $(sekceKurzu).on('click', function () {
            $(this).nextUntil('.buttons').toggle();
        });
    };

    var dialogSDetailemSkoleniKurzu = function(){
        var tlacitkoDetailu = $('.zobrazit-detail-skoleni-kurzu');
        var dialogDetailuSkoleniKurzu = $('#detail-skoleni-kurzu');

        $(tlacitkoDetailu).each(function () {
            $(this).on('click', function () {

                var idpp = $(this).attr('data-ron-idpp');
                var druhSkoleni = $(this).attr("data-ron-druhskoleni");
                var datumPovinnosti = $(this).attr("data-ron-datum");
                //Pri znovuotevreni vycisti predchozi data
                vycistiDialog(dialogDetailuSkoleniKurzu);
                dialogDetailuSkoleniKurzu.html("<div class='align-center margin-all-2 loading'>" + ron.translate('Probiha_nacitani') + "<i class='position-absolute fa fa-spin glyph-spinner loading-indicator'></i></div>");

                $.ajax({
                            url : "?menuid=skoleni&action=detailnipopisskolenikurzu",
                            type: "GET",
                            data: {
                                idpp: idpp,
                                druhskoleni: druhSkoleni,
                                datum: datumPovinnosti
                            }})
                    .done(function (responseData) {
                        //Pri znovuotevreni vycisti predchozi data
                        vycistiDialog(dialogDetailuSkoleniKurzu);

                        $.each(responseData, function (index, hodnota)
                        {
                            if(hodnota === 'Skoleni_absolvovane_caption'){
                                //Vypis nadpisu sekce skoleni
                                var $divSekce = $('<div class="row form-section" />').appendTo(dialogDetailuSkoleniKurzu);
                                $divSekce.text(ron.translate(index));
                                return true;
                            }

                            if(hodnota === 'Skoleni_kurz_caption'){
                                //Vypis nadpisu sekce kurzu pripoji plus pro rozbaleni a prepina pomoci toggleClass
                                var $divSekce = $('<div class="row form-section informace-kurzu" />').css({cursor: "pointer"}).appendTo(dialogDetailuSkoleniKurzu);
                                var $span = $('<span class="col col-12 col-sm-11 align-left" />');
                                $span.text(ron.translate(index));
                                $divSekce.prepend('<i class="far toggleClass col col-12 col-sm-1 align-right fa-minus-square" data-toggle-class="fa-minus-square fa-plus-square"></i>');
                                // $divSekce.prepend('<i class="col col-12 col-sm-1 align-right far fa-plus-square"></i>');
                                $divSekce.prepend($span);

                                return true;
                            }

                            pripojeniRadku(index, hodnota, dialogDetailuSkoleniKurzu);
                        });

                        pripojeniSekceKurzu();
                        pripojeniTlacitek(dialogDetailuSkoleniKurzu);

                    })
                    .fail(function (jqXHR) {
                        ron.showAjaxError(jqXHR, "Data nejsou k dispozici");
                    });


                $(dialogDetailuSkoleniKurzu).dialog({
                    open: function () {$(".ui-widget-overlay").css({opacity: 0.5,backgroundColor: "black"});},
                    resizable: false,
                    modal: true,
                    width: "auto",
                    height: "auto",
                    position: { my: 'center',
                                at: 'top',
                                of: window,
                                collision: 'fit' },
                    title: ron.translate('podrobnosti_skoleni')
                })
            })
        });
    };


    // skoleni.hromadneOznaceniPrihlaseniNaKurz = function(){
    //     $('#prihlaseni_ALL').on('click', function () {
    //         $('.hromadne-prihlasit').prop("checked", $('#prihlaseni_ALL').prop("checked"));
    //     });
    // };
    //
    // skoleni.hromadneOznaceniVyhledanychKurzuNaDanemTerminu = function(){
    //     $('#prihlaseni_vyhledanych_ALL').on('click', function () {
    //         $('.hromadne-prihlasit-vyhledane').prop("checked", $('#prihlaseni_vyhledanych_ALL').prop("checked"));
    //     });
    // };


    // skoleni.hromadnePrihlaseniKurzu = function()
    // {
    //     var dialog = $('#skoleni-hromadne-prihlaseni-kurzu');
    //     var tlacitko = $('.prihlasit-kurz');
    //
    //     tlacitko.on('click', function () {
    //         if(debugMode){ console.log("hromadnePrihlaseniKurzu");}
    //         $('#loadingSpinnerKurzy').show();
    //         var osoba = $(this).attr('data-ron-osoba');
    //         var cislo = $(this).attr('data-ron-cislo');
    //         var jmeno = $(this).attr('data-ron-jmeno');
    //         var datum = $(this).attr('data-ron-datum');
    //         var mistopopis = $(this).attr('data-ron-mistopopis');
    //
    //         $("#osoba_kurzu").text(jmeno);
    //         $("#datum_kurzu").text(datum);
    //         $("#misto_kurzu").text(mistopopis);
    //
    //         //TODO upravit a odesilat jen cislo kurzu
    //
    //
    //         if(osoba === undefined || osoba === ''){
    //             ron.showError(ron.translate('Skoleni_osoba_nevybrana'));
    //             return false;
    //         }
    //
    //         $('#prehled-kurzu-k-prihlaseni').html("");
    //
    //         /**
    //         * @param data.form
    //         * @param data.jeKurz
    //         */
    //         $.ajax({
    //             url : "?menuid=skoleni&action=nactikurzykprihlaseni",
    //             type: "GET",
    //             data: {
    //                 osoba: osoba,
    //                 cislo: cislo
    //             }
    //         })
    //         .done(function (data) {
    //                 $('#loadingSpinnerKurzy').hide();
    //             if(debugMode){console.log(data);}
    //
    //             //TODO popis sloupcu ?
    //
    //             $.each(data.kurzy, function (index, Kurz){
    //                 skoleni.radekDialoguProHromadnePrihlaseni(Kurz, $('#prehled-kurzu-k-prihlaseni'));
    //             });
    //             skoleni.skupinaCheckboxuProVolbuDruhuSkoleni();
    //         })
    //         .fail(function (jqXHR) {
    //             ron.showAjaxError(jqXHR, "Data nejsou k dispozici");
    //         });
    //
    //
    //         $(dialog).dialog({
    //             open: function () {$(".ui-widget-overlay").css({opacity: 0.5,backgroundColor: "black"});},
    //             resizable: true,
    //             modal: true,
    //             width: "51rem",
    //             height: "auto",
    //             position: { my: 'center-100',
    //                         at: 'top',
    //                         of: window,
    //                         collision: 'fit' },
    //             buttons: [
    //                 {
    //                     text: ron.translate('Zpet'),
    //                     id: 'storno',
    //                     click: function() {$(this).dialog('close'); }
    //                 },
    //                 {
    //                     text: ron.translate('Zapsat'),
    //                     id: 'ulozit',
    //                     click: function()
    //                     {
    //                         $('#hromadnekurzy').submit();
    //                     }
    //                 }
    //             ], //buttons
    //             title: ron.translate('Skoleni_hromadne_prihlaseni_kurzu')
    //         });
    //
    //         //Uprava na Ron styl
    //         var storno = $('#storno');
    //         var ulozit = $('#ulozit');
    //         storno.removeClass();
    //         storno.addClass('button');
    //         ulozit.removeClass();
    //         ulozit.addClass('button');
    //     });
    // };

    // skoleni.radekDialoguProHromadnePrihlaseni = function(radekKurzu, dialog)
    // {
    //     /*
    //         Kurz_idpp
    //         Kurz_cislo
    //         Kurz_vznik_povinnosti
    //         Kurz_druh
    //         Kurz_povinnost
    //         Kurz_prihlasen
    //         Kurz_Popis
    //         Kurz_datum
    //         Kurz_oznacit
    //      */
    //
    //     var idpp = radekKurzu.Kurz_idpp;
    //     var cislo = radekKurzu.Kurz_cislo;
    //     var timestamp = radekKurzu.Kurz_vznik_povinnosti;
    //     var prihlasen = radekKurzu.Kurz_prihlasen;
    //     var druh = radekKurzu.Kurz_druh;
    //     var id_part = idpp + "_" + cislo + "_" + timestamp;
    //     var vybrany = "";
    //     var oznacitTucneRadek = "";
    //
    //     // var $divContent = $('<div class="col col-12 col-sm-7" />').appendTo($divRow);
    //     // $divContent.text();
    //     // var $divContent = $('<div class="col col-12 col-sm-7" />').appendTo($divRow);
    //     // $divContent.text(ron.translate("Skoleni_kurz_popis"));
    //
    //
    //     if(radekKurzu.Kurz_prihlasen == "1"){
    //         vybrany = "checked='checked'";
    //     }
    //
    //     if(radekKurzu.Kurz_oznacit == "1"){
    //         vybrany = "checked='checked'";
    //         oznacitTucneRadek = "font-weight-bold";
    //     }
    //     var $divRow = $('<div class="row ' + oznacitTucneRadek + '" />').appendTo(dialog);
    //
    //     var $divContent = $('<div class="col col-12 col-sm-1 caption required" />').appendTo($divRow);
    //     var prihlasitNaSkoleniCheck = "prihlasitNaSkoleni" + "["+id_part+"]"+"[prihlasit]";
    //     var prihlasitNaSkoleniID = "prihlasitNaSkoleni" + "["+id_part+"]"+"[osoba]";
    //     var prihlasitNaSkoleniCislo = "prihlasitNaSkoleni" + "["+id_part+"]"+"[cislo]";
    //     var prihlasitNaSkoleniDatumpovinnosti = "prihlasitNaSkoleni" + "["+id_part+"]"+"[datumpovinnosti]";
    //     var prihlasitNaSkoleniJizPrihlaseno = "prihlasitNaSkoleni" + "["+id_part+"]"+"[jizPrihlaseno]";
    //
    //
    //     $('<input type="checkbox" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniCheck+'" name="'+prihlasitNaSkoleniCheck+'" ' +
    //         'value="1" ' + vybrany + ' data-ron-druh="' + druh +'"/>').appendTo($divContent);
    //     $('<input type="hidden" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniID+'" name="'+prihlasitNaSkoleniID+'" value="'+idpp+'" />').appendTo($divContent);
    //     $('<input type="hidden" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniCislo+'" name="'+prihlasitNaSkoleniCislo+'" value="'+cislo+'"  />').appendTo($divContent);
    //     $('<input type="hidden" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniDatumpovinnosti+'" name="'+prihlasitNaSkoleniDatumpovinnosti+'" value="'+timestamp+'" />').appendTo($divContent);
    //     $('<input type="hidden" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniJizPrihlaseno+'" name="'+prihlasitNaSkoleniJizPrihlaseno+'" value="'+prihlasen+'" />').appendTo($divContent);
    //
    //
    //     // $('<span />').text(radekKurzu.Kurz_prihlasen).appendTo($divContent);
    //     var $divContent = $('<div class="col col-12 col-sm-7" />').appendTo($divRow);
    //     $divContent.text(radekKurzu.Kurz_Popis);
    //
    //     var $divContent = $('<div class="col col-12 col-sm-2" />').appendTo($divRow);
    //     $divContent.css('text-align', 'right');
    //     $divContent.text(radekKurzu.Kurz_misto);
    //
    //     var $divContent = $('<div class="col col-12 col-sm-2" />').appendTo($divRow);
    //     $divContent.text(radekKurzu.Kurz_prihlasen_text);
    // };




    skoleni.vetsiOblastCheckboxu = function(){
        var oblastCheckboxu = $("td.oblastCheckboxu:not(.browserfooter)");

        if(oblastCheckboxu.length !== 0){
            oblastCheckboxu.on('click', function(e) {
                var chk = $(this).find("input:checkbox").get(0);
                if(e.target !== chk && $(chk).length > 0){
                    chk.checked = chk.checked === false;
                    $(this).closest("tr").toggleClass('font-weight-bold', chk.checked);
                }
            });
        }
    };


    // skoleni.hromadneVyhledaniKurzu = function(){
    //     var tlacitkoVyhledatKurzy = $("#hromadnydialogvyhledanikurzu");
    //     var dialog = $('#dialog-skoleni-hromadne-vyhledani-kurzu');
    //
    //     vycistiDialog(dialog);
    //     $(tlacitkoVyhledatKurzy).on("click", function () {
    //         if(debugMode){ console.log("hromadneVyhledaniKurzu");}
    //
    //
    //         var vracenZaznam = true;
    //         $('#loadingSpinnerVyhledaniKurzu').show();
    //         //hromadne-prihlasit
    //         var seznamOsob = [];
    //
    //         $('input:checkbox[class="hromadne-prihlasit"]').each(function () {
    //             if(this.checked){
    //                 var str = "";
    //                 var osoba = $(this).attr("data-ron-osoba");
    //                 var cislo = $(this).attr("data-ron-cislo");
    //
    //                 str = osoba+";"+cislo;
    //                 if(seznamOsob.indexOf(str) === -1){
    //                     seznamOsob.push(str);
    //                 }
    //             }
    //         });
    //
    //         if(seznamOsob.length > 0){
    //             vycistiDialog(dialog);
    //             //Pokud nikdo neni zvolen
    //             $.ajax(
    //                 {
    //                     url: "?menuid=skoleni&action=hromadnevyhledaniproviceosob&hromadneprihlaseni=1",
    //                     type: "POST",
    //                     dataType: 'json',
    //                     data: {
    //                         seznamOsob: seznamOsob
    //                     }
    //                 })
    //                 .done(function (data) {
    //                     $('#loadingSpinnerVyhledaniKurzu').hide();
    //
    //                     if(data.osoby == ""){
    //                         vracenZaznam = false
    //                     }
    //
    //                     $.each(data.osoby, function (index, Osoby){
    //                         $.each(Osoby, function (indexRadku, radekKurzu){
    //                             /*
    //                             Kurz_cislo
    //                             Kurz_Uzivatel
    //                             Kurz_idpp
    //                             Kurz_Popis
    //                             Kurz_datum
    //                             Kurz_misto
    //                              */
    //
    //                             //TODO jako prvni vypsat ty kurzy ktere neni mozno nabidnout pro prohlaseni (kapacita atd.)
    //                             //TODO nasledne vypsat lidi s moznosti prihlaseni
    //                             skoleni.radekDialoguProHromadneVyhledani(radekKurzu, $('#prehled-kurzu-k-hromadnemu-vyhledani'));
    //                         });
    //                     });
    //                 })
    //                 .fail(function (jqXHR) {
    //                     ron.showAjaxError(jqXHR, "Pri hledani kurzu doslo k chybe!");
    //                 });
    //
    //             $(dialog).dialog({
    //                 open: function () {$(".ui-widget-overlay").css({opacity: 0.5,backgroundColor: "black"});},
    //                 resizable: true,
    //                 modal: true,
    //                 width: "68rem",
    //             height: "auto",
    //             position: { my: 'center-100',
    //                         at: 'top',
    //                         of: window,
    //                         collision: 'fit' },
    //             buttons: [
    //                 {
    //                     text: ron.translate('Zpet'),
    //                     id: 'storno',
    //                     click: function() {$(this).dialog('close'); }
    //                 },
    //                 {
    //                     text: ron.translate('Skoleni_prihlasit'),
    //                     id: 'ulozit',
    //                     click: function()
    //                     {
    //                             if(vracenZaznam){
    //                                 $('#hromadnevyhledanikurzu').submit();
    //                             }
    //                     }
    //                 }
    //             ], //buttons
    //             title: ron.translate('Skoleni_hromadne_prihlaseni_kurzu')
    //         });
    //
    //         //Uprava na Ron styl
    //         var storno = $('#storno');
    //         var ulozit = $('#ulozit');
    //         storno.removeClass();
    //         storno.addClass('button');
    //         ulozit.removeClass();
    //         ulozit.addClass('button');
    //
    //         } else {
    //             ron.showError(ron.translate('Skoleni_hromadne_nevybran_uzivatel'))
    //         }
    //     })
    // };


    /**
     * @param radekKurzu
     * @param dialogDetailuSkoleniKurzu
     */
    // skoleni.radekDialoguProHromadneVyhledani = function(radekKurzu, dialogDetailuSkoleniKurzu)
    // {
    //     /*
    //     Kurz_cislo
    //     Kurz_Uzivatel
    //     Kurz_idpp
    //     Kurz_Popis
    //     Kurz_datum
    //     Kurz_timestamp
    //     Kurz_misto
    //      */
    //
    //     var idpp = radekKurzu.Kurz_idpp;
    //     var cislo = radekKurzu.Kurz_cislo;
    //     var timestamp = radekKurzu.Kurz_timestamp;
    //
    //     var $divRow = $('<div class="row" />').appendTo(dialogDetailuSkoleniKurzu);
    //
    //     var id_part = idpp + "_" + cislo + "_" + timestamp;
    //
    //     var $divContent = $('<div class="col col-12 col-sm-2 caption required" />').appendTo($divRow);
    //     var prihlasitNaSkoleniCheck = "prihlasitNaSkoleni" + "["+id_part+"]"+"[prihlasit]";
    //     var prihlasitNaSkoleniID = "prihlasitNaSkoleni" + "["+id_part+"]"+"[osoba]";
    //     var prihlasitNaSkoleniCislo = "prihlasitNaSkoleni" + "["+id_part+"]"+"[cislo]";
    //     var prihlasitNaSkoleniDatumpovinnosti = "prihlasitNaSkoleni" + "["+id_part+"]"+"[datumpovinnosti]";
    //     var prihlasitNaSkoleniJizPrihlaseno = "prihlasitNaSkoleni" + "["+id_part+"]"+"[jizPrihlaseno]";
    //
    //     $('<input type="checkbox" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniCheck+'" name="'+prihlasitNaSkoleniCheck+'" value="1" />').appendTo($divContent);
    //     $('<input type="hidden" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniID+'" name="'+prihlasitNaSkoleniID+'" value="'+idpp+'" />').appendTo($divContent);
    //     $('<input type="hidden" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniCislo+'" name="'+prihlasitNaSkoleniCislo+'" value="'+cislo+'"  />').appendTo($divContent);
    //     $('<input type="hidden" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniDatumpovinnosti+'" name="'+prihlasitNaSkoleniDatumpovinnosti+'" value="'+timestamp+'" />').appendTo($divContent);
    //     $('<input type="hidden" class="hromadne-prihlasit-vyhledane" id="'+prihlasitNaSkoleniJizPrihlaseno+'" name="'+prihlasitNaSkoleniJizPrihlaseno+'" value="0" />').appendTo($divContent);
    //
    //     $('<span />').text(radekKurzu.Kurz_Uzivatel).appendTo($divContent);
    //     // $divContent.text(radekKurzu.Kurz_Uzivatel);
    //
    //     var $divContent = $('<div class="col col-12 col-sm-5" />').appendTo($divRow);
    //     $divContent.text(radekKurzu.Kurz_Popis);
    //
    //     var $divContent = $('<div class="col col-12 col-sm-5" />').appendTo($divRow);
    //     $divContent.css('text-align', 'right');
    //     $divContent.text(radekKurzu.Kurz_misto);
    // };


    // skoleni.skupinaCheckboxuProVolbuDruhuSkoleni = function(){
    //     var prepinatelnyCheckbox = $("input.hromadne-prihlasit-vyhledane");
    //
    //     $(prepinatelnyCheckbox).click(function (e) {
    //         if(this.checked){
    //             var skupina = "input:checkbox[data-ron-druh='"+$(this).attr("data-ron-druh")+"']";
    //             $(skupina).prop("checked", false);
    //             $(this).prop("checked", true);
    //         } else {
    //             $(this).prop("checked", false);
    //         }
    //     })
    // };

    // skoleni.oznaceniRadkuPrihlaseniNaKurz = function(){
    //     var checkbox = $(".hromadne-prihlasit");
    //
    //     checkbox.each(function() {
    //         $(this).on('click', function () {
    //             $(this).closest("tr").toggleClass('font-weight-bold');
    //         });
    //     });
    // };


    $(document).ready(function () {
        kontrolaFormulareNaZmenu();
        stornoTlacitko();
        kontrolaVyplneniPoli();
        comboFirmy();
        dialogSchvaleniPlanuKurzu();
        dialogSDetailemSkoleniKurzu();

        // skoleni.hromadneOznaceniPrihlaseniNaKurz();
        // skoleni.hromadneOznaceniVyhledanychKurzuNaDanemTerminu();
        // skoleni.hromadnePrihlaseniKurzu();
        skoleni.vetsiOblastCheckboxu();
        // skoleni.hromadneVyhledaniKurzu();
        // skoleni.oznaceniRadkuPrihlaseniNaKurz();
        // skoleni.skupinaCheckboxuProVolbuDruhuSkoleni();




        ron.floatingTableHeaders($('#skoleniHeader'));
    })
})();