/** Roman.Szablatura RON Software 16.6.2017 */

(function () {

    //Global promnn pro udren aktulnho storno - pro monost odejt z dialogu pomoc ESC
    var aktualniStorno;

    /**
     * Funkce pro pidn asu pomoc koleka myi. Pouze pro pravu asu ve formuli editace termnu.
     * Sta mt id s njakou mnc se promnnou (aby si to mohl pamatovat)oddlenou "_".
     * Skript si je (je-li jich vce) projde a nave na kadou obslunou rutinu.
     */
    var pridaniCasu = function (item) {
        var seznamPoliSCasem = [];
        $(item).each(function() {
            seznamPoliSCasem.push(this.id);
        });

        $.each(seznamPoliSCasem, function (index) {
            var jednotlivaPoleCasu = seznamPoliSCasem[index];
            var cas = $('#'+jednotlivaPoleCasu);
            var zobrazHodiny = "";
            var zobrazMinuty = "";
            var hodiny = "";
            var minuty = "";

            if(cas.val() === ""){
                // cas.val( zobrazHodiny + ":" + zobrazMinuty);
                hodiny = 7;
                minuty = 0;
            } else {
                var poleCasu = cas.val().split(":");
                hodiny = parseInt(poleCasu[0]);
                minuty = parseInt(poleCasu[1]);
            }

            cas.on('mousewheel DOMMouseScroll', function(event){
                event.preventDefault();
                if (event.originalEvent.wheelDelta > 0 || event.originalEvent.detail < 0) {
                    // scroll nahoru
                    if (event.shiftKey) {
                        if (minuty >= 49) {
                            minuty = 0;
                            if (hodiny >= 23) {
                                hodiny = 0;
                            } else {
                                hodiny++;
                            }
                        } else {
                            minuty+=10;
                        }

                        zobrazHodiny = ((hodiny < 10) ? ("0" + hodiny) : hodiny);
                        zobrazMinuty = ((minuty < 10) ? ("0" + minuty) : minuty);

                        cas.val(zobrazHodiny + ":" + zobrazMinuty);
                    } else {

                        if (hodiny >= 23) {
                            hodiny = 0;
                        } else {
                            hodiny++;
                        }
                        zobrazHodiny = ((hodiny < 10) ? "0" + hodiny : hodiny);
                        zobrazMinuty = ((minuty < 10) ? "0" + minuty : minuty);

                        cas.val(zobrazHodiny + ":" + zobrazMinuty);
                    }
                } else {
                    // scroll dol

                    if (event.shiftKey) {
                        if (minuty <= 0) {
                            if (hodiny <= 0) {
                                hodiny = 24;
                            }
                            hodiny--;
                            minuty = 50;
                        } else {
                            minuty-=10;
                        }
                        zobrazHodiny = ((hodiny < 10) ? "0" + hodiny : hodiny);
                        zobrazMinuty = ((minuty < 10) ? "0" + minuty : minuty);

                        cas.val(zobrazHodiny + ":" + zobrazMinuty);
                    } else {
                        if (hodiny <= 0) {
                            hodiny = 24;
                        }
                        hodiny--;

                        zobrazHodiny = ((hodiny < 10) ? "0" + hodiny : hodiny);
                        zobrazMinuty = ((minuty < 10) ? "0" + minuty : minuty);

                        cas.val(zobrazHodiny + ":" + zobrazMinuty);
                    }
                }
                $(cas).trigger("change");
            });
        });
    };

    /**
     * Po oznaen je mon ihned vloit datum (ztej) otoenm koleka
     */
    var pridaniDatumuPomociKolecka = function ()
    {
        var poleDatum = $('[name="pridaniTerminu"]');
        var datum = "";
        var dnesniDatum = "";

        poleDatum.bind('mousewheel DOMMouseScroll', function(event) {
            event.preventDefault();

            //Pokud je pole przdn tak vloit ztek
            if ($(this).val() !== "") {
                var from = $(this).val().split(".");
                datum = new Date(from[2], from[1] - 1, from[0]);
            } else {
                datum = new Date();
            }

            //Kolekem myi urm posun datumu
            if (event.originalEvent.wheelDelta > 0 || event.originalEvent.detail < 0) {

                //S shiftem inkrementovat msce
                if (event.shiftKey) {
                    datum.setMonth(datum.getMonth() + 1);
                    dnesniDatum = datum.getDate() + "." + (datum.getMonth() + 1) + "." + datum.getFullYear();
                    $(this).val(dnesniDatum);
                } else {
                    //Inkrementovat pouze dny
                    datum.setDate(datum.getDate() + 1);
                    dnesniDatum = datum.getDate() + "." + (datum.getMonth() + 1) + "." + datum.getFullYear();
                    $(this).val(dnesniDatum);
                }
            } else {
                //S shiftem odetat msce
                if (event.shiftKey) {
                    datum.setMonth(datum.getMonth() - 1);
                    dnesniDatum = datum.getDate() + "." + (datum.getMonth() + 1) + "." + datum.getFullYear();
                    $(this).val(dnesniDatum);
                } else {
                    //Odetat pouze dny
                    datum.setDate(datum.getDate() - 1);
                    dnesniDatum = datum.getDate() + "." + (datum.getMonth() + 1) + "." + datum.getFullYear();
                    $(this).val(dnesniDatum);
                }
            }
            $(this).trigger("change")
        })
    };

    /**
     * Pi dblclick na datum se nastav filter na aktuln datum a odele se
     */
    var vybraniPouzeDnesnihoDne = function () {
        var datum = $("[name='datumTerminu']");
        var filtrObdobi = $("[name='jenObdobiUcastiNaSkoleni']");
        var vyberpocetdnu = $("[name='vyberpocetdnu']");

        datum.on('dblclick', function () {
            var dt = new Date($.now());

            datum.val(dt.getDate() + "." + (dt.getMonth()+1) + "." + dt.getFullYear());
            filtrObdobi.val(2);
            vyberpocetdnu.val("1");
            this.form.submit();
        });
    };

    /**
     * Po oznaen je mon ihned vloit as 8:00 otoenm koleka (zvolen as monho zatku kolen)
     */
    var pridaniCasuPomociKolecka = function ()
    {
        var cas = $('[name="pridaniTerminu_time"]');
        var hodiny = 7;
        var minuty = 0;
        var zobrazHodiny = "";
        var zobrazMinuty = "";

        $(this).val( zobrazHodiny + ":" + zobrazMinuty);

        cas.on('mousewheel DOMMouseScroll', function(event){
            event.preventDefault();
            if (event.originalEvent.wheelDelta > 0 || event.originalEvent.detail < 0) {
                // scroll nahoru

                if (event.shiftKey) {
                    if (minuty >= 49) {
                        minuty = 0;
                    } else {
                        minuty+=10;
                    }
                    zobrazHodiny = ((hodiny < 10) ? "0" + hodiny : hodiny);
                    zobrazMinuty = ((minuty < 10) ? "0" + minuty : minuty);

                    $(this).val(zobrazHodiny + ":" + zobrazMinuty);
                } else {

                    if (hodiny >= 23) {
                        hodiny = 0;
                    } else {
                        hodiny++;
                    }
                    zobrazHodiny = ((hodiny < 10) ? "0" + hodiny : hodiny);
                    zobrazMinuty = ((minuty < 10) ? "0" + minuty : minuty);

                    $(this).val(zobrazHodiny + ":" + zobrazMinuty);
                }
            } else {
                // scroll dol

                if (event.shiftKey) {
                    if (minuty <= 0) {
                        hodiny--;
                        minuty = 50;
                    } else {
                        minuty-=10;
                    }
                    zobrazHodiny = ((hodiny < 10) ? "0" + hodiny : hodiny);
                    zobrazMinuty = ((minuty < 10) ? "0" + minuty : minuty);

                    $(this).val(zobrazHodiny + ":" + zobrazMinuty);
                } else {
                    if (hodiny <= 0) {
                        hodiny = 24;
                    }
                    hodiny--;

                    zobrazHodiny = ((hodiny < 10) ? "0" + hodiny : hodiny);
                    zobrazMinuty = ((minuty < 10) ? "0" + minuty : minuty);

                    $(this).val(zobrazHodiny + ":" + zobrazMinuty);
                }
            }
            $(this).trigger("change");
        });
    };

    //Pi click na odkaz se menu vysune
    var menuVytvoreniNovehoTerminu = function ()
    {
        var combo = $("[name='kodDlouhodobehoKurzu']").val();
        var menuNovyTermin = $('.vytvoritTerminSeznam');
        var vytvoritNovyTermin = $('#buttonNovyTermin');

        if(combo === ""){
            menuNovyTermin.hide();
            vytvoritNovyTermin.hide();
        }

        vytvoritNovyTermin.click(function () {
            if (!(menuNovyTermin.is(":visible"))){
                setTimeout(function () {
                    $('.vytvoritTerminSeznam').show("slow");
                }  , 600);
            } else {
                setTimeout(function () {
                    $('.vytvoritTerminSeznam').hide("slow");
                }  , 600);
            }
        });
    };

    /**
     * Kontrola asu
     */
    var testVyplneniPoliNovehoTerminu = function ()
    {
        var vytvoritNovyTerminBtn = $("#vytvoritNovyTerminBtn");
        var pridaniTerminu = $('#pridaniTerminu');
        var pridaniTerminu_time = $('#pridaniTerminuTime_1');
        var casOK = false;
        var datumOK = false;

        vytvoritNovyTerminBtn.hide();

        pridaniTerminu_time.on("keyup change", function () {
            casOK = false;

            //Military zapis 08:30,0830
            casOK = /^([01]\d|2[0-3]):?[0-5]\d$/.test(pridaniTerminu_time.val());
            if(!casOK){
                //Nejspornj zapis 8
                casOK = /^\d$/.test(pridaniTerminu_time.val());
            }

            if(casOK ){
                if (debugMode) {console.log("Je as v podku")}
            } else {
                if (debugMode) {console.log("Nen as v podku")}
            }

            if(testCasu(datumOK,casOK)){
                vytvoritNovyTerminBtn.show();
            } else {
                vytvoritNovyTerminBtn.hide();
            }
        });

        pridaniTerminu.on("keyup change", function () {
            datumOK = false;
            try {
                var dd = $.datepicker.parseDate("dd.mm.yy", pridaniTerminu.val());
                datumOK = true;
                if (debugMode) {console.log("Je datum v podku")}

            } catch (e){
                if (debugMode) {console.log("Nen datum v podku")}
            }

            if(testCasu(datumOK,casOK)){
                vytvoritNovyTerminBtn.show();
            } else {
                vytvoritNovyTerminBtn.hide();
            }
        });
    };

    /**
     * Kontrola na zmnu v checkboxu, textarea
     */
    var kontrolaVsechFormularuNaZmenu = function ()
    {
        pridaniCasu($('.editaceCasuTerminu'));

        var names = [];
        $("form").each(function() {
            names.push(this.id);
        });

        $.each(names, function (index) {
            var name = names[index];
            var timestamp = (name.split('_')[1] !== undefined ? name.split('_')[1] : "");
            var formular = $('#'+name);


            //Pi resetu, ve nastavuji do pvodnho stavu - submit se znepstupuje
            formular.on('reset', function() {
                formular.data('changed', false);
                $('input[name="filtr_pritomnych"][value="0"]').click();
            });

            formular.find($('#pritomenNaTerminuAll_' + timestamp)).click(function () {
                //Kdykoliv dojde k njak zmn..nastav pznak
                formular.data('changed', true);
                $('[id$="_pritomenNaTerminu_'+ timestamp + '"]').prop('checked', this.checked);
            });

            formular.find($('#omluvenaUcastAll_' + timestamp)).click(function () {
                formular.data('changed', true);
                $('[id$="_omluvenaUcast_'+ timestamp + '"]').prop('checked', this.checked);
            });

            formular.find($("[id*='_pritomenNaTerminu_']")).change(function () {
                formular.data('changed', true);
            });

            formular.find($("[id*='_omluvenaUcast_']")).change(function () {
                formular.data('changed', true);
            });

            formular.find($("[id*='_poznamkaKUchazeci_']")).on('change keyup paste', function () {
                formular.data('changed', true);
            });

            formular.find($("[id*='poznamkaKUchazeci_']")).on('change keyup paste', function () {
                formular.data('changed', true);
            });

            formular.find($("[id*='editaceCasuTerminu_']")).on('change keyup paste', function () {
                formular.data('changed', true);
            });

            //Koprovn obsahu textarea do ostatnch przdnch
            formular.find($('[id*="_copyPoznamkyKUchazeci_'+ timestamp + '"]')).click(function () {
                var id = (this.id.split('_')[0] !== undefined ? this.id.split('_')[0] : "");
                var copyTextarea= ($('[id="' + id + '_poznamkaKUchazeci_'+ timestamp + '"]')).text();
                var textarea = $('[id$="_poznamkaKUchazeci_'+ timestamp + '"]');

                //Kopruje se pouze do textarea s :visible
                $('textarea:visible').each(function () {
                    if(!$(this).val()){
                        $(this).val(copyTextarea);
                    }
                });
                formular.data('changed', true);
            });

            //Radio zobrazit Vechny / Ptomn / neptomn
            formular.find($('[id$="filtr_pritomnych_'+ timestamp + '"]')).change(function ()
            {
                var filtrZobrazeni = $('[id$="filtr_pritomnych_'+ timestamp + '"]:checked').val();

                var radkySUcastniky = '';
                var licheRadkySUcastniky = '';
                var sudeRadkySUcastniky = '';

                //Radio zobrazit Vechny
                if(filtrZobrazeni === "0"){
                    $(".pritomni").show();
                    $(".nepritomni").show();

                    //Obarven sudch / lichch dle aktulnho zobrazen
                    radkySUcastniky = formular.find($(".radekTabulky:visible"));
                    licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                    sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                    radkySUcastniky.removeClass("licheRadky");
                    radkySUcastniky.removeClass("sudeRadky");
                    licheRadkySUcastniky.addClass("licheRadky");
                    sudeRadkySUcastniky.addClass("sudeRadky");
                }

                //Radio zobrazit Ptomn
                if(filtrZobrazeni === "1"){
                    $(".nepritomni").hide();
                    $(".pritomni").show();

                    //Obarven sudch / lichch dle aktulnho zobrazen
                    radkySUcastniky = formular.find($(".radekTabulky:visible"));
                    licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                    sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                    radkySUcastniky.removeClass("licheRadky");
                    radkySUcastniky.removeClass("sudeRadky");
                    licheRadkySUcastniky.addClass("licheRadky");
                    sudeRadkySUcastniky.addClass("sudeRadky");
                }

                //Radio zobrazit Neptomn
                if(filtrZobrazeni === "2"){
                    $(".pritomni").hide();
                    $(".nepritomni").show();

                    //Obarven sudch / lichch dle aktulnho zobrazen
                    radkySUcastniky = formular.find($(".radekTabulky:visible"));
                    licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                    sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                    radkySUcastniky.removeClass("licheRadky");
                    radkySUcastniky.removeClass("sudeRadky");
                    licheRadkySUcastniky.addClass("licheRadky");
                    sudeRadkySUcastniky.addClass("sudeRadky");
                }
            });
        })
    };


    var testCasu = function (datum, cas)
    {
        if(datum && cas){
            return true;
        }
    };

    /**
     * Vycentrovni okna na sted
     * @param timestamp
     * @param kontejner
     * @returns {[*,*,*,*]}
     */
    var poziceOkna = function (kontejner) {
        var maskHeight = $(window).height();
        var maskWidth = $(window).width();

        // Vpoet hodnot pro zarovnn na "sted"
        // var dialogTop =  (maskHeight/2.5)  - $(kontejner).height()/1.2;
        var dialogTop =  20;
        var dialogLeft = (maskWidth/2.5)- $(kontejner).width()/2;

        return [maskHeight, maskWidth ,dialogTop, dialogLeft ];
    };

    /**
     * Piazen tlatek s pslunm dialogem ASTI
     */
    var svazaniDialoguUcastiSTlacitkem = function () {

        var buttonNames = [];
        $("[id^='buttonProDialog_']").each(function() {
            buttonNames.push(this.id);
        });

        var stornoButtonNames = [];
        $("[id^='tlacitkoStorno_']").each(function() {
            stornoButtonNames.push(this.id);
        });

        //Svzan zobrazen dialogu s tlatkem
        $.each(buttonNames, function (index) {
            var name = buttonNames[index];
            var timestamp = (name.split('_')[1] !== undefined ? name.split('_')[1] : "");
            var button = $('#'+name);
            var potah = ($('[id="dialog-overlay_'+ timestamp + '"]'));
            var kontejner = ($('[id="dialog-box_'+ timestamp + '"]'));

            button.on('click', function ()
            {
                var timestampTlacitka = (document.activeElement.id.split('_')[1] !== undefined ? document.activeElement.id.split('_')[1] : "");
                aktualniStorno = $("#tlacitkoStorno_"+timestampTlacitka);

                var nalezenaPozice = poziceOkna(kontejner);
                var maskHeight = nalezenaPozice[0];
                var maskWidth = nalezenaPozice[1];
                var dialogTop = nalezenaPozice[2];
                var dialogLeft = nalezenaPozice[3];

                $(potah).css({height:maskHeight+$(window).scrollTop(), width:maskWidth});
                $(kontejner).css({top:dialogTop + $(window).scrollTop(), left:dialogLeft});

                $(potah).show();
                $(kontejner).animate({height: 'toggle'},500, 'linear');
                $(kontejner).focus();

                //Disable mouse scroll pro pozad
                $('body').addClass('disable_scroll');
                $('html').keypress(function(e){
                    if($('body').hasClass('disable_scroll') &&(e.keyCode === 38 || e.keyCode === 40)){
                       return false;
                    }
                });
            });
        });

        //Svzan skryt dialogu se storno tlatkem
        $.each(stornoButtonNames, function (index) {
            var name = stornoButtonNames[index];
            var timestamp = (name.split('_')[1] !== undefined ? name.split('_')[1] : "");
            var button = $('#'+name);
            var potah = ($('[id="dialog-overlay_'+ timestamp + '"]'));
            var kontejner = ($('[id="dialog-box_'+ timestamp + '"]'));

            button.on('click', function (e) {
                //Pokud dolo ke zmn a uivatel se rozhodl odejt pak se dotzat
                if($(this).closest('form').data('changed')){
                    var question = ron.translate('zaznam_upraveny');
                    if(!ron.confirm(question)){
                        e.stopPropagation();
                        return false;
                    } else {
                        //Odstrann znaky zmny a nsledn reset formule
                        $(this).closest('form').data('changed', false);
                        //Reset formule
                        $(this).closest('form')[0].reset();

                        $(kontejner).hide("slow");

                        setTimeout(function () {
                            $('input[name="filtr_pritomnych"][value="0"]').click();
                            $(potah).hide();
                            $('body').removeClass('disable_scroll');
                            aktualniStorno = undefined;
                            $(window).unbind('beforeunload');
                        }, 500);
                    }
                } else {
                    $(kontejner).hide("slow");
                    $('input[name="filtr_pritomnych"][value="0"]').click();

                    setTimeout(function () {
                        $(potah).hide();
                        $('body').removeClass('disable_scroll');
                        aktualniStorno = undefined;
                        $(window).unbind('beforeunload');
                    }, 500);
                }
            });
        })
    };

    /**
     * Vpoet pozice dialogu s posunem pro dialog editace (asu a poznmky)
     * @param timestamp
     * @param kontejner
     * @returns {[*,*,*,*]}
     */
    var poziceOknaEditace = function (kontejner) {
        var maskHeight = $(document).height();
        var maskWidth = $(window).width();

        // Vpoet hodnot pro zarovnn na "sted"
        var dialogTop =  (maskHeight/3.3)  - $(kontejner).height() /1.2;
        var dialogLeft = (maskWidth/2.7) - $(kontejner).width()/2;

        return [maskHeight, maskWidth ,dialogTop, dialogLeft ];
    };

    /**
     * Piazen tlatek s pslunm dialogem EDITACE
     */
    var svazaniDialoguEditaceTerminuSTlacitkem = function ()
    {
        var buttonNames = [];
        $("[id^='buttonProDialog-edit_']").each(function() {
            buttonNames.push(this.id);
        });

        var stornoButtonNames = [];
        $("[id^='tlacitkoStorno-edit_']").each(function() {
            stornoButtonNames.push(this.id);
        });

        $.each(buttonNames, function (index) {
            var name = buttonNames[index];
            var timestamp = (name.split('_')[1] !== undefined ? name.split('_')[1] : "");
            var button = $('#'+name);
            var potah = ($('[id="dialog-overlay-edit_'+ timestamp + '"]'));
            var kontejner = ($('[id="dialog-box-edit_'+ timestamp + '"]'));

            //Svzan zobrazen dialogu s tlatkem
            button.on('click', function () {
                var timestampTlacitka = (document.activeElement.id.split('_')[1] !== undefined ? document.activeElement.id.split('_')[1] : "");
                aktualniStorno = $("#tlacitkoStorno-edit_"+timestampTlacitka);

                var nalezenaPozice = poziceOknaEditace(kontejner);
                var maskHeight = nalezenaPozice[0];
                var maskWidth = nalezenaPozice[1];
                var dialogTop = nalezenaPozice[2]/3;
                var dialogLeft = nalezenaPozice[3];

                $(potah).css({height:maskHeight+$(window).scrollTop(), width:maskWidth});
                $(kontejner).css({top:dialogTop + $(window).scrollTop(), left:dialogLeft});

                //Disable mouse scroll
                $('body').addClass('disable_scroll');
                $('html').keypress(function(e){
                    if($('body').hasClass('disable_scroll') &&(e.keyCode === 38 || e.keyCode === 40)){
                       return false;
                    }
                });

                $(potah).show();
                $(kontejner).animate({height: 'toggle'},500, 'linear');
                $(kontejner).focus();
            });
        });

        //Svzan skryt dialogu se storno tlatkem
        $.each(stornoButtonNames, function (index)
        {
            var name = stornoButtonNames[index];
            var timestamp = (name.split('_')[1] !== undefined ? name.split('_')[1] : "");
            var button = $('#'+name);
            var potah = ($('[id="dialog-overlay-edit_'+ timestamp + '"]'));
            var kontejner = ($('[id="dialog-box-edit_'+ timestamp + '"]'));

            button.on('click keyup', function ()
            {
                //Pokud dolo ke zmn a uivatel se rozhodl odejt pak se dotzat
                if($(this).closest('form').data('changed')){
                    var question = ron.translate('zaznam_upraveny');
                    if(!ron.confirm(question)){
                        return false;
                    }
                    //Odstrann znaky zmny
                    $(this).closest('form').data('changed', false);
                    //Reset formule
                    $(this).closest('form')[0].reset();
                    //Uvolnit mouse scroll
                    $('body').removeClass('disable_scroll');
                    aktualniStorno = undefined;
                }

                $(kontejner).hide("fast");
                setTimeout(function () {
                    $(potah).hide("fast");
                    //Uvolnit mouse scroll
                    $('body').removeClass('disable_scroll');
                    aktualniStorno = undefined;
                }, 500);

            });
        })
    };

    /**
     * Pidn informace v procentech jako sloupec v browseru
     */
    var informaceVBrowseruNaUcastVProcentech = function ()
    {
        var hodnotaUcastiNaSkoleniNames = [];
        $("[id^='hodnotaUcastiNaSkoleni_']").each(function() {
            hodnotaUcastiNaSkoleniNames.push(this.id);
        });

         var hodnotaNeucastiNaSkoleniNames = [];
        $("[id^='hodnotaNeucastiNaSkoleni_']").each(function() {
            hodnotaNeucastiNaSkoleniNames.push(this.id);
        });

        $.each(hodnotaUcastiNaSkoleniNames, function (index) {
            var ucastNaTerminu = hodnotaUcastiNaSkoleniNames[index];
            var timestamp = (ucastNaTerminu.split('_')[1] !== undefined ? ucastNaTerminu.split('_')[1] : "");

            var hodnotaUcastiVBrowseru = ($('[id="hodnotaUcastiNaSkoleni_'+ timestamp + '"]'));
            var hodnotaNeucastiVBrowseru = ($('[id="hodnotaNeucastiNaSkoleni_'+ timestamp + '"]'));

            var ucastZaznamenana = ($('[id="info_vlozenaUcast_'+ timestamp + '"]'));

            var sloupecUcastiVBrowseru = ($('[id="sloupecUcasti_'+ timestamp + '"]'));
            var sloupecNeucastiVBrowseru = ($('[id="sloupecNeucasti_'+ timestamp + '"]'));
            var ucast = "";

            //Pro rychlej orientaci - informace o tom, kde lektor zapsal ast a kde nebyla provedena dn prava /udlat pes sql pokud bude zjem
            if((hodnotaUcastiVBrowseru.val() + hodnotaNeucastiVBrowseru.val() ) > 0){
                ucast = ron.translate('Str_Yes');
                ucastZaznamenana.text(ucast);
            } else {
                ucast = ron.translate('Str_No');
                ucastZaznamenana.css("font-size", "98%");
                ucastZaznamenana.text(ucast);
            }
            sloupecUcastiVBrowseru.text(hodnotaUcastiVBrowseru.val() + "%");
            sloupecNeucastiVBrowseru.text(hodnotaNeucastiVBrowseru.val() + "%");
        });
    };


    /** Zven tolerance checkboxu na nejbli TD - zmn jeho stav (problem byl se trefovat pi zmn vce za sebou) */
    var vetsiPlochaAktivaceCheckBoxu = function ()
    {
        var oblastCheckboxu = $("td.oblastCheckboxu");
        oblastCheckboxu.on('click', function(e) {
            var chk = $(this).find("input:checkbox").get(0);
            if(e.target !== chk){
                // chk.checked = !(chk.checked);
                //Zkrcenina za  if
                chk.checked = chk.checked === false;
                //Dolo ke zmn proto nastavit pznak "change" na formuli
                $(this).closest('form').data('changed', true);
            }
        });

        //pokud by byla poteba rychl zmny vce checkboxu najednou
        oblastCheckboxu.on('mouseenter', function(e) {
            var chk = $(this).find("input:checkbox").get(0);
            if(e.target !== chk){
                if(e.ctrlKey){
                    chk.checked = chk.checked === false;
                    //Dolo ke zmn proto nastavit pznak "change" na formuli
                    $(this).closest('form').data('changed', true);
                }
            }
        });
    };


    /**
     * Po stisku ESC pmo uktivuje sprvn storno.
     */
    var obsluhaESC = function () {
        //Na Esc skrt dialog
        $(document).keyup(function(e) {
            if (e.keyCode === 27) {
                aktualniStorno.trigger('click');
                aktualniStorno = undefined;
                console.log(aktualniStorno);
                // e.stopPropagation();
            }
        });
    };

    /**
     * Pokud je zvoleno obdob [aktuln msc, aktuln tvrtlet, aktuln pololet] pak se automaticky mn i radio na toto nastaven
     */
    var volbaAktualnihoObdobi = function () {
        // var comboAktualnihoObdobi = $("[name='jenObdobiUcastiNaSkoleni']:checked").val();
        var comboAktualnihoObdobi = $("[name='aktualniObdobiUcastiNaSkoleni']");
        var radioAktualnihoObdobi = $("[name='jenObdobiUcastiNaSkoleni']");

        comboAktualnihoObdobi.on('change', function () {
            radioAktualnihoObdobi.val(1);
            this.form.submit();
        });
    };

    var otestujPole = function () {
        var navrat = 1;
        var zprava = "";
        $(".nonempty").each(function ()
        {
            // oeteni formule na przdn hodnoty povinnch pol
            if ($(this).val().trim() === "") {
                $(this).addClass("app_input_error");
                zprava += " - " + $(this).attr('title') + "\n";
                navrat = 0;
            } else {
                $(this).removeClass("app_input_error");
            }
        });
        if(navrat === 0){
            alert(ron.translate('doplnte_chybejici_pole') + "\n" + zprava);
        }

        return navrat;
    };

    var kontrolaVyplneniPoli = function () {

        $("form").submit(function(e){
            if(!otestujPole()){
                e.preventDefault();
            }
        });
    };


    var akceTlacitkaZpet = function () {
        var tlacitkoZpetPlanovaneho = $('#back_url_planovani_skoleni');

        tlacitkoZpetPlanovaneho.on('click', function () {
            window.location.href = '?menuid=skoleni&action=planovaneskolenikurzy'
        })
    };



    $(document).ready(function () {
        testVyplneniPoliNovehoTerminu();
        menuVytvoreniNovehoTerminu();
        vybraniPouzeDnesnihoDne();
        volbaAktualnihoObdobi();
        pridaniCasuPomociKolecka();
        pridaniDatumuPomociKolecka();
        kontrolaVsechFormularuNaZmenu();
        svazaniDialoguUcastiSTlacitkem();
        svazaniDialoguEditaceTerminuSTlacitkem();
        informaceVBrowseruNaUcastVProcentech();
        vetsiPlochaAktivaceCheckBoxu();
        obsluhaESC();
        kontrolaVyplneniPoli();
        akceTlacitkaZpet();


        //Pokud resize() tak zavt dialog
        $(window).resize(function() {
            if(aktualniStorno){
                aktualniStorno.trigger('click');
            }
        });
    });
})();
