
ron.ZastupPlanKapacit = function() {
    this.existujeplan = false;
    this.smena = '';
    this.rozdeleni = '';
};

ron.zastup = { };

ron.zastup = {
        hromadneSchvaleni : {
            zobrazHromadne : function () {
                window.location= '?menuid=zastup&schvalovani=1';
            },
            
            init : function (dataSchvalovani) {
                var oznacRadekZastupu = function(index) {
                    var selected = false;

                    if (/*!selected  &&*/  dataSchvalovani.items[index].pravo) {
                        if ( $("#Schvaleni_" + dataSchvalovani.items[index].id).checked != !!dataSchvalovani.items[index].schvaleno ) selected = true;
                    }


                    $("#zastup_row_" + dataSchvalovani.items[index].id).toggleClass("browserselectedrow", selected);
                };


                var schvaleniCheckboxClick = function() {
                    var index = $(this).data("ronschvalenizastupu_index");
                    if (index === undefined) return;

                    oznacRadekZastupu(index);
                };
                var oznacVsechnyZastupy = function (value) {
                    for (var i = 0;  i < dataSchvalovani.items.length;  i++) {
                        var jePravo = false;
                        var checkboxId = null;

                        var originalValue = null;

                        jePravo = dataSchvalovani.items[i].pravo;
                        checkboxId = 'Schvaleni_' + dataSchvalovani.items[i].id;
                        originalValue = dataSchvalovani.items[i].schvaleno;

                        if (jePravo && checkboxId) {
                            var newvalue = !!( value < 0 ? originalValue : value);
                            if ( document.getElementById(checkboxId).checked != newvalue ) {
                                document.getElementById(checkboxId).checked = newvalue;
                                oznacRadekZastupu(i);
                            }
                        }
                    }
                };


                var schvaleniZastupuMenu = function($sender) {
                    var $menu = $("#schvaleniZastupuMenu");

                    $menu
                        .off("click", "li")
                        .on("click", "li", function() {
                            oznacVsechnyZastupy( $(this).data("ron-hodnotaschvaleni") );
                        });

                    ron.showPopupMenu($menu, { attachToElement: $sender } );

                    return false; // stop event propagation
                };


                $("#schvaleniZastupuMenu_Header")
                    .on("click", function() { schvaleniZastupuMenu($(this)); return false;} );

                $("#schvaleni_ALL")
                    .on("click", function() { oznacVsechnyZastupy($(this).prop("checked")); });

                $("#seznamzastupu")
                    .on("click", "input", schvaleniCheckboxClick);

                $("#stornoHromadneSchvaleniZastupu")
                    .on("click", function() { window.location = '?menuid=zastup'; } );

                $("#provestHromadneSchvaleniZastupu")
                    .on("click", function() {
                        ron.showWorkingInfo();
                        this.form.submit();
                    } );
                
            }
        },

        formular : {
            idZvoleneOsoby : function () {
                var idPP = 0;
                var preferovanyPP = 0;
                var vybranyPP = 0;

                var osobaCombo = $('#zastup_osoba2').find('select');
                if ($(osobaCombo).length == 0) {
                    osobaCombo = $('#row_osoba').find('select');
                }

                var preferovanaOsobaCombo = $('#zastup_osoba1').find('select');

                if ($(preferovanaOsobaCombo).length != 0) {
                    preferovanyPP = $(preferovanaOsobaCombo).val();
                    idPP = parseInt(preferovanyPP);
                }
                else { // if ($(osobaCombo).is(':visible')) { - upraveno 2021-06 - ronselect neni nikdy visible
                    vybranyPP = $(osobaCombo).val();
                    idPP = parseInt(vybranyPP);
                }

                return idPP;
            },

            overPlanovaniKapacit : function (event) {

                var idZvolenehoPP = ron.zastup.formular.idZvoleneOsoby();
                var planZamestnance = {};
                var zjistiPlan = function () {
                    $.ajax(
                        {
                            async: false,
                            url: "?menuid=zastup&action=kontrolaplanu",
                            type: "GET",
                            data: {
                                idpp: idZvolenehoPP,
                                datum: parseInt($('input[name=DatumZastupu]').val())
                            }
                        }).done(function (responseData) {

                            planZamestnance.existujeplan = responseData.existujeplan;
                            planZamestnance.smena = responseData.smena;
                            planZamestnance.rozdeleni = responseData.rozdeleni;
                    }).fail(function (jqXHR) {
                        ron.showAjaxError(jqXHR, "Pri kontrole planovani kapacit doslo k chybe!");
                    });
                };
                var potvrditPrepsaniPlanu = function (data) {
                    if (data.existujeplan) {
                        var question = ron.translate('Zastup_existuje_plan');

                        if (data.smena !== '') {
                            question += ron.translate('Zastup_existuje_smena') + data.smena;
                            if (data.rozdeleni !== '') {
                                question += ', ';
                            }
                        }

                        if (data.rozdeleni !== '') {
                            question += ron.translate('Zastup_existuje_rozdeleni') + data.rozdeleni;
                        }

                        question += ron.translate('Zastup_pokracovat');

                        if (!ron.confirm(question)) {
                            return false;
                        }
                    }

                    return true;
                };

                if (idZvolenehoPP !== 0) {
                    zjistiPlan();
                    return potvrditPrepsaniPlanu(planZamestnance);
                }

            }
        }
    };

$( function() {
    $("#zastup_kalendar_link").on('click',function () {
        var idPP = ron.zastup.formular.idZvoleneOsoby();

        if (idPP != 0) {
            $(this).attr('href',$(this).data('ronlink') + idPP);
        }
    });

    $('#zastup_osoba1').on('change','select', function () {
        if (this.value == '') {
            $("#zastup_osoba2").show();
        } else {
            $("#zastup_osoba2").hide();
        }
    });

    $('form:has(input[value=ZadostOZastup])').on('click','.submitbutton', ron.zastup.formular.overPlanovaniKapacit);
});

  
