<?php
/**
 * UTF8
 * stanislav.elbl, 16.10.2014
 */

namespace Ron\RonPortal;

use Ron\StringUtils;

/** @var $this SluzebniCesta */

$mistostr = $this ->cilPopis;
if ($mistostr && $this ->popisCile) $mistostr .= ' - ';
$mistostr .= $this ->popisCile;

?>
<div class='form large-form<?php if ($this ->zahranicni) echo ' zahranicniSC'; ?>' id='hlavickasluzebnicesty zkracenahlavickasc'>
    <div class="form-content">
        <div class="row" id="hlavickasc_osoba">
            <div class="col col-2"></div>
            <div class="col col-7 font-weight-bold">
                <strong><?= $this ->f_PP ->jmenoPrijmeni ?></strong>, <?= \Ron\ronText('Osobni_cislo') . ' ' . StringUtils::htmlTextConvert($this ->f_PP ->osobniCislo) ?>
            </div>
            <div class="col col-3 align-right">
                <?php if ($this ->zahranicni) {?><span id="hlavickasc_zahranicni"><?= \Ron\ronText('Zahranicni') ?> (<?= $this ->cilovyStatPopis ?>)</span>  <?php } ?>
            </div>
        </div>

        <div class="row" id="hlavickasc_datum">
            <div class="col col-2 caption"><?= \Ron\ronText('Date') ?></div>
            <div class="col col-10"><?= date('j.n.Y G:i', $this ->datumCasOd) . ' - ' . date('j.n.Y G:i', $this ->datumCasDo) ?></div>
        </div>

        <?php if ($mistostr) { ?>
        <div class="row" id="hlavickasc_cil">
            <div class="col col-2 caption"><?= \Ron\ronText('Cil_sc') ?></div>
            <div class="col col-10"><?= StringUtils::htmlTextConvert($mistostr) ?></div>
        </div>
        <?php } ?>
    </div>
</div>
