<?php
/**
 * stanislav.elbl, 10.07.2015
 */

global $appDate;
global $appVersion;
global $copyrightYear;

?>
<!doctype html>
<html>
<head>
    <?php
    require('ron/apphead.php');
    require('view/apphead.php');
    if ( \Ron\Http\App::getDebugMode() ) {
        \Ron\Http\HttpResponse::getInstance() ->getHeaders() ->renderDebugScript();
    }
    ?>
</head>
<body>
<div class="pagecontent nolog">
    <!-- hlavicka, aplikace, jazyk -->
    <?php
        require('view/apptitle.php');
        //require('adsapp/topmenu.php');
    ?>

    <div class="container">
        <div class="appcontent">
            <!-- obsah -->
            <?php
            if (\Ron\MVC\Model::getInstance() ->getViewObjects()) {
                foreach (\Ron\MVC\Model::getInstance() ->getViewObjects() as $viewObject) {
                    $viewObject ->render();
                }
            }
            ?>
        </div>
    </div>


    <!-- paticka -->
    <div class="footer">
        <div class="copyright">
            &copy; <span class="desktop-only">2003-<?= $copyrightYear ?>, <?= \Ron\StringUtils::fromUTF8('Všechna práva vyhrazena') ?>, </span><a href="http://www.ron.cz">RON Software</a>, s.r.o.
        </div>

        <div id="nojs"><a href="script/nojs.html"><?= \Ron\ronText('Adblock_nebo_vypnuty_javascript') ?></a></div>

        <div class='version' title='<?= $appDate ?>'><a href='verze.php' target='_blank'> <?= $appVersion ?></a></div>
    </div>

</div>
</body>
</html>
