<?php
/**
 * UTF8
 * stanislav.elbl, 26.05.2017
 */

namespace Ron\RonPortal\XML;


use Ron\MessageManager;
use Ron\MVC\Redirect;
use Ron\RonPortal\Log;
use Ron\RonPortal\Prava;
use Ron\RonPortal\User;
use Ron\StringUtils;


class XMLFormElementSimpleCommand extends XMLFormElementCommand
{
    public function doCommand()
    {
        switch ($this->elementName) {
            case 'exit' :
                $this->xmlForm->exit = true;
                break;

            case 'mapovanimenu' :
                $this->xmlForm->f_mapovanimenu_pokracovat = self::getBoolValue($this->getAttributeValue('pokracovat'));
                $this->xmlForm->f_mapovanimenu_newmenuid = $this->getAttributeValue('menuid');
                break;
        }
    }
}



class XMLFormElementDelete extends XMLFormElementCommand
{
    function doCommand()
    {
        if ($this ->xmlForm ->readOnly) {
            return;
        }

        $okinfomsg = StringUtils::fromUTF8($this ->getAttributeValue('okinfomsg'));
        $this ->xmlForm ->delete($okinfomsg);
        $this ->xmlForm ->exit = true;
    }
}


