<?php
/**
 * UTF8
 * stanislav.elbl, 09.10.2018
 */

namespace Ron\RonPortal\XML;

require_once 'xml/xml_commands.php';

/**
 * Class XMLFormElementViewFile
 * @package Ron\RonPortal\XML
 */
class XMLFormElementViewFile extends XMLFormElementCommand
{
    function doCommand()
    {
        $fileName = $this ->getAttributeValue('filename');

        if (!$fileName) {
            $fileName = $this ->getBoolAttribute('frame')
                ? 'view/appview_frame.php'
                : 'view/appview.php';
        }

        $this ->xmlForm ->viewFileName = $fileName;
    }
}
